#ifdef ZDOOM_GL

//#define __DOOMTYPE__

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <windows.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "gl_struct.h"
#include "gl_mem.h"
#include "gl_priv.h"
#ifndef GL_HEXEN
#include "doomdef.h"
#else
#include "h2def.h"
#endif
#include "r_local.h"

#include "p_spec.h"

#include "i_system.h"

#include "p_local.h"

// From p_local.h
#define NUMREDPALS		8
#define NUMBONUSPALS	4

int g_iCorona;
extern int g_iParticle;

extern	int	usegamma;
extern int consoleplayer;
extern float cosA,sinA;
float g_fRed=0.0f,g_fPal=0.0f,g_fGreen=0.0f,g_fBlue=0.0f;
// DarkFang
/*#define MAX_LIGHT_SOURCES	20
GLDynamicLight a_stGLLight[MAX_LIGHT_SOURCES];
int iGLNbLightSources;
float fLightUpF[MAX_LIGHT_SOURCES],fLightDownF[MAX_LIGHT_SOURCES],fLightLeftF[MAX_LIGHT_SOURCES],fLightRightF[MAX_LIGHT_SOURCES];
float fLightUpC[MAX_LIGHT_SOURCES],fLightDownC[MAX_LIGHT_SOURCES],fLightLeftC[MAX_LIGHT_SOURCES],fLightRightC[MAX_LIGHT_SOURCES];*/
// End DarkFang

GLDynamicLight a_stGLLight[MAX_LIGHT_SOURCES];
int iGLNbLightSources;
float fLightUpF[MAX_LIGHT_SOURCES],fLightDownF[MAX_LIGHT_SOURCES],fLightLeftF[MAX_LIGHT_SOURCES],fLightRightF[MAX_LIGHT_SOURCES];
float fLightUpC[MAX_LIGHT_SOURCES],fLightDownC[MAX_LIGHT_SOURCES],fLightLeftC[MAX_LIGHT_SOURCES],fLightRightC[MAX_LIGHT_SOURCES];

H_boolean g_bLightEffects;

/*void GL_PaletteFlash()
{ player_t *CPlayer;
  int palette;
  int		cnt;
  int		bzc;

	CPlayer = &players[consoleplayer];

    cnt = CPlayer->damagecount;

#ifdef DOOM
    if (CPlayer->powers[pw_strength])
    {
	// slowly fade the berzerk out
  	bzc = 12 - (CPlayer->powers[pw_strength]>>6);

	if (bzc > cnt)
	    cnt = bzc;
    }
#endif	
    if (cnt)
	//if(CPlayer->damagecount)
	{
		//palette = (CPlayer->damagecount+7)>>3;
		palette = (cnt+7)>>3;
		if(palette >= NUMREDPALS)
		{
			palette = NUMREDPALS-1;
		}
		g_fRed=palette*0.2f;
	}
	else if(CPlayer->bonuscount)
	{
		palette = (CPlayer->bonuscount+7)>>3;
		if(palette >= NUMBONUSPALS)
		{
			palette = NUMBONUSPALS-1;
		}
		g_fPal=palette*0.2f;
	}
#ifdef DOOM
    else if ( CPlayer->powers[pw_ironfeet] > 4*32
	      || CPlayer->powers[pw_ironfeet]&8)
		g_fGreen=0.5f;
#endif
#ifdef GL_HEXEN
	else if (CPlayer->poisoncount)
		{
			palette = 0;
			palette = (CPlayer->poisoncount+7)>>3;
			if(palette >= NUMPOISONPALS)
			{
				palette = NUMPOISONPALS-1;
			}
			//palette += STARTPOISONPALS;
			g_fGreen=palette*0.2f;
		}
		else if(CPlayer->mo->flags2&MF2_ICEDAMAGE)
		{ // Frozen player
			//palette = STARTICEPAL;
			g_fBlue=0.6f;
		}
#endif
    else
	{
		g_fRed = g_fPal = g_fGreen = 0.0f;
	}
}*/

#ifdef DOOM_GL
#define INVERSECOLORMAP		32
#endif

void GL_StaticLight3f(GLfloat fRed,GLfloat fGreen,GLfloat fBlue)
{ float fGamma=/*usegamma*0.12f+*/g_fPal;
#ifndef DOOM_GL
  float fColor;
#endif
  player_t *player;
#if 0	// test light
  float color[4];

	/*color[0]=fRed+fGamma+g_fRed;
	color[0]=fGreen+fGamma-g_fRed;
	color[0]=fBlue+fGamma-g_fRed;*/
	color[0]=1.0f;
	color[0]=1.0f;
	color[0]=1.0f;
	color[0]=1.0f;
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,color);
    /*fRed/=2.0f;
	fGreen/=2.0f;
	fBlue/=2.0f;*/
#else	// 1
	player = &players[consoleplayer];
	if (player->fixedcolormap == INVERSECOLORMAP)
		//glColor3f(fRed+fGamma+g_fRed+0.2f,fGreen+fGamma-g_fRed+0.2f,fBlue+fGamma-g_fRed-0.5f);
		glColor3f(1.0f,1.0f,0.0f);
	else
	if (player->fixedcolormap)
		glColor3f(1.0f,1.0f,1.0f);
	else
		glColor3f(fRed/*+fGamma+g_fRed-g_fGreen*/,fGreen/*+fGamma-g_fRed+g_fGreen*/,fBlue/*+fGamma-g_fRed-g_fGreen*/);
#endif	// 1
}

void GL_StaticLight4f(GLfloat fRed,GLfloat fGreen,GLfloat fBlue,GLfloat fAlpha)
{ float fGamma=/*usegamma*0.12f+*/g_fPal;
  player_t *player;

	player = &players[consoleplayer];
	if (player->fixedcolormap == INVERSECOLORMAP)
		//glColor3f(fRed+fGamma+g_fRed+0.2f,fGreen+fGamma-g_fRed+0.2f,fBlue+fGamma-g_fRed-0.5f);
		glColor4f(1.0f,1.0f,0.0f,fAlpha);
	else
	if (player->fixedcolormap)
		glColor4f(1.0f,1.0f,1.0f,fAlpha);
	else
		glColor4f(fRed/*+fGamma+g_fRed-g_fGreen*/,fGreen/*+fGamma-g_fRed+g_fGreen*/,fBlue/*+fGamma-g_fRed-g_fGreen*/,fAlpha);
}

// ---------------------------------------------------------------------------------
// DYNAMIC LIGHTING
// ---------------------------------------------------------------------------------
extern GLboolean g_bLightRaster;
extern LARGE_INTEGER PerformanceCountStart,PerformanceCountEnd;
extern LARGE_INTEGER LightPerf;	// MR1907
GLdynamic_prop *g_p_stLightProp;

// DarkFang
/*#ifdef DOOM_GL
#define NUMBER_OF_DYNAMIC_LIGHT_SOURCES 20

GLdynamic_prop dynamic_mobjlight[NUMBER_OF_DYNAMIC_LIGHT_SOURCES] = 
{
	{ MT_BRUISERSHOT,   0.43f, 1.0f, 0.43f, 0.0f, 0.9f, UPDATE_FALSE		},
	{ MT_PUFF,			 0.0f, 0.4f,  1.0f, 0.0f, 0.6f, UPDATE_FALSE		},
	{ MT_ARACHPLAZ,		 0.5f, 1.0f,  0.2f, 0.0f, 0.8f, UPDATE_FALSE		},
	{ MT_BFG,			 0.1f, 1.0f,  0.1f, 0.0f, 2.0f, UPDATE_FALSE		},
	{ MT_FATSHOT,		 0.8f,0.45f, 0.15f, 0.0f, 1.0f, UPDATE_FALSE		},
	{ MT_ROCKET,		 1.0f, 0.9f,  0.1f, 0.0f, 1.0f, UPDATE_FALSE		},
	{ MT_PLASMA,		0.45f,0.66f, 0.97f, 0.0f, 1.8f, UPDATE_FALSE		},
	{ MT_EXTRABFG,		 0.1f, 1.0f,  0.1f, 0.0f, 1.0f, UPDATE_FALSE		},
	{ MT_TROOPSHOT,		 1.0f, 0.4f,  0.2f, 0.0f, 0.9f, UPDATE_FALSE		},
	{ MT_HEADSHOT,		 0.8f,0.05f,  0.8f, 0.0f, 0.9f, UPDATE_FALSE		},
	{ MT_TRACER,		 1.0f,0.25f, 0.25f, 0.0f, 0.9f, UPDATE_FALSE		},
	{ MT_FIRE,		    0.94f,0.94f, 0.27f, 0.0f, 1.6f, UPDATE_FALSE		},
	{ MT_PLAYER,		 0.9f, 0.9f,  0.2f, 0.0f, 1.0f, UPDATE_FALSE		},
	{ MT_MISC41,		0.0f, 0.0f, 1.0f, 0.0f, 1.8f, UPDATE_TRUE		},
	{ MT_MISC42,		0.0f, 1.0f, 0.0f, 0.0f, 1.8f, UPDATE_TRUE		},
	{ MT_MISC43,		1.0f, 0.0f, 0.0f, 0.0f, 1.8f, UPDATE_TRUE		},
	{ MT_MISC49,		1.0f, 0.9f, 0.3f, 0.0f, 0.4f, UPDATE_TRUE		},
	{ MT_MISC46,		1.0f, 0.0f, 0.0f, 0.0f, 1.0f, UPDATE_TRUE		},
	{ MT_MISC45,		0.0f, 1.0f, 0.0f, 0.0f, 1.0f, UPDATE_TRUE		},
	{ MT_MISC44,		0.0f, 0.0f, 1.0f, 0.0f, 1.0f, UPDATE_TRUE		}
};
#elif GL_HEXEN
#define NUMBER_OF_DYNAMIC_LIGHT_SOURCES 25

GLdynamic_prop dynamic_mobjlight[NUMBER_OF_DYNAMIC_LIGHT_SOURCES] = 
{
	{ MT_FSWORD_MISSILE,   0.1f,1.0f,0.1f,0.0f,0.5f, UPDATE_FALSE		},
	{ MT_FSWORD_FLAME,			 0.1f,1.0f,0.1f,0.0f,1.1f, UPDATE_FALSE		},
	{ MT_MWAND_MISSILE,		 0.35f,0.56f,1.0f,0.0f,0.9f, UPDATE_FALSE		},
	{ MT_LIGHTNING_ZAP,			 0.45f,0.60f,0.97f,0.0f,2.0f, UPDATE_FALSE		},
	{ MT_AXEPUFF_GLOW,		 0.45f,0.66f,0.97f,0.0f,0.9f, UPDATE_FALSE		},
	{ MT_CFLAME_MISSILE,		 1.0f,0.5f,0.2f,0.0f,1.1f, UPDATE_FALSE		},
	{ MT_CIRCLEFLAME,		1.0f,0.5f,0.2f,0.0f,0.2f, UPDATE_FALSE		},
	{ MT_HOLY_MISSILE,		 1.0f,1.0f,1.0f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_HOLY_FX,		 1.0f,1.0f,1.0f,0.0f,0.5f, UPDATE_FALSE		},
	{ MT_MSTAFF_FX2,		 1.0f,0.1f,0.05f,0.0f,2.0f, UPDATE_FALSE		},
	{ MT_SHARDFX1,		 0.45f,0.66f,0.97f,0.0f,0.4f, UPDATE_FALSE		},
	{ MT_CSTAFF_MISSILE,	0.1f,1.0f,0.1f,0.0f,0.4f, UPDATE_FALSE		},
	{ MT_HAMMER_MISSILE,		 1.0f,0.4f,0.2f,0.0f,0.9f, UPDATE_FALSE		},
	// Monsters
	{ MT_MNTRFX1,		1.0f,0.4f,0.2f,0.0f,0.9f, UPDATE_FALSE		},
	{ MT_SERPENTFX,		0.1f,1.0f,0.2f,0.0f,0.6f, UPDATE_FALSE		},
	{ MT_CENTAUR_FX,		0.45f,0.60f,0.97f,0.0f,1.1f, UPDATE_FALSE		},
	{ MT_BISH_FX,		0.79f,0.99f,0.28f,0.0f,0.3f, UPDATE_FALSE		},
	{ MT_DRAGON_FX,		0.9f,0.7f,0.1f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_DEMONFX1,		1.0f,0.8f,0.1f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_DEMON2FX1,		0.1f,1.0f,0.2f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_WRAITHFX1,		0.8f,0.45f,0.15f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_ICEGUY_FX,		0.45f,0.66f,0.97f,0.0f,0.7f, UPDATE_FALSE		},
	{ MT_FIREDEMON_FX6,		0.9f,0.7f,0.12f,0.0f,0.6f, UPDATE_FALSE		},
	{ MT_SORCFX4,		0.9f,0.2f,0.99f,0.0f,0.4f, UPDATE_FALSE		},
	{ MT_SORCFX1,		1.0f,0.45f,0.15f,0.0f,0.9f, UPDATE_FALSE		},
};
#else
#define NUMBER_OF_DYNAMIC_LIGHT_SOURCES 23

GLdynamic_prop dynamic_mobjlight[NUMBER_OF_DYNAMIC_LIGHT_SOURCES] = 
{
	{ MT_GOLDWANDPUFF1,   1.0f,0.4f,0.2f,0.0f,0.9f, UPDATE_FALSE		},
	{ MT_GOLDWANDPUFF2,	  1.0f,0.4f,0.2f,0.0f,0.4f, UPDATE_FALSE		},
	{ MT_GOLDWANDFX2,		 1.0f,0.4f,0.2f,0.0f,0.8f, UPDATE_FALSE		},
	{ MT_CRBOWFX1,			 0.1f,1.0f,0.1f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_CRBOWFX2,		 0.1f,1.0f,0.1f,0.0f,1.2f, UPDATE_FALSE		},
	{ MT_BLASTERPUFF1,		 0.45f,0.66f,0.97f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_BLASTERFX1,		0.45f,0.66f,0.97f,0.0f,1.7f, UPDATE_FALSE		},
	{ MT_HORNRODFX1,		 1.0f,0.05f,0.05f,0.0f,1.1f, UPDATE_FALSE		},
	{ MT_HORNRODFX2,		 1.0f,0.05f,0.05f,0.0f,3.0f, UPDATE_FALSE		},
	{ MT_PHOENIXFX1,		 1.0f,0.4f,0.2f,0.0f,1.8f, UPDATE_FALSE		},
	{ MT_PHOENIXFX2,		 1.0f,0.4f,0.2f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_MACEFX3,		    1.0f,0.4f,0.2f,0.0f,0.9f, UPDATE_FALSE		},
	{ MT_IMPBALL,		 1.0f,0.4f,0.2f,0.0f,0.7f, UPDATE_FALSE		},
	{ MT_MUMMYFX1,		 1.0f,0.9f,0.1f,0.0f,0.7f, UPDATE_FALSE		},
	{ MT_SRCRFX1,		 0.98f,0.9f,0.3f,0.0f,0.7f, UPDATE_FALSE		},
	{ MT_SOR2FX1,		 0.2f,0.98f,0.98f,0.0f,0.95f, UPDATE_FALSE		},
	{ MT_MNTRFX1,		 1.0f,0.4f,0.2f,0.0f,0.9f, UPDATE_FALSE		},
	{ MT_BEASTBALL,		 0.8f,0.45f,0.15f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_HEADFX1,		 0.1f,0.98f,0.98f,0.0f,1.0f, UPDATE_FALSE		},
	{ MT_HEADFX3,		 0.8f,0.45f,0.15f,0.0f,2.5f, UPDATE_FALSE		},
	{ MT_SNAKEPRO_A,		 0.9f,0.6f,0.95f,0.0f,0.65f, UPDATE_FALSE		},
	{ MT_SNAKEPRO_B,		 1.0f,0.05f,0.05f,0.0f,0.7f, UPDATE_FALSE		},
	{ MT_WIZFX1,		 0.8f,0.05f,0.9f,0.0f,0.7f, UPDATE_FALSE		}
};
#endif*/
// End DarkFang

void GL_fn_vInitLights()
{ int i;
	
	iGLNbLightSources=0;
	for (i=0;i<MAX_LIGHT_SOURCES;i++)
		a_stGLLight[i].thing=NULL;
}

CVAR (g_bDynLight, "3", CVAR_ARCHIVE)
CVAR (g_bMD2Light, "1", CVAR_ARCHIVE)
CVAR (g_iMaxNbMD2Light, "1", CVAR_ARCHIVE)		// MR2909
float Distance(float x1,float y1,float z1,float x2,float y2,float z2)
{
	return (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)+(z1-z2)*(z1-z2);
}

void GL_DynamicLight4f(GLfloat x, GLfloat y,GLfloat z,GLfloat fRedB,GLfloat fGreenB,GLfloat fBlueB,GLfloat fAlpha)
{ //float fGamma=/*usegamma*0.12f+*/g_fPal;
  GLDynamicLight *p_stGLLight;
  float fRed,fGreen,fBlue,fCoeff[MAX_LIGHT_SOURCES],fSumCoeff;
  float fDist,fDiff/*,fAmb=0.7f*/;
  int i;
	
	fRed=fGreen=fBlue=0.0f;
	fSumCoeff=0.0f;
	for (i=0;i<iGLNbLightSources;i++)
	{	p_stGLLight=&a_stGLLight[i];
		fDist=Distance(x,y,z,p_stGLLight->x,p_stGLLight->y,p_stGLLight->z);
		if (fDist>p_stGLLight->fFar2)
		{	fCoeff[i]=0.0f;
			/*fRed=0.0f;
			fGreen=0.0f;
			fRed=0.0f;*/
		}
		else
		if (fDist<p_stGLLight->fNear)
		{	fCoeff[i]=1.0f;
		}
		else
		{	fCoeff[i]=(p_stGLLight->fFar2-fDist)/(p_stGLLight->fFar2-p_stGLLight->fNear);
		}
		fRed+=fCoeff[i]*p_stGLLight->fRed;
		fGreen+=fCoeff[i]*p_stGLLight->fGreen;
		fBlue+=fCoeff[i]*p_stGLLight->fBlue;
		fSumCoeff+=fCoeff[i];
	}
	/*if (fSumCoeff)
	{	fRed/=fSumCoeff;
		fGreen/=fSumCoeff;
		fBlue/=fSumCoeff;
	}*/
	
// MR1602
/*	player = &players[consoleplayer];
	if (player->fixedcolormap == INVERSECOLORMAP)
	{//	glColor3f(1.0f,1.0f,0.0f);
		fRedS=1.0f;
		fGreenS=1.0f;
		fBlueS=1.0f;
	}
	else
	if (player->fixedcolormap)
	{//	glColor3f(1.0f,1.0f,0.0f);
		fRedS=1.0f;
		fGreenS=1.0f;
		fBlueS=1.0f;
	}
	else
	{	fRedS=fRedB+fGamma+g_fRed-g_fGreen;
		fGreenS=fGreenB+fGamma-g_fRed+g_fGreen;
		fBlueS=fBlueB+fGamma-g_fRed-g_fGreen;

	}*/
	
	if (fSumCoeff)
		fDiff=fSumCoeff;
	else
		fDiff=0.0f;
	
	// MR1602
	/*fAmb=1.0f;
	fRed=fRed*fDiff+fRedS*fAmb;
	fGreen=fGreen*fDiff+fGreenS*fAmb;
	fBlue=fBlue*fDiff+fBlueS*fAmb;*/
	fRed=fRed*fDiff+fRedB;
	fGreen=fGreen*fDiff+fGreenB;
	fBlue=fBlue*fDiff+fBlueB;
	
	glColor4f(fRed,fGreen,fBlue,fAlpha);
}

// For qsort...
typedef struct
{	int index;
	float radius;
} tdRadiusArray;

tdRadiusArray a_fFloorRadius[MAX_LIGHT_SOURCES],a_fCeilingRadius[MAX_LIGHT_SOURCES];

int __cdecl compare( const void *arg1, const void *arg2 )
{
   if (((tdRadiusArray *)arg1)->radius>((tdRadiusArray *)arg2)->radius)
		return 1;
	else if (((tdRadiusArray *)arg1)->radius<((tdRadiusArray *)arg2)->radius)
		return -1;
	else
		return 0;
}

#ifdef HAVE_FASTSQRT
extern /*inline*/ float fastsqrt(float n);
#else
#define fastsqrt(n) sqrtf(n)
#endif

// MD2 lighting
// MR2909 (use tdRadiusArray to store md2-lights distances)
//short g_aMD2Light[MAX_LIGHT_SOURCES];
tdRadiusArray g_aMD2Light[MAX_LIGHT_SOURCES];
short g_iNbMD2Lights;
void GL_BuildLightsListForMD2(float x,float y,float z)
{ float fDist,tmpX,tmpZ,fTrueDist;
  int i;
  GLDynamicLight *p_stGLLight;
	
	g_iNbMD2Lights=0;
	//memset(g_aMD2Light,0,MAX_LIGHT_SOURCES*2);
	for (i=0;i<iGLNbLightSources;i++)
	{	p_stGLLight=&a_stGLLight[i];
		fDist=Distance(x,y,z,p_stGLLight->x,p_stGLLight->y,p_stGLLight->z);
		if (fDist<1.5f*p_stGLLight->fFar2)
		{	
			fTrueDist=(float)sqrt(fDist);
			//fTrueDist=fastsqrt(fDist);
			// MR2909
			//g_aMD2Light[g_iNbMD2Lights++]=i;
			g_aMD2Light[g_iNbMD2Lights].index=i;
			g_aMD2Light[g_iNbMD2Lights++].radius=fTrueDist;

			p_stGLLight->fDirection[0] = (p_stGLLight->x-x)/fTrueDist;
			p_stGLLight->fDirection[1] = (p_stGLLight->y-y)/fTrueDist;
			p_stGLLight->fDirection[2] = (p_stGLLight->z-z)/fTrueDist;
			//fn_vRotateVector(p_stGLLight->fDirection,yaw/*,pitch*/);
			tmpX=p_stGLLight->fDirection[0]*cosA-p_stGLLight->fDirection[2]*sinA;
			tmpZ=p_stGLLight->fDirection[0]*sinA+p_stGLLight->fDirection[2]*cosA;
			p_stGLLight->fDirection[0]=tmpX;
			p_stGLLight->fDirection[2]=tmpZ;
		}
	}
	// MR2909
	qsort(g_aMD2Light,g_iNbMD2Lights,sizeof(tdRadiusArray),compare);	
	if (g_iNbMD2Lights>g_iMaxNbMD2Light.value)
		g_iNbMD2Lights=(short)g_iMaxNbMD2Light.value;
}

void GL_MD2DynamicLight4f(GLfloat x, GLfloat y,GLfloat z,GLfloat fRedB,GLfloat fGreenB,GLfloat fBlueB,GLfloat fAlpha,float fNormal[3])
{ 
  GLDynamicLight *p_stGLLight;
  float fRed,fGreen,fBlue,fCoeff[MAX_LIGHT_SOURCES],fSumCoeff;
  float fDist,fDiff,fDotProduct;
  int i;
	
	fRed=fGreen=fBlue=0.0f;
	fSumCoeff=0.0f;
	for (i=0;i<g_iNbMD2Lights;i++)
	{	p_stGLLight=&a_stGLLight[g_aMD2Light[i].index];
		fDist=Distance(x,y,z,p_stGLLight->x,p_stGLLight->y,p_stGLLight->z);
		
		fDotProduct=p_stGLLight->fDirection[0]*fNormal[0]+
					p_stGLLight->fDirection[1]*fNormal[1]+
					p_stGLLight->fDirection[2]*fNormal[2];

		//if (fDist>p_stGLLight->fFar2)
		if ((fDist>p_stGLLight->fFar2)||(fDotProduct<=0))
		{	fCoeff[i]=0.0f;
		}
		else
		if (fDist<p_stGLLight->fNear)
		{	fCoeff[i]=1.0f;
		}
		else
		{	fCoeff[i]=2.0f*fDotProduct*(p_stGLLight->fFar2-fDist)/(p_stGLLight->fFar2-p_stGLLight->fNear);
		}
		fRed+=fCoeff[i]*p_stGLLight->fRed;
		fGreen+=fCoeff[i]*p_stGLLight->fGreen;
		fBlue+=fCoeff[i]*p_stGLLight->fBlue;
		fSumCoeff+=fCoeff[i];
	}
	
	if (fSumCoeff)
		fDiff=fSumCoeff;
	else
		fDiff=0.0f;
	
	fRed=fRed*fDiff+fRedB/**(1.0f-fDiff)*/;
	fGreen=fGreen*fDiff+fGreenB/**(1.0f-fDiff)*/;
	fBlue=fBlue*fDiff+fBlueB/**(1.0f-fDiff)*/;
	
	glColor4f(fRed,fGreen,fBlue,fAlpha);
}

//void GL_AddLightSource(int ID,float x,float y,float z,float fRed,float fGreen,float fBlue,float fNear, float fFar)
GLboolean GL_bAddLightSource(mobj_t *obj,float x,float y,float z,float fRed,float fGreen,float fBlue,float fNear, float fFar, char update)
{
	if (iGLNbLightSources==MAX_LIGHT_SOURCES)
		return false;
	//a_stGLLight[iGLNbLightSources].ID=ID;
	a_stGLLight[iGLNbLightSources].thing=obj;
	a_stGLLight[iGLNbLightSources].x=x;
	a_stGLLight[iGLNbLightSources].y=y;
	a_stGLLight[iGLNbLightSources].z=z;
	a_stGLLight[iGLNbLightSources].fRed=fRed;
	a_stGLLight[iGLNbLightSources].fGreen=fGreen;
	a_stGLLight[iGLNbLightSources].fBlue=fBlue;
	a_stGLLight[iGLNbLightSources].fFar=fFar;
	a_stGLLight[iGLNbLightSources].fFar2=fFar*fFar;
	a_stGLLight[iGLNbLightSources].fNear=fNear;
	a_stGLLight[iGLNbLightSources].update=update;
	a_stGLLight[iGLNbLightSources++].tic=-1;
	return true;
}

void GL_RemoveLightSource(int ID)
{ int i;

	if (iGLNbLightSources<=0)
		return;		// Should never happen...

	if (ID==-1)
		return;

	/*if (a_stGLLight[ID].update != UPDATE_FALSE)
	{ return; }

	if (!a_stGLLight[ID].thing)
		return;*/

		
#ifdef _DEBUG
/*	if (M_CheckParm("-debugstats"))
	{
		printf("Light source removed. doomednum - %d\n", a_stGLLight[ID].thing->info->doomednum);
	}*/
#endif

	if (a_stGLLight[ID].thing)
		a_stGLLight[ID].thing->iLightID=-1;
	a_stGLLight[ID].thing=NULL;
	a_stGLLight[ID].update = -1;

	for (i=ID;i<iGLNbLightSources-1;i++)
	{	memcpy(&a_stGLLight[i],&a_stGLLight[i+1],sizeof(GLDynamicLight));
		a_stGLLight[i].thing->iLightID=i;
	}
	iGLNbLightSources--;
}

/*void GL_MoveLight(int ID,float x,float y,float z)
{ int i;

	for (i=0;i<iGLNbLightSources;i++)
	{
		if (a_stGLLight[i].ID==ID)
		{
			a_stGLLight[i].x=x;
			a_stGLLight[i].y=y;
			a_stGLLight[i].z=z;
			return;
		}
	}
}*/

void GL_SpawnLight(mobj_t *th,fixed_t x,fixed_t y,fixed_t z)
{ float fX,fY,fZ;
  GLboolean result=false;
  int i;

	fX=(float)-x/MAP_SCALE;
	fY=(float)z/MAP_SCALE;
	fZ=(float)y/MAP_SCALE;

/*	for (i=0; i<NUMBER_OF_DYNAMIC_LIGHT_SOURCES; i++)
	{

		if (th->type == dynamic_mobjlight[i].type)
		{
			

			if (!g_bLightEffects&&(dynamic_mobjlight[i].update!=UPDATE_FALSE))
				return;
			result = GL_bAddLightSource(th, fX, fY, fZ, 
										dynamic_mobjlight[i].fRed,
										dynamic_mobjlight[i].fGreen,
										dynamic_mobjlight[i].fBlue,
										dynamic_mobjlight[i].fNear,
										dynamic_mobjlight[i].fFar,
										dynamic_mobjlight[i].update);
		
		}
	}*/
	i=th->state->iLightProp;
	if (i!=-1)
		result = GL_bAddLightSource(th, fX, fY+g_p_stLightProp[i].fOffset, fZ, 
								g_p_stLightProp[i].fRed,
								g_p_stLightProp[i].fGreen,
								g_p_stLightProp[i].fBlue,
								0.0f,
								g_p_stLightProp[i].fFar,
								0);
	else
		return;

/*#if !defined(DOOM_GL) && !defined(GL_HEXEN)
	if (th->type==MT_PLAYER)
	{
		if ((th->player->readyweapon==wp_gauntlets)&&(th->player->powers[pw_weaponlevel2]))
			result=GL_bAddLightSource(th,fX,fY,fZ,1.0f,0.05f,0.05f,0.0f,1.0f,UPDATE_FALSE);
		else
		if (th->player->readyweapon==wp_gauntlets)
			result=GL_bAddLightSource(th,fX,fY,fZ,0.1f,1.0f,0.1f,0.0f,1.0f,UPDATE_FALSE);
		else
		if (th->player->readyweapon==wp_goldwand)
			result=GL_bAddLightSource(th,fX,fY,fZ,1.0f,0.4f,0.2f,0.0f,0.8f,UPDATE_FALSE);
		else
		if (th->player->readyweapon==wp_blaster)
			result=GL_bAddLightSource(th,fX,fY,fZ,0.45f,0.66f,0.97f,0.0f,0.8f,UPDATE_FALSE);
		else result=false;
	}
#endif*/
	if (result)
		th->iLightID=iGLNbLightSources-1;
}

void GL_UpdateLights()
{ int i;
  //state_t *stat;
  int stat;
  //player_t *player;

	for (i=0;i<iGLNbLightSources;i++)
	{	a_stGLLight[i].x=(float)-a_stGLLight[i].thing->x/MAP_SCALE;
		a_stGLLight[i].y=(float)a_stGLLight[i].thing->z/MAP_SCALE;
		a_stGLLight[i].z=(float)a_stGLLight[i].thing->y/MAP_SCALE;

		// special effects...
/*		if (g_bLightEffects)	// DarkFang
		{ AGL_HandleEffects(i); }

		if (a_stGLLight[i].tic==-1)
			continue;*/
		if (!a_stGLLight[i].thing->state)
			continue;

		stat=a_stGLLight[i].thing->state->iLightProp;
		a_stGLLight[i].fRed=g_p_stLightProp[stat].fRed;
		a_stGLLight[i].fGreen=g_p_stLightProp[stat].fGreen;
		a_stGLLight[i].fBlue=g_p_stLightProp[stat].fBlue;
		a_stGLLight[i].y+=g_p_stLightProp[stat].fOffset;
		if (!paused)
		{	if (g_p_stLightProp[stat].bSign==-1)
				a_stGLLight[i].fFar2-=g_p_stLightProp[stat].fIncrease;
			else
			if (g_p_stLightProp[stat].bSign==1)
				a_stGLLight[i].fFar2+=g_p_stLightProp[stat].fIncrease;
			else
				a_stGLLight[i].fFar2=g_p_stLightProp[stat].fFar*g_p_stLightProp[stat].fFar;
		}
		if (a_stGLLight[i].fFar2<0.0f)
			a_stGLLight[i].fFar2=0.0f;
	}
}
// Special effects:
void A_GL_StartLightEffect(mobj_t *mo)
{ int iLight=mo->iLightID;

	a_stGLLight[iLight].tic=0;
}

#if 0
GLboolean fn_bComputeLightUV1(float lightRad,float x1,float y1,float z1,float x2,float y2,float z2,float x3,float y3,float z3,float *u1,float *u2,float *v1,float *v2)
{ float u,radius,dist,d1,d2,x,y,signV,sign1,sign2;
  GLboolean exit=false;

	// MR1907
#ifdef LRASTER
	if (g_bLightRaster)
		QueryPerformanceCounter(&PerformanceCountStart);
#endif

	// Mettre des if  la place des * -1.
	// Virer les / et les sqrt.
	u=((x3-x1)*(x2-x1)+(y3-y1)*(y2-y1))/((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
	x=x1+u*(x2-x1);
	y=y1+u*(y2-y1);
	dist=sqrt((x3-x)*(x3-x)+(y3-y)*(y3-y));
	if (dist>lightRad)
	//	return false;
		goto lfalse;
	d1=sqrt((x1-x)*(x1-x)+(y1-y)*(y1-y));
	d2=sqrt((x2-x)*(x2-x)+(y2-y)*(y2-y));
	radius=sqrt(lightRad*lightRad-dist*dist);		// MR0507 (sqrt)
	if ((d1>radius)&&(d2>radius))					// MR0507
	//	return false;
		exit=true;
	if (x1!=x2)
	{	signV=(x2>x1)?1.0f:-1.0f;
		sign1=(x1>x)?1.0f:-1.0f;
		sign2=(x2>x)?1.0f:-1.0f;
		if (exit&&(sign1==sign2))
			//return false;
			goto lfalse;
		*u1=signV*sign1*d1/(2*radius)+0.5f;
		*u2=signV*sign2*d2/(2*radius)+0.5f;
	}
	else
	{	signV=(y2>y1)?1.0f:-1.0f;
		sign1=(y1>y)?1.0f:-1.0f;
		sign2=(y2>y)?1.0f:-1.0f;
		if (exit&&(sign1==sign2))
			//return false;
			goto lfalse;
		*u1=signV*sign1*d1/(2*radius)+0.5f;
		*u2=signV*sign2*d2/(2*radius)+0.5f;
	}
	/**u1=(radius-d1)/(2*radius);
	*u2=1.0f+(d2-radius)/(2*radius);*/
	*v1=(radius-z1+z3)/(2*radius);
	*v2=1.0f+(z3-z2-radius)/(2*radius);

	if (g_bLightRaster)
		QueryPerformanceCounter(&PerformanceCountEnd);
	LightPerf.LowPart+=PerformanceCountEnd.LowPart-PerformanceCountStart.LowPart;
	return true;

lfalse:
#ifdef LRASTER
	if (g_bLightRaster)
		QueryPerformanceCounter(&PerformanceCountEnd);
	LightPerf.LowPart+=PerformanceCountEnd.LowPart-PerformanceCountStart.LowPart;
#endif
	return false;

}
#endif	// 0

GLboolean fn_bComputeLightUV(float lightRad,float x1,float y1,float z1,float x2,float y2,float z2,float x3,float y3,float z3,float xN,float yN,float *u1,float *u2,float *v1,float *v2)
{ float u,radius,dist,d1,d2,x,y,sign1,sign2;
  GLboolean exit=false;
  float radiusDiv/*,radius2*/;

	// MR1907
#ifdef LRASTER
	if (g_bLightRaster)
		QueryPerformanceCounter(&PerformanceCountStart);
#endif

	if (((x3-x1)*xN+(y3-y1)*yN)>0.0f)		// Light behind the wall
		goto lfalse;

	u=((x3-x1)*(x2-x1)+(y3-y1)*(y2-y1))/((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
	x=x1+u*(x2-x1);
	y=y1+u*(y2-y1);
	dist=(x3-x)*(x3-x)+(y3-y)*(y3-y);
	if (dist>lightRad)
		goto lfalse;

	d1=(float)sqrt((x1-x)*(x1-x)+(y1-y)*(y1-y));
	d2=(float)sqrt((x2-x)*(x2-x)+(y2-y)*(y2-y));
	radius=(float)sqrt(lightRad-dist);
	//radius2=radius*radius;
	radiusDiv=1.0f/(2.0f*radius);
	if ((d1>radius)&&(d2>radius))
	//	return false;
		exit=true;
	
	if (x1!=x2)
	{	
		sign1=(x1>x)?1.0f:-1.0f;
		sign2=(x2>x)?1.0f:-1.0f;
		//if (exit&&(sign1==sign2))
		if (exit&&((x1>x)==(x2>x)))
		//if (exit&&((x1>x)&&(x2>x))||((x1<=x)&&(x2<=x)))
			//return false;
			goto lfalse;
		if (x2>x1)
		{	if (x1>x)
				*u1=d1*radiusDiv+0.5f;
			else
				*u1=-d1*radiusDiv+0.5f;
			if (x2>x)
				*u2=d2*radiusDiv+0.5f;
			else
				*u2=-d2*radiusDiv+0.5f;
		}
		else
		{	if (x1>x)
				*u1=-d1*radiusDiv+0.5f;
			else
				*u1=d1*radiusDiv+0.5f;
			if (x2>x)
				*u2=-d2*radiusDiv+0.5f;
			else
				*u2=d2*radiusDiv+0.5f;
		}
/*		signV=(x2>x1)?1.0f:-1.0f;
		sign1=(x1>x)?1.0f:-1.0f;
		sign2=(x2>x)?1.0f:-1.0f;
		if (exit&&(sign1==sign2))
			//return false;
			goto lfalse;
		*u1=signV*sign1*d1*radiusDiv+0.5f;
		*u2=signV*sign2*d2*radiusDiv+0.5f;*/
	}
	else
	{	//if (exit&&((y1>y)&&(y2>y))||((y1<y)&&(y2<y)))
		if (exit&&((y1>y)==(y2>y)))
			//return false;
			goto lfalse;
		if (y2>y1)
		{	if (y1>y)
				*u1=d1*radiusDiv+0.5f;
			else
				*u1=-d1*radiusDiv+0.5f;
			if (y2>y)
				*u2=d2*radiusDiv+0.5f;
			else
				*u2=-d2*radiusDiv+0.5f;
		}
		else
		{	if (y1>y)
				*u1=-d1*radiusDiv+0.5f;
			else
				*u1=d1*radiusDiv+0.5f;
			if (y2>y)
				*u2=-d2*radiusDiv+0.5f;
			else
				*u2=d2*radiusDiv+0.5f;
		}
	}

	*v1=(radius-z1+z3)*radiusDiv;
	*v2=1.0f+(z3-z2-radius)*radiusDiv;

#ifdef LRASTER
	if (g_bLightRaster)
		QueryPerformanceCounter(&PerformanceCountEnd);
	LightPerf.LowPart+=PerformanceCountEnd.LowPart-PerformanceCountStart.LowPart;
#endif
	return true;

lfalse:
#ifdef LRASTER
	if (g_bLightRaster)
		QueryPerformanceCounter(&PerformanceCountEnd);
	LightPerf.LowPart+=PerformanceCountEnd.LowPart-PerformanceCountStart.LowPart;
#endif
	return false;

}

bool GL_DrawLightsOnPolygon1(float x1,float y1,float z1,float x2,float y2,float z2,float xN,float yN,GLboolean backface)
{ int i;
  GLDynamicLight *p_stGLLight;
  float u1,u2,v1,v2;
  GLboolean bFirst=true;

	glBindTexture(GL_TEXTURE_2D, g_iCorona);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

//	glDepthFunc(GL_LEQUAL);
//	glEnable(GL_BLEND);	

//	glBlendFunc(GL_DST_COLOR, GL_ONE);
	//glBlendFunc(GL_ONE,GL_ONE);
	//glBlendFunc(GL_ONE,GL_ONE_MINUS_DST_ALPHA);

	for (i=0;i<iGLNbLightSources;i++)
	{	p_stGLLight=&a_stGLLight[i];
		if (fn_bComputeLightUV(p_stGLLight->fFar2,x1,y1,z1,x2,y2,z2,p_stGLLight->x,p_stGLLight->z,p_stGLLight->y,xN,yN,&u1,&u2,&v1,&v2))
		{	
			glBegin(GL_QUADS);

			glColor3f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue);
			//glColor4f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue,0.5f);
			if (!backface)
			{	glTexCoord2f(u1, v1); glVertex3f( x1, z1, y1);
				glTexCoord2f(u1, v2); glVertex3f( x1, z2, y1);
				glTexCoord2f(u2, v2); glVertex3f( x2, z2, y2);
				glTexCoord2f(u2, v1); glVertex3f( x2, z1, y2);
			}
			else
			{	glTexCoord2f(u1, v1); glVertex3f( x1, z1, y1);
				glTexCoord2f(u2, v1); glVertex3f( x2, z1, y2);
				glTexCoord2f(u2, v2); glVertex3f( x2, z2, y2);
				glTexCoord2f(u1, v2); glVertex3f( x1, z2, y1);
			}
			glEnd();
			if (bFirst)
			{	bFirst=false;
				glEnable(GL_BLEND);
				glDepthFunc(GL_LEQUAL);
				//glBlendFunc(GL_ONE,GL_ONE);
				glBindTexture(GL_TEXTURE_2D, g_iParticle);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
				//glBlendFunc(GL_ONE,GL_ONE_MINUS_DST_ALPHA);
			}
		}
	}
//	glDisable(GL_BLEND);	
//	glDepthFunc(GL_LESS);

	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

	if (bFirst)
		return false;
	else
		return true;
}

void GL_DrawLightsOnPolygon0(float x1,float y1,float z1,float x2,float y2,float z2,float xN,float yN,GLboolean backface)
{ int i;
  GLDynamicLight *p_stGLLight;
  float u1,u2,v1,v2;

		//glHint(GL_POLYGON_SMOOTH_HINT, GL_FASTEST);
	
	glBindTexture(GL_TEXTURE_2D, g_iCorona);
	//glBindTexture(GL_TEXTURE_2D, g_iCorona+i);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

	glDepthFunc(GL_LEQUAL);
	glEnable(GL_BLEND);	

	glBlendFunc(GL_DST_COLOR, GL_ONE);

	for (i=0;i<iGLNbLightSources;i++)
	{	p_stGLLight=&a_stGLLight[i];
		if (fn_bComputeLightUV(p_stGLLight->fFar2,x1,y1,z1,x2,y2,z2,p_stGLLight->x,p_stGLLight->z,p_stGLLight->y,xN,yN,&u1,&u2,&v1,&v2))
		{	
			glBegin(GL_QUADS);

			glColor3f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue);
			//glColor4f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue,0.2f);			
			if (!backface)
			{	glTexCoord2f(u1, v1); glVertex3f( x1, z1, y1);
				glTexCoord2f(u1, v2); glVertex3f( x1, z2, y1);
				glTexCoord2f(u2, v2); glVertex3f( x2, z2, y2);
				glTexCoord2f(u2, v1); glVertex3f( x2, z1, y2);
			}
			else
			{	glTexCoord2f(u1, v1); glVertex3f( x1, z1, y1);
				glTexCoord2f(u2, v1); glVertex3f( x2, z1, y2);
				glTexCoord2f(u2, v2); glVertex3f( x2, z2, y2);
				glTexCoord2f(u1, v2); glVertex3f( x1, z2, y1);
			}
			glEnd();
		}
	}
	//glDisable(GL_ALPHA_TEST);
	glDisable(GL_BLEND);	
	glDepthFunc(GL_LESS);

	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

		//glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);
}

// Floor / Ceiling
void fn_vSortFloorCeilingLights()
{  int i;
	for (i=0;i<iGLNbLightSources;i++)
	{	a_fFloorRadius[i].index=i;
		a_fFloorRadius[i].radius=a_stGLLight[i].fLightRadiusFloor;
		a_fCeilingRadius[i].index=i;
		a_fCeilingRadius[i].radius=a_stGLLight[i].fLightRadiusCeiling;
	}
	qsort(a_fFloorRadius,iGLNbLightSources,sizeof(tdRadiusArray),compare);
	qsort(a_fCeilingRadius,iGLNbLightSources,sizeof(tdRadiusArray),compare);
}

void fn_vComputeLightsRadius(float fFloor,float fCeiling)
{ int i;
  float dist;
  GLDynamicLight *p_stGLLight;

#ifdef RASTER		// MR1907
/*	if (g_bLightRaster)
		QueryPerformanceCounter(&PerformanceCountStart);*/
#endif

	for (i=0;i<iGLNbLightSources;i++)
	{	
		p_stGLLight=&a_stGLLight[i];
		dist=fCeiling-p_stGLLight->y;
		if ((dist*dist>p_stGLLight->fFar2)||(dist<0.0f))		// MR231200: dist*dist
			p_stGLLight->fLightRadiusCeiling=-1.0f;
		else
		{	
			p_stGLLight->fLightRadiusCeiling=(float)sqrt(p_stGLLight->fFar2-dist*dist);
			//p_stGLLight->fLightRadiusCeiling=p_stGLLight->fFar-dist;		// Faster but inaccurate
			fLightUpC[i]=p_stGLLight->z+p_stGLLight->fLightRadiusCeiling;
			fLightDownC[i]=p_stGLLight->z-p_stGLLight->fLightRadiusCeiling;
			fLightLeftC[i]=p_stGLLight->x-p_stGLLight->fLightRadiusCeiling;
			fLightRightC[i]=p_stGLLight->x+p_stGLLight->fLightRadiusCeiling;
		}
		dist=p_stGLLight->y-fFloor;
		if ((dist*dist>p_stGLLight->fFar2)||(dist<0.0f))
			p_stGLLight->fLightRadiusFloor=-1.0f;
		else
		{	
			p_stGLLight->fLightRadiusFloor=(float)sqrt(p_stGLLight->fFar2-dist*dist);
			//p_stGLLight->fLightRadiusFloor=p_stGLLight->fFar-dist;
			fLightUpF[i]=p_stGLLight->z+p_stGLLight->fLightRadiusFloor;
			fLightDownF[i]=p_stGLLight->z-p_stGLLight->fLightRadiusFloor;
			fLightLeftF[i]=p_stGLLight->x-p_stGLLight->fLightRadiusFloor;
			fLightRightF[i]=p_stGLLight->x+p_stGLLight->fLightRadiusFloor;
		}
	}

//	fn_vSortFloorCeilingLights();
#ifdef RASTER
/*	if (g_bLightRaster)
		QueryPerformanceCounter(&PerformanceCountEnd);
	LightPerf.LowPart+=PerformanceCountEnd.LowPart-PerformanceCountStart.LowPart;*/
#endif
}

GLboolean fn_bComputeLightUVFC(float RadDiv,float x1,float y1,float x2,float y2,float *u,float *v)
// x1,y1,z1 = point / x2,y2,z2 = light
{  //float RadDiv=1/(2*lightRad);

	//*u=(x1-x2)*RadDiv+0.5f;
	*u=(x1-x2)*RadDiv+0.5f;
	
	//*v=(y1-y2)*RadDiv+0.5f;
	//*v=(y2-y1)*RadDiv+0.5f;
	*v=(y2-y1)*RadDiv+0.5f;
	return true;
}

extern GLFloorCeilingPolygonArray *a_stFCPolygonArray;
#ifdef GL_HEXEN
#define F_SKY	"F_SKY"
#else
#define F_SKY	"F_SKY1"
#endif

GLboolean fn_bIsLightInArray(int s,int i,float fUp,float fDown,float fLeft,float fRight)
{
#if 0	
	if ((fUp<a_stFCPolygonArray[s].p_stVertexArray[i].fUp)&&
		(fUp>a_stFCPolygonArray[s].p_stVertexArray[i].fDown)&&
		(fLeft<a_stFCPolygonArray[s].p_stVertexArray[i].fRight)&&
		(fLeft>a_stFCPolygonArray[s].p_stVertexArray[i].fLeft))
		return true;
	
	if ((fUp<a_stFCPolygonArray[s].p_stVertexArray[i].fUp)&&
		(fUp>a_stFCPolygonArray[s].p_stVertexArray[i].fDown)&&
		(fRight<a_stFCPolygonArray[s].p_stVertexArray[i].fRight)&&
		(fRight>a_stFCPolygonArray[s].p_stVertexArray[i].fLeft))
		return true;
	
	if ((fDown<a_stFCPolygonArray[s].p_stVertexArray[i].fUp)&&
		(fDown>a_stFCPolygonArray[s].p_stVertexArray[i].fDown)&&
		(fLeft<a_stFCPolygonArray[s].p_stVertexArray[i].fRight)&&
		(fLeft>a_stFCPolygonArray[s].p_stVertexArray[i].fLeft))
		return true;
	
	if ((fDown<a_stFCPolygonArray[s].p_stVertexArray[i].fUp)&&
		(fDown>a_stFCPolygonArray[s].p_stVertexArray[i].fDown)&&
		(fRight<a_stFCPolygonArray[s].p_stVertexArray[i].fRight)&&
		(fRight>a_stFCPolygonArray[s].p_stVertexArray[i].fLeft))
		return true;

	return false;
#endif

	if (a_stFCPolygonArray[s].p_stVertexArray[i].fUp<fDown)
		return false;
	if (a_stFCPolygonArray[s].p_stVertexArray[i].fDown>fUp)
		return false;
	if (a_stFCPolygonArray[s].p_stVertexArray[i].fLeft>fRight)
		return false;
	if (a_stFCPolygonArray[s].p_stVertexArray[i].fRight<fLeft)
		return false;
/*	if ((a_stFCPolygonArray[s].p_stVertexArray[i].fUp<fDown)&&
		(a_stFCPolygonArray[s].p_stVertexArray[i].fDown>fUp)&&
		(a_stFCPolygonArray[s].p_stVertexArray[i].fLeft>fRight)&&
		(a_stFCPolygonArray[s].p_stVertexArray[i].fRight<fLeft))
		return false;*/
	return true;
}


extern GLbyte **a_bFirstPass;
void GL_DrawLightForFloor(int s)
{ int l,i,j;
  float u,v;
  GLDynamicLight *p_stGLLight;
  GLboolean bFirst=true;
  float fRadDiv;

	glCullFace(GL_FRONT);
	glDisable(GL_BLEND);
	glDepthFunc(GL_LESS);

	if (!a_stFCPolygonArray[s].iNbArrays)
		return;

	memset(a_bFirstPass[s],1,a_stFCPolygonArray[s].iNbArrays*2);

/*	glDepthFunc(GL_LEQUAL);
	glEnable(GL_BLEND);	
	glBlendFunc(GL_DST_COLOR, GL_ONE);*/
	glBindTexture(GL_TEXTURE_2D, g_iCorona);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

	fn_vComputeLightsRadius(a_stFCPolygonArray[s].p_stVertexArray[0].p_fVertex[1],a_stFCPolygonArray[s].p_stVertexArray[0].p_fCeiling[0]);

	if (sectors[s].floorpic==R_FlatNumForName(F_SKY))
	{	
		//glDisable(GL_BLEND);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		return;
	}

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//glBlendFunc(GL_ONE, GL_ONE);

	for (l=0;l<iGLNbLightSources;l++)
	{	//l=a_fFloorRadius[k].index;

		p_stGLLight=&a_stGLLight[l];
		if (p_stGLLight->fLightRadiusFloor==-1.0f)
			continue;
		fRadDiv=1/(2*p_stGLLight->fLightRadiusFloor);

		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			if (!fn_bIsLightInArray(s,i,fLightUpF[l],fLightDownF[l],fLightLeftF[l],fLightRightF[l]))
				continue;

			if (a_bFirstPass[s][2*i])
			{	glDisable(GL_BLEND);
				glDepthFunc(GL_LESS);
				glBindTexture(GL_TEXTURE_2D, g_iCorona);
			}
			else
			{	glEnable(GL_BLEND);
				glDepthFunc(GL_LEQUAL);
				glBindTexture(GL_TEXTURE_2D, g_iParticle);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
			}
			
			a_bFirstPass[s][2*i]=0;
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				glColor3f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue);
				fn_bComputeLightUVFC(fRadDiv,
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2],
									 p_stGLLight->x,p_stGLLight->z,&u,&v);
				glTexCoord2f(u,v);
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}
		/*if (bFirst)
		{	bFirst=false;
			glEnable(GL_BLEND);
			glDepthFunc(GL_LEQUAL);
			//glBlendFunc(GL_ONE,GL_ONE_MINUS_DST_ALPHA);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		}*/
	}
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
}

void GL_DrawLightForCeiling(int s)
{ int l,i,j;
  float u,v;
  GLDynamicLight *p_stGLLight;
  GLboolean bFirst=true;
  float fRadDiv;

	glCullFace(GL_BACK);
	glDisable(GL_BLEND);
	glDepthFunc(GL_LESS);

	if (!a_stFCPolygonArray[s].iNbArrays)
		return;

	glBindTexture(GL_TEXTURE_2D, g_iCorona);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

	//fn_vComputeLightsRadius(a_stFCPolygonArray[s].p_stVertexArray[0].p_fVertex[1],a_stFCPolygonArray[s].p_stVertexArray[0].p_fCeiling[0]);

 	if (sectors[s].ceilingpic==R_FlatNumForName(F_SKY))
	{	
		//glDisable(GL_BLEND);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		return;
	}
	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//glBlendFunc(GL_ONE, GL_ONE);

	for (l=0;l<iGLNbLightSources;l++)
	{	//l=a_fCeilingRadius[k].index;

		p_stGLLight=&a_stGLLight[l];
		if (p_stGLLight->fLightRadiusCeiling==-1)
			continue;
		
		fRadDiv=1/(2*p_stGLLight->fLightRadiusCeiling);

		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			if (!fn_bIsLightInArray(s,i,fLightUpC[l],fLightDownC[l],fLightLeftC[l],fLightRightC[l]))
				continue;

			if (a_bFirstPass[s][2*i+1])
			{	glDisable(GL_BLEND);
				glDepthFunc(GL_LESS);
				glBindTexture(GL_TEXTURE_2D, g_iCorona);
			}
			else
			{	glEnable(GL_BLEND);
				glDepthFunc(GL_LEQUAL);
				glBindTexture(GL_TEXTURE_2D, g_iParticle);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
			}

			a_bFirstPass[s][2*i+1]=0;
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				glColor3f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue);
				fn_bComputeLightUVFC(fRadDiv,
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2],
									 p_stGLLight->x,p_stGLLight->z,&u,&v);
				glTexCoord2f(u,v);
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
		/*if (bFirst)
		{	bFirst=false;
			glEnable(GL_BLEND);
			glDepthFunc(GL_LEQUAL);
			//glBlendFunc(GL_ONE,GL_ONE_MINUS_DST_ALPHA);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		}*/
	}
	//glDisable(GL_BLEND);	
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
}

// Mirrors
void GL_DrawLightForFloorM(int s,float fAlpha)
{ int l,i,j;
  float u,v;
  GLDynamicLight *p_stGLLight;
  GLboolean bFirst=true;
  float fRadDiv;

	glCullFace(GL_FRONT);
	//glDisable(GL_BLEND);
	glDepthFunc(GL_LESS);

	if (!a_stFCPolygonArray[s].iNbArrays)
		return;

	glBindTexture(GL_TEXTURE_2D, g_iCorona);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

	fn_vComputeLightsRadius(a_stFCPolygonArray[s].p_stVertexArray[0].p_fVertex[1],a_stFCPolygonArray[s].p_stVertexArray[0].p_fCeiling[0]);

	if (sectors[s].floorpic==R_FlatNumForName(F_SKY))
	{	
		//glDisable(GL_BLEND);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		return;
	}

	for (l=0;l<iGLNbLightSources;l++)
	{	//l=a_fFloorRadius[k].index;

		p_stGLLight=&a_stGLLight[l];
		if (p_stGLLight->fLightRadiusFloor==-1)
			continue;

		fRadDiv=1/(2*p_stGLLight->fLightRadiusFloor);

		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
/*			if (!fn_bIsLightInArray(s,i,fLightUpF[l],fLightDownF[l],fLightLeftF[l],fLightRightF[l]))
				continue;*/
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				glColor4f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue,fAlpha);
				fn_bComputeLightUVFC(fRadDiv,
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2],
									 p_stGLLight->x,p_stGLLight->z,&u,&v);
				glTexCoord2f(u,v);
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}
		if (bFirst)
		{	bFirst=false;
			glEnable(GL_BLEND);
			glDepthFunc(GL_LEQUAL);
			//glBlendFunc(GL_ONE,GL_ONE_MINUS_DST_ALPHA);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		}
	}
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
}

void GL_DrawLightForFloorCeiling(int s,int type)
// type= 0 : Floor & ceiling
// type= 1 : Floor
// type= 2 : Ceiling
{ int l,i,j;
  float u,v;
  GLDynamicLight *p_stGLLight;
  float fRadDiv;

	if (!a_stFCPolygonArray[s].iNbArrays)
		return;

	glDepthFunc(GL_LEQUAL);
	glEnable(GL_BLEND);	

	glBlendFunc(GL_DST_COLOR, GL_ONE);

	glBindTexture(GL_TEXTURE_2D, g_iCorona);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

	fn_vComputeLightsRadius(a_stFCPolygonArray[s].p_stVertexArray[0].p_fVertex[1],a_stFCPolygonArray[s].p_stVertexArray[0].p_fCeiling[0]);

	if ((sectors[s].floorpic==R_FlatNumForName(F_SKY))||(type==2))
	{	
		goto dceiling;
	}
	glCullFace(GL_FRONT);

	//iNbLights=iGLNbLightSources<3?iGLNbLightSources:3;
	for (l=0;l<iGLNbLightSources;l++)
	//for (k=0;k<iNbLights;k++)
	{	//l=a_fFloorRadius[k].index;

		p_stGLLight=&a_stGLLight[l];
		if (p_stGLLight->fLightRadiusFloor==-1)
			continue;

		fRadDiv=1/(2*p_stGLLight->fLightRadiusFloor);

		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			if (!fn_bIsLightInArray(s,i,fLightUpF[l],fLightDownF[l],fLightLeftF[l],fLightRightF[l]))
				continue;
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				glColor3f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue);
				//glColor4f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue,0.2f);
				fn_bComputeLightUVFC(fRadDiv,
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2],
									 p_stGLLight->x,p_stGLLight->z,&u,&v);
				glTexCoord2f(u,v);
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}
	}
dceiling:
	// MR090699
	glCullFace(GL_BACK);

 	if ((sectors[s].ceilingpic==R_FlatNumForName(F_SKY))||(type==1))
	{	
		glDisable(GL_BLEND);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		return;
	}
	
	for (l=0;l<iGLNbLightSources;l++)
	//for (k=0;k<iNbLights;k++)
	{	//l=a_fCeilingRadius[k].index;

		p_stGLLight=&a_stGLLight[l];
		if (p_stGLLight->fLightRadiusCeiling==-1)
			continue;

		fRadDiv=1/(2*p_stGLLight->fLightRadiusCeiling);

		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			if (!fn_bIsLightInArray(s,i,fLightUpC[l],fLightDownC[l],fLightLeftC[l],fLightRightC[l]))
				continue;
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				glColor3f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue);
				//glColor4f(p_stGLLight->fRed,p_stGLLight->fGreen,p_stGLLight->fBlue,0.2f);
				fn_bComputeLightUVFC(fRadDiv,
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
									 a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2],
									 p_stGLLight->x,p_stGLLight->z,&u,&v);
				glTexCoord2f(u,v);
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
	}
	glDisable(GL_BLEND);	
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

}

// -----------------------------------------------
// READ LIGHT.INI
// -----------------------------------------------
char C_sz_Lightini0[255]="lights.ini";
char C_sz_Lightini[255];
static int iState,g_iNbLightProps,g_iNbCoronaProps;
GLCoronaProp *g_a_CoronasProp;

typedef struct
{	char szLight[64];
	int iLight;
} tdstLkTable;

static tdstLkTable *LkTable;
static tdstLkTable *LkTableCor;	// MR2812

int fn_iGetLightId(tdstLkTable *LkTable,int iNbElements,char *szState)
{ /*int i;

	for (i=0;i<g_iNbLightProps;i++)
		if (!strcmp(LkTable[i].szLight,szState))
			return i;
	return -1;*/
	int min, max;

	min = 0;
	max = iNbElements;

	while (min <= max)
	{
		int mid = (min + max) / 2;
		int lexx = strcmp (LkTable[mid].szLight, szState);

		if (lexx == 0)
		{
			return LkTable[mid].iLight;
		}
		else if (lexx < 0)
		{
			min = mid + 1;
		}
		else
		{
			max = mid - 1;
		}
	}
	return -1;
}

void fn_vReadLightSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer,*p_cBuffer2=NULL;

	if (iState == g_iNbLightProps)
	{
		g_p_stLightProp = (GLdynamic_prop *)realloc (g_p_stLightProp, (++g_iNbLightProps)*sizeof(GLdynamic_prop));
	}

	strcpy(LkTable[iState].szLight,buffer);
	LkTable[iState].iLight=iState;

	GetPrivateProfileString("LIGHTS",buffer,"-",szBuffer,1024,C_sz_Lightini);
	if (szBuffer)
	{	p_cBuffer=szBuffer;
		p_cBuffer2=strchr(p_cBuffer,' ');
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_p_stLightProp[iState].fRed=(float)atof(p_cBuffer);
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;
		p_cBuffer2=strchr(p_cBuffer,' ');
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_p_stLightProp[iState].fGreen=(float)atof(p_cBuffer);
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;
		p_cBuffer2=strchr(p_cBuffer,' ');
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_p_stLightProp[iState].fBlue=(float)atof(p_cBuffer);
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;
		p_cBuffer2=strchr(p_cBuffer,' ');
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		if (p_cBuffer[0]=='-')
		{	g_p_stLightProp[iState].bSign=-1;
			g_p_stLightProp[iState].fIncrease=(float)atof(p_cBuffer+1);
			g_p_stLightProp[iState].fFar=0.0f;
		}
		else
		if (p_cBuffer[0]=='+')
		{	g_p_stLightProp[iState].bSign=1;
			g_p_stLightProp[iState].fIncrease=(float)atof(p_cBuffer+1);
			g_p_stLightProp[iState].fFar=0.0f;
		}
		else
		{	g_p_stLightProp[iState].bSign=0;
			g_p_stLightProp[iState].fFar=(float)atof(p_cBuffer);
		}
		if (!p_cBuffer2)
		{
			g_p_stLightProp[iState].fOffset=0.0f;
			iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;
		g_p_stLightProp[iState].fOffset=(float)atof(p_cBuffer)/MAP_COEFF;
	}
	iState++;
}

// MR2812
void fn_vReadCoronaSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer,*p_cBuffer2=NULL;

	if (iState == g_iNbCoronaProps)
	{
		g_a_CoronasProp = (GLCoronaProp *)realloc (g_a_CoronasProp, (++g_iNbCoronaProps)*sizeof(GLCoronaProp));
	}

	strcpy(LkTableCor[iState].szLight,buffer);
	LkTableCor[iState].iLight=iState;

	GetPrivateProfileString("CORONAS",buffer,"-",szBuffer,1024,C_sz_Lightini);
	if (szBuffer)
	{	p_cBuffer=szBuffer;
		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		if (!strcmp(p_cBuffer,"CORONA"))
			g_a_CoronasProp[iState].lighttype=GL_CORONA;
		else
		if (!strcmp(p_cBuffer,"FLARE1"))
			g_a_CoronasProp[iState].lighttype=GL_FLARE1;
		else
			g_a_CoronasProp[iState].lighttype=GL_FLARE2;
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;
		
		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_a_CoronasProp[iState].fRed=(float)atof(p_cBuffer);
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;
		
		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_a_CoronasProp[iState].fGreen=(float)atof(p_cBuffer);
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;

		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_a_CoronasProp[iState].fBlue=(float)atof(p_cBuffer);
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;

		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_a_CoronasProp[iState].fAlpha=(float)atof(p_cBuffer);
		g_a_CoronasProp[iState].fRed*=g_a_CoronasProp[iState].fAlpha;
		g_a_CoronasProp[iState].fGreen*=g_a_CoronasProp[iState].fAlpha;
		g_a_CoronasProp[iState].fBlue*=g_a_CoronasProp[iState].fAlpha;
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;

		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_a_CoronasProp[iState].offsetX=(int)atoi(p_cBuffer);
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;

		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_a_CoronasProp[iState].offsetY=(int)atoi(p_cBuffer);
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;

		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_a_CoronasProp[iState].fDistMin=(float)atof(p_cBuffer);
		//g_a_CoronasProp[iState].fDistMin*=g_a_CoronasProp[iState].fDistMin;
		if (!p_cBuffer2)
		{	
			g_a_CoronasProp[iState].fDistMed=100000.0f;
			iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;
		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_a_CoronasProp[iState].fDistMed=(float)atof(p_cBuffer);
		//g_a_CoronasProp[iState].fDistMed*=g_a_CoronasProp[iState].fDistMed;
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;

		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		g_a_CoronasProp[iState].fDistMax=(float)atof(p_cBuffer);
		//g_a_CoronasProp[iState].fDistMax*=g_a_CoronasProp[iState].fDistMax;
		if (!p_cBuffer2)
		{	iState++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;
	}
	iState++;
}
// End MR2812
void fn_vReadLightingSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer,*p_cBuffer2=NULL;
  int i;

/*	GetPrivateProfileString("LIGHTING",buffer,"-",szBuffer,1024,C_sz_Lightini);
	if (szBuffer[0]!='-')
	{	p_cBuffer2=strpbrk(szBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		states[iState+1].iLightProp=fn_iGetLightId(szBuffer);
		if (states[iState+1].iLightProp==-1)
			printf("Warning: %s light undefined\n",szBuffer);
	}
	else
		states[iState+1].iLightProp=-1;*/
	GetPrivateProfileString("LIGHTING",buffer,"-",szBuffer,1024,C_sz_Lightini);
	states[iState+1].iLightProp=-1;
	states[iState+1].iNbCoronas=0;
	states[iState+1].a_iCoronas=NULL;
	if (szBuffer[0]!='-')
	{	//p_cBuffer=szBuffer;
		p_cBuffer=strstr(szBuffer,"light(");
		if (p_cBuffer)
		{	
			p_cBuffer+=6;
			p_cBuffer2=strpbrk(p_cBuffer,")");
			if (p_cBuffer2)
				p_cBuffer2[0]=0;

			states[iState+1].iLightProp=fn_iGetLightId(LkTable,g_iNbLightProps,p_cBuffer);
			if (states[iState+1].iLightProp==-1)
				Printf(PRINT_HIGH, "\nWarning: %s light undefined\n",szBuffer);

			p_cBuffer2[0]=')';
		}

		p_cBuffer=strstr(szBuffer,"corona(");
		if (p_cBuffer)
		{	p_cBuffer+=7;
			p_cBuffer2=strpbrk(p_cBuffer,",");
			if (p_cBuffer2)
				p_cBuffer2[0]=0;
			states[iState+1].iNbCoronas=atoi(p_cBuffer);
			states[iState+1].a_iCoronas=(int *)malloc(states[iState+1].iNbCoronas*sizeof(int));

			p_cBuffer=p_cBuffer2+1;

			for (i=0;i<states[iState+1].iNbCoronas;i++)
			{
				if (i==states[iState+1].iNbCoronas-1)
					p_cBuffer2=strpbrk(p_cBuffer,")");
				else
					p_cBuffer2=strpbrk(p_cBuffer,",");

				if (p_cBuffer2)
					p_cBuffer2[0]=0;
				states[iState+1].a_iCoronas[i]=fn_iGetLightId(LkTableCor,g_iNbCoronaProps,p_cBuffer);
				if (states[iState+1].a_iCoronas[i]==-1)
					Printf(PRINT_HIGH, "\nWarning: %s corona undefined\n",szBuffer);

				p_cBuffer=p_cBuffer2+1;
			}
		}
	}

	iState++;
}

static int STACK_ARGS lightsortcmp (const void *a, const void *b)
{
	return strcmp (((tdstLkTable *)a)->szLight, ((tdstLkTable *)b)->szLight);
}

void GL_vLoadLightIni()
{ char szBuffer[20480],*p_cBuffer;
  int pDisp=0;

	Printf (PRINT_HIGH,"OpenGL: Init lights");

	if (Args.CheckParm ("-nolight"))
	{
		Printf (PRINT_HIGH, " (skipped)\n");
		return;
	}

	GetCurrentDirectory(255,C_sz_Lightini);
	strcat(C_sz_Lightini,"\\");
	strcat(C_sz_Lightini,C_sz_Lightini0);

	iState=0;
	
	//LkTable=(tdstLkTable *)malloc(NUMSTATES*sizeof(tdstLkTable));	// MR2812
	
	// Read LIGHTS section
	GetPrivateProfileString("LIGHTS","Nb","0",szBuffer,1024,C_sz_Lightini);
	g_iNbLightProps=atoi(szBuffer);
	
	LkTable=(tdstLkTable *)malloc(g_iNbLightProps*sizeof(tdstLkTable));	// MR2812
	g_p_stLightProp=(GLdynamic_prop *)malloc(g_iNbLightProps*sizeof(GLdynamic_prop));
	memset (g_p_stLightProp, 0, g_iNbLightProps*sizeof(GLdynamic_prop));
	
	GetPrivateProfileString("LIGHTS",NULL,"-",szBuffer,1024,C_sz_Lightini);
	p_cBuffer=szBuffer;
	p_cBuffer+=strlen(p_cBuffer)+1;
	while (*p_cBuffer!=0)
	{
		if (iState>=g_iNbLightProps)
			Printf (PRINT_HIGH,"\n Warning: Too much lights in the LIGHTS section\n");
		if (!pDisp)
			Printf (PRINT_HIGH,".");
		pDisp++;
		pDisp&=31;
		fn_vReadLightSection(p_cBuffer);
		p_cBuffer+=strlen(p_cBuffer)+1;
	}

	if (iState < g_iNbLightProps)
	{
		g_iNbLightProps = iState;
	}
	qsort (LkTable, g_iNbLightProps, sizeof(tdstLkTable), lightsortcmp);

	// Read CORONAS section	// MR2812
	iState=0;

	GetPrivateProfileString("CORONAS","Nb","0",szBuffer,1024,C_sz_Lightini);
	g_iNbCoronaProps=atoi(szBuffer);
	
	LkTableCor=(tdstLkTable *)malloc(g_iNbCoronaProps*sizeof(tdstLkTable));	// MR2812
	g_a_CoronasProp=(GLCoronaProp *)malloc(g_iNbCoronaProps*sizeof(GLCoronaProp));
	memset (g_a_CoronasProp, 0, g_iNbCoronaProps*sizeof(GLdynamic_prop));

	GetPrivateProfileString("CORONAS",NULL,"-",szBuffer,1024,C_sz_Lightini);
	p_cBuffer=szBuffer;
	p_cBuffer+=strlen(p_cBuffer)+1;
	while (*p_cBuffer!=0)
	{
		if (iState>=g_iNbCoronaProps)
			Printf (PRINT_HIGH,"\n Warning: Too much coronas in the CORONAS section\n");
		if (!pDisp)
			Printf (PRINT_HIGH,".");
		pDisp++;
		pDisp&=31;
		fn_vReadCoronaSection(p_cBuffer);
		p_cBuffer+=strlen(p_cBuffer)+1;
	}

	if (iState < g_iNbCoronaProps)
	{
		g_iNbCoronaProps = iState;
	}
	qsort (LkTableCor, g_iNbCoronaProps, sizeof(tdstLkTable), lightsortcmp);

	// Read LIGHTING section
	iState=0;

	states[0].iLightProp=-1;
	GetPrivateProfileString("LIGHTING",NULL,"-",szBuffer,20480,C_sz_Lightini);
	p_cBuffer=szBuffer;
	p_cBuffer+=strlen(p_cBuffer)+1;
	while (*p_cBuffer!=0)
	{
		if (!pDisp)
			Printf (PRINT_HIGH,".");
		pDisp++;
		pDisp&=31;
		fn_vReadLightingSection(p_cBuffer);
		p_cBuffer+=strlen(p_cBuffer)+1;
	}

	free(LkTable);
	free(LkTableCor);

	Printf (PRINT_HIGH,"\n");
}

// ---------------------------------------------------------------------------------
// CORONAS
// ---------------------------------------------------------------------------------

#ifdef DOOM
// MR2812
/*#define NB_LIGHT_SOURCES	14
GLCoronaProp g_a_CoronasProp[NB_LIGHT_SOURCES]=
	{ 	// Distances (last 3 values) for MAP_COEFF = 100
		// For another MAP_COEFF: value * = 100/MAP_COEFF
		{ MT_MISC49  , GL_CORONA, 1.0f,0.90f,0.50f,0.3f, -1, 17,0.5f,10.0f,10.00f },
		{ MT_MISC50  , GL_CORONA, 1.0f,0.90f,0.50f,0.3f,-10, 55,0.5f,10.0f,10.00f },
		{ MT_MISC50  , GL_CORONA, 1.0f,0.99f,0.50f,0.3f,  0, 60,0.5f,10.0f,10.00f },
		{ MT_MISC50  , GL_CORONA, 1.0f,0.90f,0.50f,0.3f, 10, 55,0.5f,10.0f,10.00f },
		{ MT_MISC41  , GL_CORONA,0.13f,0.25f,1.00f,0.5f,  0, 57,1.0f,5.0f,10.0f },
		{ MT_MISC42  , GL_CORONA,0.25f,1.00f,0.25f,0.5f,  0, 57,1.0f,5.0f,10.0f },
		{ MT_MISC43  , GL_CORONA, 1.0f,0.45f,0.13f,0.5f,  0, 57,1.5f,4.5f,10.0f },
		{ MT_MISC44  , GL_CORONA,0.13f,0.25f,1.00f,0.5f,  0, 35,1.5f,4.5f,10.0f },
		{ MT_MISC45  , GL_FLARE,0.25f,1.00f,0.25f,0.5f,  0, 35,1.5f,4.5f,10.0f },
		{ MT_MISC46  , GL_CORONA, 1.0f,0.45f,0.13f,0.5f,  0, 35,1.0f,5.0f,10.0f },
		{ MT_MISC77  , GL_CORONA, 1.0f,0.99f,0.50f,0.3f,  0, 35,1.7f,4.0f,8.00f },
		{ MT_MISC29  , GL_CORONA, 1.0f,1.00f,1.00f,0.8f,  0, 70,1.0f,4.0f,10.0f },
		{ MT_MISC30  , GL_CORONA, 1.0f,1.00f,1.00f,0.8f,  1, 52,1.0f,4.0f,10.0f },
		{ MT_MISC31  , GL_CORONA, 1.0f,1.00f,1.00f,0.6f, -2, 40,0.5f,5.0f,10.0f },
};
*/
#elif GL_HEXEN
#define NB_LIGHT_SOURCES	13
GLCoronaProp g_a_CoronasProp[NB_LIGHT_SOURCES]=
	{ 	
		/*{ 8061, 1.0f,0.80f,0.40f,0.5f,0.5f,  35,0.70f,2.00f,4.0f },
		{ 8066, 0.3f,0.78f,0.97f,0.3f,   3,  24,0.40f,3.10f,5.0f },
		{ 17  , 1.0f,0.60f,0.30f,0.3f, -19,  22,0.25f, 5.0f,5.0f },
		{ 17  , 1.0f,0.60f,0.30f,0.3f,  -2,  27,0.25f, 5.0f,5.0f },
		{ 17  , 1.0f,0.60f,0.30f,0.3f, 4.5f,  20,0.25f, 5.0f,5.0f },
		{ 17  , 1.0f,0.60f,0.30f,0.3f,  22,  24,0.25f, 5.0f,5.0f },
		{ 119 , 1.0f,0.70f,0.30f,0.3f,  -5,  10,0.25f, 5.0f,5.0f },
		{ 119 , 1.0f,0.70f,0.30f,0.3f,   0,  15,0.25f, 5.0f,5.0f },
		{ 119 , 1.0f,0.70f,0.30f,0.3f,   7,   8,0.25f, 5.0f,5.0f },
		{ 8042, 1.0f,0.80f,0.40f,0.48f,  0,  27,0.70f,2.00f,4.0f },
		{ 8060, 1.0f,0.70f,0.36f,0.45f,  2,  25,0.57f,2.50f,4.5f },
		{ 116 , 1.0f,0.70f,0.36f,0.45f,  2,  60,0.77f,2.20f,3.8f },
		{ 54  , 0.9f,0.80f,0.40f,0.5f,1.0f,  30,0.50f,2.60f,4.5f },*/
		{ MT_BRASSTORCH  , GL_CORONA, 1.0f,0.80f,0.40f,0.5f,0.5f,  35,0.70f,2.00f,4.0f },
		{ MT_ZBLUE_CANDLE, GL_CORONA, 0.3f,0.78f,0.97f,0.3f,   3,  24,0.40f,3.10f,5.0f },
		{ MT_MISC5       , GL_CORONA, 1.0f,0.60f,0.30f,0.3f, -19,  22,0.25f, 5.0f,5.0f },
		{ MT_MISC5       , GL_CORONA, 1.0f,0.60f,0.30f,0.3f,  -2,  27,0.25f, 5.0f,5.0f },
		{ MT_MISC5       , GL_CORONA, 1.0f,0.60f,0.30f,0.3f, 4.5f,  20,0.25f, 5.0f,5.0f },
		{ MT_MISC5       , GL_CORONA, 1.0f,0.60f,0.30f,0.3f,  22,  24,0.25f, 5.0f,5.0f },
		{ MT_MISC79      , GL_CORONA, 1.0f,0.70f,0.30f,0.3f,  -5,  10,0.25f, 5.0f,5.0f },
		{ MT_MISC79      , GL_CORONA, 1.0f,0.70f,0.30f,0.3f,   0,  15,0.25f, 5.0f,5.0f },
		{ MT_MISC79      , GL_CORONA, 1.0f,0.70f,0.30f,0.3f,   7,   8,0.25f, 5.0f,5.0f },
		{ MT_ZFIREBULL   , GL_CORONA, 1.0f,0.80f,0.40f,0.48f,  0,  27,0.70f,2.00f,4.0f },
		{ MT_FIRETHING   , GL_CORONA, 1.0f,0.70f,0.36f,0.45f,  2,  25,0.57f,2.50f,4.5f },
		{ MT_ZTWINEDTORCH, GL_CORONA, 1.0f,0.70f,0.36f,0.45f,  2,  60,0.77f,2.20f,3.8f },
		{ MT_ZWALLTORCH  , GL_CORONA, 0.9f,0.80f,0.40f,0.5f,1.0f,  30,0.50f,2.60f,4.5f },
	};
#else
#define NB_LIGHT_SOURCES	11
GLCoronaProp g_a_CoronasProp[NB_LIGHT_SOURCES]=
	{ 	
		{ MT_SERPTORCH   , GL_CORONA, 1.0f,0.90f,0.50f,0.5f,   0,  50,0.35f,2.90f,5.0f },
		{ MT_CHANDELIER  , GL_CORONA, 1.0f,0.60f,0.30f,0.3f, -22,  19,0.25f, 5.0f,5.0f },
		{ MT_CHANDELIER  , GL_CORONA, 1.0f,0.60f,0.30f,0.3f, -17,  16,0.25f, 5.0f,5.0f },
		{ MT_CHANDELIER  , GL_CORONA, 1.0f,0.60f,0.30f,0.3f, -10,  20,0.25f, 5.0f,5.0f },
		{ MT_CHANDELIER  , GL_CORONA, 1.0f,0.60f,0.30f,0.3f,   3,  17,0.25f, 5.0f,5.0f },
		{ MT_CHANDELIER  , GL_CORONA, 1.0f,0.60f,0.30f,0.3f,   8,  20,0.25f, 5.0f,5.0f },
		{ MT_CHANDELIER  , GL_CORONA, 1.0f,0.60f,0.30f,0.3f,  14,  16,0.25f, 5.0f,5.0f },
		{ MT_CHANDELIER  , GL_CORONA, 1.0f,0.60f,0.30f,0.3f,  21,  19,0.25f, 5.0f,5.0f },
		{ MT_MISC10      , GL_CORONA, 0.9f,0.80f,0.40f,0.5f,   0,  77,0.50f,2.60f,5.0f },
		{ MT_MISC6       , GL_CORONA, 1.0f,0.80f,0.40f,0.5f,   0,  45,0.70f,2.00f,4.0f }, 
		{ MT_MISC12      , GL_CORONA, 1.0f,0.50f,0.20f,0.5f,   0,  20,0.50f,2.50f,5.0f } };
#endif

extern fixed_t		shootz;	
extern fixed_t		attackrange;
extern fixed_t		aimslope;
extern mobj_t *shootthing;
extern fixed_t	topslope;
extern fixed_t	bottomslope;	

extern GLuint *texobjs;

mobj_t *lamp;

#define MAX_CORONAS 50
GLCorona p_stCorona[MAX_CORONAS];
int iCoronaIndex=0;

unsigned char *g_p_bCoronaTexture;
unsigned char *g_p_bLightTexture;

// ---------------------------------------------------------------------------------
// CORONAS: Inits
// ---------------------------------------------------------------------------------
void fn_vLoadRAWFile(char *szFileName,unsigned char *Texture,int width,int height)
{ FILE *hFile;
  unsigned char *buffer;
  int x,y;

    buffer=(unsigned char *)malloc(width*height);
	hFile=fopen(szFileName,"rb");
	if (!hFile)
		I_Error("Could not open file %s\n",szFileName);
	fread(buffer,1,width*height,hFile);
	fclose(hFile);
	for (x=0;x<width;x++)
	for (y=0;y<height;y++)
	{	if (buffer[(y*width+x)]<40)
			buffer[(y*width+x)]=0;	// a voir...
		//if ((y==0)||(x==0)||(y==height-1)||(x==width-1))
		//	buffer[(y*width+x)]=0;
		Texture[4*(y*width+x)]=buffer[(y*width+x)];
		Texture[4*(y*width+x)+1]=buffer[(y*width+x)];
		Texture[4*(y*width+x)+2]=buffer[(y*width+x)];
		Texture[4*(y*width+x)+3]=buffer[(y*width+x)];
	}
	free(buffer);
}
#if 0	// For corona.raw
void fn_vLoadRAWFile(char *szFileName,unsigned char *Texture,int width,int height)
{ FILE *hFile;
  unsigned char *buffer;
  int x,y;

    buffer=(unsigned char *)malloc(width*height*3);
	hFile=fopen(szFileName,"rb");
	if (!hFile)
		I_Error("Could not open file %s\n",szFileName);
	fread(buffer,1,width*height*3,hFile);
	fclose(hFile);
	for (x=0;x<width;x++)
	for (y=0;y<height;y++)
	{	if (buffer[(y*width+x)]<40)
			buffer[(y*width+x)]=0;	// a voir...
		Texture[4*(y*width+x)]=buffer[3*(y*width+x)];
		Texture[4*(y*width+x)+1]=buffer[3*(y*width+x)+1];
		Texture[4*(y*width+x)+2]=buffer[3*(y*width+x)+2];
		Texture[4*(y*width+x)+3]=buffer[3*(y*width+x)];
	}
	free(buffer);
}
#endif	// 0

void GL_LoadCoronaTexture()
{ int x,y;
  // MR2812
  unsigned char *p_bBuffer;
	
	p_bBuffer=(unsigned char *)malloc(128*128*4);	
	fn_vLoadRAWFile("haze.raw",p_bBuffer,128,128);

    g_p_bCoronaTexture=(unsigned char *)glMalloc(128*128*4);
	//g_p_bCoronaTexture=(unsigned char *)glMalloc(8*8*4);
	memcpy(g_p_bCoronaTexture,p_bBuffer,128*128*4);
	/*for (x=0;x<8;x++)
	for (y=0;y<8;y++)
	{
		g_p_bCoronaTexture[4*(x+y*8)]=255;
		g_p_bCoronaTexture[4*(x+y*8)+1]=255;
		g_p_bCoronaTexture[4*(x+y*8)+2]=255;
		g_p_bCoronaTexture[4*(x+y*8)+3]=p_bBuffer[4*(16*x+8+(y*16+8)*128)+3];
	}*/
	
	//g_p_bLightTexture=(unsigned char *)glMalloc(8*8*4);
	g_p_bLightTexture=(unsigned char *)glMalloc(128*128*4);
	//memcpy(g_p_bLightTexture,p_bBuffer,128*128*4);
	for (x=0;x<128;x++)
	for (y=0;y<128;y++)
	{ unsigned char col;

		if ((y==0)||(x==0)||(y==127)||(x==127))
			col=0;
		else
			col=255;
		g_p_bLightTexture[4*(x+y*128)]=255;
		g_p_bLightTexture[4*(x+y*128)+1]=255;
		g_p_bLightTexture[4*(x+y*128)+2]=255;
		g_p_bLightTexture[4*(x+y*128)+3]=p_bBuffer[4*(x+y*128)+3];
	}
	/*for (x=0;x<8;x++)
	for (y=0;y<8;y++)
	{
		g_p_bLightTexture[4*(x+y*8)]=255;
		g_p_bLightTexture[4*(x+y*8)+1]=255;
		g_p_bLightTexture[4*(x+y*8)+2]=255;
		g_p_bLightTexture[4*(x+y*8)+3]=p_bBuffer[4*(16*x+8+(y*16+8)*128)+3];
	}*/

	free(p_bBuffer);
}

// ---------------------------------------------------------------------------------
// CORONAS: Drawing
// ---------------------------------------------------------------------------------

//GLint GL_iGetDoomednum(int index)	// MR2007
mobjtype_t GL_iGetType(int index)
{
	//return g_a_CoronasProp[index].type;
	return (mobjtype_t)0;	// MR2812
}

GLint GL_GenerateCorona(int doomednum)
{// MR2812
/* int i;

	for (i=0;i<NB_LIGHT_SOURCES;i++)
		if (doomednum==g_a_CoronasProp[i].type)
			return i;*/
	return -1;
}

void glCoronaColor(float r,float g,float b,float a,float light)
{
	//glColor4f(r/**light*/,g/**light*/,b/**light*/,a/**light*/);
	glColor4f(r/**light*/,g/**light*/,b/**light*/,a/**0.3f*/);
}

void GL_vDoFlares(GLfloat x, GLfloat y, GLfloat z, GLfloat angle, GLfloat near_clip,GLCoronaProp *CoronaProp,GLfloat fDistance);

void GL_DrawCoronas(player_t *player)
{ float fWidthL;
  int i;
  float fDistance,fdx,fdy;
  mobj_t *mobj;

//#ifdef DOOM_GL
	//float fWidth1=(float)64/(MAP_SCALE>>FRACBITS);
	//float fStencilWidth=(float)1/(MAP_SCALE>>FRACBITS);
	float fWidth1=(float)64/MAP_COEFF;
//	float fStencilWidth=(float)1/MAP_COEFF;
//	static GLbyte *StencilBuffer=NULL;
	//static GLfloat *DepthBuffer=NULL;

	
/*	if (!StencilBuffer)
		StencilBuffer=(GLbyte *)malloc(SCREENWIDTH*SCREENHEIGHT);

	//if (!DepthBuffer)
	//	DepthBuffer=(GLfloat *)malloc(sizeof(GLfloat)*SCREENWIDTH*SCREENHEIGHT);
	
	// No stencil buffer on 3dfx... Unusable...
	glEnable(GL_STENCIL_TEST);
	glClearStencil(1);
	glClear(GL_STENCIL_BUFFER_BIT);
	glStencilOp (GL_KEEP, GL_ZERO, GL_KEEP);
	glStencilFunc (GL_ALWAYS, 0x1, 0x1);

	// 1st pass: set stencil buffer
	for (i=0;i<iCoronaIndex;i++)
	{
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glTranslatef(p_stCorona[i].x,p_stCorona[i].y,p_stCorona[i].z);

		glBegin(GL_QUADS);
			GL_StaticLight3f(1.0f,1.0f,1.0f);
			glVertex3f( -fStencilWidth, -fStencilWidth, 0);
			glVertex3f( -fStencilWidth, fStencilWidth, 0);
			glVertex3f( fStencilWidth, fStencilWidth, 0);
			glVertex3f( fStencilWidth, -fStencilWidth, 0);
		glEnd();

		glPopMatrix();
	}

	glReadPixels(0,0,SCREENWIDTH,SCREENHEIGHT,GL_STENCIL_INDEX,GL_BYTE,StencilBuffer);

	glDisable(GL_STENCIL_TEST);*/
	
	//glReadPixels(0,0,SCREENWIDTH,SCREENHEIGHT,GL_DEPTH_COMPONENT,GL_FLOAT,DepthBuffer);

	/*{ int x,y;
		for (x=0;x<SCREENWIDTH;x++)
		for (y=0;y<SCREENHEIGHT;y++)
			if (StencilBuffer[x+y*SCREENWIDTH]!=1)
				printf("prout");
	}*/

	if (player->cheats & CF_CHASECAM)
		mobj=camera;		
	else
		mobj=player->mo;

	//glBindTexture(GL_TEXTURE_2D, g_iCorona);
	glBindTexture(GL_TEXTURE_2D, g_iParticle);

	/*glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER,0.2);*/
	glDepthFunc(GL_ALWAYS);
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE);

	for (i=0;i<iCoronaIndex;i++)
	{ GLboolean bDrawCorona=false;
	  GLCoronaProp *CoronaProp;
		
// stencil test...
/*		for (j=0;j<p_stCorona[i].iNbVertices;j++)
		{	
			//glReadPixels(p_stCorona[i].xV[j],p_stCorona[i].yV[j],1,1,GL_DEPTH_COMPONENT,GL_FLOAT,DepthBuffer);
			if (StencilBuffer[p_stCorona[i].xV[j]+SCREENWIDTH*p_stCorona[i].yV[j]])
			{	bDrawCorona=true;
			}
		}
		
		if (!bDrawCorona)
			continue;*/

		//CoronaProp=&g_a_CoronasProp[p_stCorona[i].doomednum];
		CoronaProp=&g_a_CoronasProp[p_stCorona[i].type];

		fdx=(float)(-mobj->x)/MAP_SCALE-p_stCorona[i].x;
		fdy=(float)(mobj->y)/MAP_SCALE-p_stCorona[i].z;
		fDistance=(float)sqrt(fdx*fdx+fdy*fdy);
		//fDistance=fdx*fdx+fdy*fdy;
		
		// MR2812
		if (CoronaProp->lighttype != GL_CORONA)
		{	GL_vDoFlares(p_stCorona[i].x,p_stCorona[i].y,p_stCorona[i].z,-90.0f+(float)(mobj->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES,1.0f,CoronaProp,fDistance);
			continue;
		}
		else
		{	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			glBindTexture(GL_TEXTURE_2D, g_iParticle);
		}

		fWidthL=fWidth1;
		
		/*if (fDistance<5.0f)
			fWidthL*=fDistance/5.0f;*/
		if (fDistance<CoronaProp->fDistMin)
			fWidthL*=CoronaProp->fDistMin/CoronaProp->fDistMed;
		else
		if (fDistance<CoronaProp->fDistMax/2)
			fWidthL*=fDistance/CoronaProp->fDistMed;
		else
			fWidthL*=(CoronaProp->fDistMax/2)/CoronaProp->fDistMed;

		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glTranslatef(p_stCorona[i].x,p_stCorona[i].y,p_stCorona[i].z);
		glRotatef(-90.0f+(float)(mobj->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES,   0.0f, 1.0f, 0.0f);
		//if (fn_bRotateSprite(CoronaProp->doomednum))
			glRotatef((float)(mobj->pitch>>ANGLETOFINESHIFT)*360.0f/(FINEANGLES*2),   1.0f, 0.0f, 0.0f);
		//glTranslatef((float)CoronaProp->offsetX/(MAP_SCALE>>FRACBITS),0.0f,0.0f);
		glTranslatef((float)CoronaProp->offsetX/MAP_COEFF,0.0f,0.0f);
		glBegin(GL_QUADS);
/*#ifdef DOOM_GL
			if (player->fixedcolormap)
				GL_StaticLight4f(CoronaProp->fRed,CoronaProp->fGreen,CoronaProp->fBlue,CoronaProp->fAlpha);
			else
#endif
				//glColor4f(CoronaProp->fRed,CoronaProp->fGreen,CoronaProp->fBlue,CoronaProp->fAlpha);
				glCoronaColor(CoronaProp->fRed,CoronaProp->fGreen,CoronaProp->fBlue,CoronaProp->fAlpha,p_stCorona[i].fLightLevel);*/
			//GL_StaticLight4f(CoronaProp->fRed,CoronaProp->fGreen,CoronaProp->fBlue,CoronaProp->fAlpha);
			glCoronaColor(CoronaProp->fRed,CoronaProp->fGreen,CoronaProp->fBlue,CoronaProp->fAlpha,p_stCorona[i].fLightLevel);

			glTexCoord2f(0.0f, 0.0f); glVertex3f( -fWidthL, -fWidthL, 0.0f);
			glTexCoord2f(0.0f, 1.0f); glVertex3f( -fWidthL, fWidthL, 0.0f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f( fWidthL, fWidthL, 0.0f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f( fWidthL, -fWidthL, 0.0f);
		glEnd();

		glPopMatrix();
	}

	glDisable(GL_BLEND);
	glDepthFunc(GL_LESS);

	//glDisable(GL_ALPHA_TEST);
	iCoronaIndex=0;
//#endif
}

void GL_AddCorona(int doomednum,float x,float y,float z,float fLightLevel)
{
	if (iCoronaIndex<MAX_CORONAS)
	{	p_stCorona[iCoronaIndex].x=x/*+(float)g_a_CoronasProp[doomednum].offsetX/(MAP_SCALE>>FRACBITS)*/;
		//p_stCorona[iCoronaIndex].y=y+(float)g_a_CoronasProp[doomednum].offsetY/(MAP_SCALE>>FRACBITS);
		p_stCorona[iCoronaIndex].y=y+(float)g_a_CoronasProp[doomednum].offsetY/MAP_COEFF;
		p_stCorona[iCoronaIndex].z=z;
		p_stCorona[iCoronaIndex].fLightLevel=fLightLevel;
		//p_stCorona[iCoronaIndex++].type=(mobjtype_t)doomednum;
		p_stCorona[iCoronaIndex++].type=doomednum;
	}
}

// ---------------------------------------------------------------------------------
// CORONAS: Clipping
// ---------------------------------------------------------------------------------


BOOL PTR_LightTraverse (intercept_t* in)
{
    mobj_t*		th;

    fixed_t		dist;
    fixed_t		thingtopslope;
    fixed_t		thingbottomslope;
		
    if (in->isaline)
    {
	// MR1106
	/*li = in->d.line;
	
	if (li->special)
	    P_ShootSpecialLine (shootthing, li);

	if ( !(li->flags & ML_TWOSIDED) )
	    goto hitline;
	
	// crosses a two sided line
	P_LineOpening (li);
		
	dist = FixedMul (attackrange, in->frac);

	if (li->frontsector->floorheight != li->backsector->floorheight)
	{
	    slope = FixedDiv (openbottom - shootz , dist);
	    if (slope > aimslope)
		goto hitline;
	}
		
	if (li->frontsector->ceilingheight != li->backsector->ceilingheight)
	{
	    slope = FixedDiv (opentop - shootz , dist);
	    if (slope < aimslope)
		goto hitline;
	}*/

	// shot continues
	return true;
	
	
	// hit line
/*      hitline:
		return false;	*/
    }
    
    // shoot a thing
    th = in->d.thing;
    if ((th == shootthing)||(th == lamp))
	return true;		// can't shoot self
    		
    // check angles to see if the thing can be aimed at
    dist = FixedMul (attackrange, in->frac);
    thingtopslope = FixedDiv (th->z+th->height - shootz , dist);

    if (thingtopslope < aimslope)
	return true;		// shot over the thing

    thingbottomslope = FixedDiv (th->z - shootz, dist);

    if (thingbottomslope > aimslope)
	return true;		// shot under the thing

    
    // hit thing
    return false;	
}

int offsetZ;

BOOL PTR_GetLightSlope (intercept_t* in)
{
    line_t*		li;
    mobj_t*		th;
    fixed_t		slope;
    fixed_t		thingslope;
    fixed_t		dist;
		
    if (in->isaline)
    {
	li = in->d.line;
	
	if ( !(li->flags & ML_TWOSIDED) )
	    return false;		// stop
	
	// Crosses a two sided line.
	// A two sided line will restrict
	// the possible target ranges.
	P_LineOpening (li);
	
// MR1105
/*	if (openbottom >= opentop)
	    return false;		// stop*/
	
	dist = FixedMul (attackrange, in->frac);

	if (li->frontsector->floorheight != li->backsector->floorheight)
	{
	    slope = FixedDiv (openbottom - shootz , dist);
	    if (slope > bottomslope)
		bottomslope = slope;
	}
		
	if (li->frontsector->ceilingheight != li->backsector->ceilingheight)
	{
	    slope = FixedDiv (opentop - shootz , dist);
	    if (slope < topslope)
		topslope = slope;
	}
		
	if (topslope <= bottomslope)
	    return false;		// stop
			
	return true;			// shot continues
    }
    
    // shoot a thing
    th = in->d.thing;
    if (th == shootthing)
	return true;			// can't shoot self
    
	if (th!=lamp)
		return true;

    // check angles to see if the thing can be aimed at
    dist = FixedMul (attackrange, in->frac);
	//thingslope=FixedDiv (th->z/*+offsetZ*/ - shootz , dist);
	thingslope=FixedDiv (th->z+offsetZ - shootz , dist);
    
	if ((thingslope < bottomslope)||(thingslope > topslope))
		return true;

	aimslope=thingslope;
    linetarget = th;

    return false;			// don't go any farther
}

fixed_t
GL_GetSlopeForCorona
( mobj_t*	t1,
  /*mobj_t*	t2*/
  fixed_t   LightX,
  fixed_t   LightY  )
{

    shootthing = t1;
    
    ////shootz = t1->z + (t1->height>>1) + 8*FRACUNIT;
	//shootz = t1->z + t1->height /*- (t1->height>>2)*/;
	shootz = t1->z+VIEWHEIGHT;

    // can't shoot outside view angles
/*    topslope = 100*FRACUNIT/160;	
    bottomslope = -100*FRACUNIT/160;*/
    topslope = 300*FRACUNIT/160;	
    bottomslope = -300*FRACUNIT/160;
    
    attackrange = MISSILERANGE;
    linetarget = NULL;
	
    P_PathTraverse ( t1->x, t1->y,
		     LightX, LightY,
		     PT_ADDLINES|PT_ADDTHINGS,
		     PTR_GetLightSlope );
		
    if (linetarget)
	return aimslope;

    return 0;
}

H_boolean GL_ChechCoronaInSight(int iIndex,mobj_t *t1, mobj_t *t2)		// t1=player / t2=light source
{ fixed_t lightX,lightY;

    lightX=t2->x/*+(g_a_CoronasProp[iIndex].offsetX<<FRACBITS)*/;
	lightY=t2->y;
	offsetZ=(g_a_CoronasProp[iIndex].offsetY<<FRACBITS);
	
	lamp=t2;
	aimslope=GL_GetSlopeForCorona(t1,lightX,lightY);
	//if (!linetarget)
	//	return false;
	
	//shootz = t1->z + t1->height/* - (t1->height>>2)*/;
	shootz = t1->z+VIEWHEIGHT;
    //aimslope = (t2->z/*+offsetZ*/) - shootz;
	//aimslope = 0;
	attackrange = MISSILERANGE;
	shootthing = t1;
	//lamphit=false;

	if (P_PathTraverse(t1->x,t1->y,lightX,lightY,PT_ADDLINES|PT_ADDTHINGS2,PTR_LightTraverse))
		return true;
	return false;
}

#if 0
// Select buffer...
/*#define MAX_CORONAS 50
extern GLCorona p_stCorona[MAX_CORONAS];
extern int iCoronaIndex;*/

void GL_HitCoronas(player_t *player)
{ float fWidthL,fWidth1;
  int i;
  float fDistance,fdx,fdy;

//#ifdef DOOM_GL
	//fWidth1=(float)1/(MAP_SCALE>>FRACBITS);
	fWidth1=(float)1/MAP_COEFF;
		
	for (i=0;i<iCoronaIndex;i++)
	{
		fWidthL=fWidth1;
		
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glTranslatef(p_stCorona[i].x,p_stCorona[i].y,p_stCorona[i].z);
		/*glRotatef(-90.0f+(float)(player->mo->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES,   0.0f, 1.0f, 0.0f);
		glRotatef(-(float)player->lookdir/2,   1.0f, 0.0f, 0.0f);*/

		//glLoadName(i+1);		// select buffer
		glPassThrough(2*i);		// feedback buffer

		glBegin(GL_QUADS);
			glColor3f(1.0f,0.0f,0.0f);
			glVertex3f( -fWidthL, -fWidthL, 0);
			glVertex3f( -fWidthL, fWidthL, 0);
			glVertex3f( fWidthL, fWidthL, 0);
			glVertex3f( fWidthL, -fWidthL, 0);
		glEnd();

		glPassThrough(2*i+1);		// feedback buffer

		glPopMatrix();
	}
//#endif
}

extern float fSkyRadius;
extern GLfloat aspect;

#define BUFSIZE 2048
void _GL_CheckCoronasPresent(float x,float y,float z,float roll,float pitch,float yaw,player_t *player)
{  GLuint selectBuf[BUFSIZE];
   GLint hits;

   glSelectBuffer (BUFSIZE, selectBuf);
   (void) glRenderMode (GL_SELECT);

   glInitNames();
   glPushName(0);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	gluPerspective(65.0, aspect, 0.01, 2*fSkyRadius);

	glRotatef(roll,  0.0f, 0.0f, 1.0f);
	glRotatef(pitch, 1.0f, 0.0f, 0.0f);
	glRotatef(yaw,   0.0f, 1.0f, 0.0f);
	//glRotatef(pitch, 1.0f, 0.0f, 0.0f);
	glTranslatef(x, y, z);

	// Sprites
	glLoadName(51);
	fn_vDrawSprites(player);

	GL_HitCoronas(player);


   hits = glRenderMode (GL_RENDER);
   //processHits (hits, selectBuf);
   printf("prout\n");
}

// Feedback buffer
#define VERTEX_SIZE	2
void processHits(GLint size, GLfloat *buffer)
{
   GLint count,i;
   GLfloat token;
   static int iCoronaID,iVertex;
   H_boolean bPolyDraw,bStartCorona=false;;

   count = size;
   while (count) {
      token = buffer[size-count]; count--;
      if (token == GL_PASS_THROUGH_TOKEN) {
         //printf ("GL_PASS_THROUGH_TOKEN\n");
         //printf ("  %4.2f\n", buffer[size-count]);
		if (!bStartCorona)
		{	bStartCorona=true;
			bPolyDraw=false;
			iCoronaID=(int)buffer[size-count]/2;
			iVertex=0;
		}
		else
		{	bStartCorona=false;
			p_stCorona[iCoronaID].iNbVertices=iVertex;
			/*if (!bPolyDraw)
				p_stCorona[iCoronaID].bDrawCorona=0;
			else
				p_stCorona[iCoronaID].bDrawCorona=1;*/
		}
         count--;
      }
      else if ((token == GL_POINT_TOKEN)||
				(token == GL_BITMAP_TOKEN) ||
				(token == GL_DRAW_PIXEL_TOKEN) ||
				(token == GL_COPY_PIXEL_TOKEN))
	   {
         //printf ("GL_POINT_TOKEN\n");
         //print3DcolorVertex (size, &count, buffer);
		 count-=VERTEX_SIZE;
      }
      else if (token == GL_LINE_TOKEN) {
         //printf ("GL_LINE_TOKEN\n");
         //print3DcolorVertex (size, &count, buffer);
         //print3DcolorVertex (size, &count, buffer);
		 count-=2*VERTEX_SIZE;
      }
      else if (token == GL_LINE_RESET_TOKEN) {
         //printf ("GL_LINE_RESET_TOKEN\n");
         //print3DcolorVertex (size, &count, buffer);
         //print3DcolorVertex (size, &count, buffer);
		 count-=6;
      }
      else if (token == GL_POLYGON_TOKEN) {
         float nbV;
		 
		 //printf ("GL_POLYGON_TOKEN\n");
         //print3DcolorVertex (size, &count, buffer);
         //print3DcolorVertex (size, &count, buffer);
		 nbV=buffer[size-count--];
		 for (i=0;i<nbV;i++)
		 {	p_stCorona[iCoronaID].xV[iVertex]=(int)buffer[size-count--];
			p_stCorona[iCoronaID].yV[iVertex++]=(int)buffer[size-count--];
		}
		 /*count-=(int)nbV*VERTEX_SIZE;
		 bPolyDraw=true;*/
      }
   }
}


void GL_CheckCoronasPresent(float x,float y,float z,float roll,float pitch,float yaw,player_t *player)
{  GLfloat selectBuf[BUFSIZE];
   GLint hits;

   glFeedbackBuffer (BUFSIZE, GL_2D, selectBuf);
   (void) glRenderMode (GL_FEEDBACK);


	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	gluPerspective(65.0, aspect, 0.01, 2*fSkyRadius);

	glRotatef(roll,  0.0f, 0.0f, 1.0f);
	glRotatef(pitch, 1.0f, 0.0f, 0.0f);
	glRotatef(yaw,   0.0f, 1.0f, 0.0f);
	//glRotatef(pitch, 1.0f, 0.0f, 0.0f);
	glTranslatef(x, y, z);

	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);

	// Sprites
	fn_vDrawSprites(player);

	GL_HitCoronas(player);


   hits = glRenderMode (GL_RENDER);
   processHits (hits, selectBuf);
   //printf("prout\n");
}

#endif	// 0

#endif	// ZDOOM_GL