#ifdef ZDOOM_GL

//#define __DOOMTYPE__

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <windows.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "gl_struct.h"
#include "gl_mem.h"
#include "gl_priv.h"
#ifndef GL_HEXEN
#include "doomdef.h"
#else
#include "h2def.h"
#endif
#include "r_local.h"

#ifdef GL_HEXEN
#define F_SKY	"F_SKY"
extern int GL_Sky1Texture,GL_Sky2Texture;
char GLCurrentSky;
#else
#define F_SKY	"F_SKY1"
#endif

extern lumpinfo_t	*lumpinfo;		// location of each lump on disk
extern GLTexture *p_stGLTextures;
extern GLTexArray *p_stGLTexArray;

extern GLuint *texobjs;

extern int *a_iGlDrawLine,*a_iGlDrawFloorCeil;

extern int *a_iGLTexTranslation;

extern level_locals_t level;

//FloorCeilVertexesArray *a_stFloorVertexesArray;
//GLFloorCeilPolygon *a_stFCPolygons;
GLFloorCeilingPolygonArray *a_stFCPolygonArray;
GLbyte **a_bFirstPass;

int iXMin,iXMax,iYMin,iYMax;
int xMapMin=0x7fffffff,xMapMax=-0x7fffffff,yMapMin=0x7fffffff,yMapMax=-0x7fffffff,iAltitudeMin=0x7fffffff,iAltitudeMax=-0x7fffffff;
int iLightLevelMin=0xffff,iLightLevelMax=-0xffff;

GLFloorCeiling *a_stFloorCeiling;
//int startCeilingList,startFloorList;
int *a_iLineArray,*a_iLinePresent;

//GLboolean bFloorCompute;
int iCurrentSector/*,iNbPoints*/;

float fSkyRadius;
int iSkyList;
#ifdef GL_HEXEN
int iSkyList1,iSkyList2;
fixed_t Sky1ColumnOffset;
fixed_t Sky2ColumnOffset;
#endif

HANDLE hVertexTmpHeap;

/*typedef struct GLUtesselator GLUtriangulatorObj;
#define gluTessBeginPolygon(x,y) gluBeginPolygon(x)
#define gluTessEndPolygon gluEndPolygon
#define gluTessBeginContour
#define gluTessEndContour(x) gluNextContour(x,GLU_UNKNOWN)
*/
int g_iSector;

#ifndef DOOM_GL
H_boolean modifiedgame;
#endif
void CALLBACK errorCallback(GLenum errorCode)
{
   const GLubyte *estring;

   estring = gluErrorString(errorCode);
   fprintf(stderr, "Tessellation Error: %s in sector %l\n", estring,g_iSector);
   if (!modifiedgame)
		exit(0);
}


int fn_iGetUpperLeftLine(int *a_iLineArray,int *a_iLinePresent,int iNbLines,int sector)
{ int i=0,iRet=-1,xMin,yMax,x,y;
  GLboolean bBadSens;
	
	xMin=0x7fffffff;
	yMax=-0x7fffffff;
	iXMin=0x7fffffff;
	iYMin=0x7fffffff;
	iXMax=-0x7fffffff;
	iYMax=-0x7fffffff;

	for (i=0;i<iNbLines;i++)
	{	//if (a_iLineArray[i]==-1)
		if (!a_iLinePresent[i])
			continue;
			//goto mapbound;

		x=-lines[a_iLineArray[i]].v1->x;
		y=lines[a_iLineArray[i]].v1->y;
		
		if ((y==yMax)&&bBadSens&&(lines[a_iLineArray[i]].frontsector->iSectorID==sector))
		{	yMax=y;
			iRet=i;
			bBadSens=false;
		}

		//if ((x<=xMin)&&(y>=yMax))
		if (/*(x<=xMin)||*/(y>yMax))
		{	xMin=x;
			yMax=y;
			iRet=i;
			if (lines[a_iLineArray[i]].frontsector->iSectorID==sector)
				bBadSens=false;
			else
				bBadSens=true;
		}

		x=-lines[a_iLineArray[i]].v2->x;
		y=lines[a_iLineArray[i]].v2->y;

		if ((y==yMax)&&bBadSens&&lines[a_iLineArray[i]].frontsector->iSectorID==sector)
		{	yMax=y;
			iRet=i;
			bBadSens=false;
		}
		
		//if ((x<=xMin)&&(y>=yMax))
		if (/*(x<=xMin)||*/(y>yMax))
		{	xMin=x;
			yMax=y;
			iRet=i;
			if (lines[a_iLineArray[i]].frontsector->iSectorID==sector)
				bBadSens=false;
			else
				bBadSens=true;
		}
		if (x<iXMin)
			iXMin=x;
		if (x>iXMax)
			iXMax=x;
		if (y<iYMin)
			iYMin=y;
		if (y>iYMax)
			iYMax=y;

/*mapbound:
		if (x<xMapMin)
			xMapMin=x;
		if (x>xMapMax)
			xMapMax=x;
		if (y<yMapMin)
			yMapMin=y;
		if (y>yMapMax)
			yMapMax=y;*/
	}
	return iRet;
}

GLfloat *fn_p_fVertex(GLdouble *p_dVertex/*,GLfloat fLightLevel*/)
{ GLfloat *p_fVertex;

	//p_fVertex=(GLfloat *)malloc(sizeof(GLfloat)*4);
	p_fVertex=(GLfloat *)HeapAlloc(hVertexTmpHeap,0,sizeof(GLfloat)*4);

	p_fVertex[0]=(float)p_dVertex[0];
	p_fVertex[1]=(float)p_dVertex[1];
	p_fVertex[2]=(float)p_dVertex[2];
	//p_fVertex[3]=fLightLevel;
	p_fVertex[3]=(float)sectors[iCurrentSector].ceilingheight/MAP_SCALE;
	
/*	if (bFloorCompute)
	{	a_stFloorVertexesArray[iCurrentSector].p_fFloor=(GLfloat **)glRealloc(a_stFloorVertexesArray[iCurrentSector].p_fFloor,(iNbPoints+1)*sizeof(GLfloat *));
		a_stFloorVertexesArray[iCurrentSector].p_fCeiling=(GLfloat **)glRealloc(a_stFloorVertexesArray[iCurrentSector].p_fCeiling,(iNbPoints+1)*sizeof(GLfloat *));
		a_stFloorVertexesArray[iCurrentSector].p_fFloor[iNbPoints++]=p_fVertex+1;
	}
	else
		a_stFloorVertexesArray[iCurrentSector].p_fCeiling[iNbPoints++]=p_fVertex+1;*/

	return p_fVertex;
}

void CALLBACK vertexArrayCallback(GLvoid *vertex)
{ GLfloat *fVertex,fU,fV;
  GLVertexArray *p_stVertexArray;

	p_stVertexArray=&a_stFCPolygonArray[iCurrentSector].p_stVertexArray[a_stFCPolygonArray[iCurrentSector].iNbArrays-1];
	p_stVertexArray->iNbVertices++;
	p_stVertexArray->p_fVertex=(GLfloat *)glRealloc(p_stVertexArray->p_fVertex,3*p_stVertexArray->iNbVertices*sizeof(GLfloat));
	p_stVertexArray->p_fUV=(GLfloat *)glRealloc(p_stVertexArray->p_fUV,2*p_stVertexArray->iNbVertices*sizeof(GLfloat));
	p_stVertexArray->p_fCeiling=(GLfloat *)glRealloc(p_stVertexArray->p_fCeiling,p_stVertexArray->iNbVertices*sizeof(GLfloat));
	
	fVertex=(GLfloat *)vertex;
	//fU=(float)(fVertex[0]*MAP_SCALE/*-iXMin*/)/FLAT_TEX_SIZE;
	//fV=(float)(/*iYMax-*/fVertex[2]*MAP_SCALE)/FLAT_TEX_SIZE;
	// ZDOOM_GL: The -fVertex
	//fU=(float)(-fVertex[0]*(MAP_SCALE>>FRACBITS))/FLAT_TEX_SIZE;
	//fV=(float)(-fVertex[2]*(MAP_SCALE>>FRACBITS))/FLAT_TEX_SIZE;
	fU=(float)(-fVertex[0]*MAP_COEFF)/FLAT_TEX_SIZE;
	fV=(float)(-fVertex[2]*MAP_COEFF)/FLAT_TEX_SIZE;


	p_stVertexArray->p_fVertex[3*(p_stVertexArray->iNbVertices-1)]=fVertex[0];
	p_stVertexArray->p_fVertex[3*(p_stVertexArray->iNbVertices-1)+1]=fVertex[1];
	p_stVertexArray->p_fVertex[3*(p_stVertexArray->iNbVertices-1)+2]=fVertex[2];

	p_stVertexArray->p_fUV[2*(p_stVertexArray->iNbVertices-1)]=fU;
	p_stVertexArray->p_fUV[2*(p_stVertexArray->iNbVertices-1)+1]=fV;

	p_stVertexArray->p_fCeiling[p_stVertexArray->iNbVertices-1]=fVertex[3];

	//free(fVertex);	// A voir

/*	glTexCoord2f(fU,fV);
	glVertex3fv(fVertex);*/
}

void CALLBACK glArrayBegin(GLenum mode)
{ GLFloorCeilingPolygonArray *p_stPolyArray=a_stFCPolygonArray+iCurrentSector;

	p_stPolyArray->iNbArrays++;
	p_stPolyArray->p_stVertexArray=(GLVertexArray *)glRealloc(p_stPolyArray->p_stVertexArray,p_stPolyArray->iNbArrays*sizeof(GLVertexArray));
	p_stPolyArray->p_stVertexArray[p_stPolyArray->iNbArrays-1].mode=mode;
	p_stPolyArray->p_stVertexArray[p_stPolyArray->iNbArrays-1].iNbVertices=0;
	p_stPolyArray->p_stVertexArray[p_stPolyArray->iNbArrays-1].p_fVertex=(GLfloat *)glMalloc(3*sizeof(GLfloat));
	p_stPolyArray->p_stVertexArray[p_stPolyArray->iNbArrays-1].p_fUV=(GLfloat *)glMalloc(2*sizeof(GLfloat));
	p_stPolyArray->p_stVertexArray[p_stPolyArray->iNbArrays-1].p_fCeiling=(GLfloat *)glMalloc(sizeof(GLfloat));
}

void CALLBACK glArrayEnd(void)
{
}

int VtxDist(vertex_t *v1,vertex_t *v2)
{
	return abs(v1->x-v2->x)+abs(v1->y-v2->y);
}

#ifdef NDEBUG
#pragma optimize( "", off )
#endif

void fn_vCreatePolygonsForSector(int s)
{ GLUtesselator *tobj;
  int iLine,iRemainingLines,iNumLines,iDblLines;
  vertex_t *vCurrentVertex,*vStartVertex,*vLastVertex;
  GLdouble a_fVertex[2][3];
  GLboolean bAbortSector;
  int iLineCandidate;

	g_iSector=s;
	tobj = gluNewTess();

	iCurrentSector=s;
	a_stFCPolygonArray[s].iNbArrays=0;
	a_stFCPolygonArray[s].p_stVertexArray=(GLVertexArray *)glMalloc(sizeof(GLVertexArray));

	a_stFCPolygonArray[s].iCeilingTexture=fn_iGetGLFlatTexturef(sectors[s].ceilingpic);
	a_stFCPolygonArray[s].iFloorTexture=fn_iGetGLFlatTexturef(sectors[s].floorpic);

	gluTessCallback(tobj, GLU_TESS_VERTEX, 
					   (void (__stdcall *)(void))vertexArrayCallback);
	gluTessCallback(tobj, GLU_TESS_BEGIN, 
					   (void (__stdcall *)(void))glArrayBegin);
	gluTessCallback(tobj, GLU_TESS_END, 
					   (void (__stdcall *)(void))glArrayEnd);
	gluTessCallback(tobj, GLU_TESS_ERROR, 
					   (void (__stdcall *)(void))errorCallback);
	
	gluTessBeginPolygon(tobj, NULL);

	iNumLines=sectors[s].linecount;
	iDblLines=0;
	for (iLine=0;iLine<iNumLines;iLine++)
	{ int i;

		i=sectors[s].lines[iLine]->iLineID;
		a_iLineArray[iLine]=i;
		if (modifiedgame)
		{	if (lines[i].frontsector==lines[i].backsector)
			{	a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
				a_iLinePresent[iLine]=1;
		}
		else
		{
#ifdef ZDOOM_GL
			if ((!strcmp(level.mapname,"MAP22"))&&(s==109)&&
				((i==530)||(i==607)||(i==542)||(i==610)))
			{	a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
			if ((!strcmp(level.mapname,"E4M3"))&&(s==81)&&((i==757)||(i==759)))
			{	a_iLinePresent[iLine]=0;
				iDblLines++;
			}
#elif DOOM_GL	// anti-bug...
			if ((gamemap==22)&&(s==109)&&
				((i==530)||(i==607)||(i==542)||(i==610)))
			{	a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
			if ((gameepisode==4)&&(gamemap==3)&&(s==81)&&((i==757)||(i==759)))
			{	a_iLinePresent[iLine]=0;
				iDblLines++;
			}
#elif GL_HEXEN
			if ((gamemap==2)&&(i>1635)&&(i<1660))
			{	// MR1006
				//a_iLinePresent[iLine]=2;
				a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
			if ((gamemap==8)&&
				((i>2147)&&(i<2152))||(i==2141)||(i==2142))
			{	
				a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
			if ((gamemap==10)&&(s==89)&&
				((i==107)||(i==123)||(i==708)))
			{	
				a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
			if ((gamemap==10)&&(s==91)&&
				((i==108)||(i==122)))
			{	
				a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
			if ((gamemap==10)&&(s==259)&&
				((i==1916)||(i==1925)||(i==1047)||((i>1048)&&(i<1053))||(i==1054)||(i==1056)))
			{	
				a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
			if ((gamemap==10)&&(s==189))
			{	gluTessEndPolygon(tobj);

				gluDeleteTess(tobj);
				return;
			}
			else
			if ((gamemap==21)&&(s==114)&&
				((i==1179)||(i==1169)||
				((i>933)&&(i<938))||((i>946)&&(i<951)||((i>986)&&(i<991)))
				))
			{	
				a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
#endif
			if (lines[i].frontsector==lines[i].backsector)
			{	// MR1006
				//a_iLinePresent[iLine]=2;
				a_iLinePresent[iLine]=0;
				iDblLines++;
			}
			else
				a_iLinePresent[iLine]=1;
		}
	}

	if (modifiedgame)
		goto endantibugs;
#ifdef ZDOOM_GL
	if (!strcmp(level.mapname,"E4M1")&&(s==61))
	{	iNumLines+=2;
		a_iLineArray[iLine]=403;
		a_iLinePresent[iLine++]=1;
		a_iLineArray[iLine]=404;
		a_iLinePresent[iLine]=1;
	}
	if (!strcmp(level.mapname,"E3M8")&&(s==1))	// anti bug E3M8 sectors 1 & 2
	{	iNumLines+=2;
		a_iLineArray[iLine]=57;
		a_iLinePresent[iLine++]=1;
		a_iLineArray[iLine]=21;
		a_iLinePresent[iLine]=1;
	}
	if (!strcmp(level.mapname,"E3M8")&&(s==2))
	{	gluTessEndPolygon(tobj);

		gluDeleteTess(tobj);

		lines[57].backsector->iSectorID=1;
		lines[21].frontsector->iSectorID=1;
		return;
	}
	if (!strcmp(level.mapname,"MAP21")&&(s==49))
	{	iNumLines+=2;
		a_iLineArray[iLine]=134;
		a_iLinePresent[iLine++]=1;
		a_iLineArray[iLine]=114;
		a_iLinePresent[iLine]=1;
	}
	if (!strcmp(level.mapname,"MAP50")||!strcmp(level.mapname,"MAP51"))
	{	gluTessEndPolygon(tobj);

		gluDeleteTess(tobj);
		return;
	}
#elif DOOM_GL	// Anti bug Doom1 E1M4 sector 61 :-((
	if ((gameepisode==4)&&(gamemap==1)&&(s==61))
	{	iNumLines+=2;
		a_iLineArray[iLine]=403;
		a_iLinePresent[iLine++]=1;
		a_iLineArray[iLine]=404;
		a_iLinePresent[iLine]=1;
	}
	if ((gameepisode==3)&&(gamemap==8)&&(s==1))	// anti bug E3M8 sectors 1 & 2
	{	iNumLines+=2;
		a_iLineArray[iLine]=57;
		a_iLinePresent[iLine++]=1;
		a_iLineArray[iLine]=21;
		a_iLinePresent[iLine]=1;
	}
	if ((gameepisode==3)&&(gamemap==8)&&(s==2))
	{	gluTessEndPolygon(tobj);

		gluDeleteTess(tobj);

		lines[57].backsector->iSectorID=1;
		lines[21].frontsector->iSectorID=1;
		return;
	}
	if ((gamemap==21)&&(s==49))
	{	iNumLines+=2;
		a_iLineArray[iLine]=134;
		a_iLinePresent[iLine++]=1;
		a_iLineArray[iLine]=114;
		a_iLinePresent[iLine]=1;
	}
	if ((gamemap==50)||(gamemap==51))
	{	gluTessEndPolygon(tobj);

		gluDeleteTess(tobj);
		return;
	}
#elif GL_HEXEN
	if ((gamemap==4)&&((s==140)||(s==152)))
	{	gluTessEndPolygon(tobj);

		gluDeleteTess(tobj);
		return;
	}
	if ((gamemap==35)&&(s==23))
	{	iNumLines++;
		a_iLineArray[iLine]=1414;
		a_iLinePresent[iLine]=1;
	}
#else	// heretic
	if ((gameepisode==3)&&(gamemap==4)&&(s==112))
	{	gluTessEndPolygon(tobj);

		gluDeleteTess(tobj);
		return;
	}

#endif
endantibugs:
	iRemainingLines=iNumLines-iDblLines;
	bAbortSector=FALSE;

	while (iRemainingLines)
	{
		gluTessBeginContour(tobj);

		//glColor3f(fLightLevel, fLightLevel, fLightLevel);
		/*iLine=0;
		while (!a_iLinePresent[iLine]) iLine++;*/
		iLine=fn_iGetUpperLeftLine(a_iLineArray,a_iLinePresent,iNumLines,s);

		// MR0906
		if (lines[a_iLineArray[iLine]].frontsector->iSectorID==s)
		{
			vStartVertex=lines[a_iLineArray[iLine]].v1;
			vCurrentVertex=lines[a_iLineArray[iLine]].v2;
			a_fVertex[0][0]=-(GLdouble)lines[a_iLineArray[iLine]].v1->x/MAP_SCALE;	// x
			a_fVertex[0][1]=(GLdouble)sectors[s].floorheight/MAP_SCALE;				// y
			a_fVertex[0][2]=(GLdouble)lines[a_iLineArray[iLine]].v1->y/MAP_SCALE;	// z
			a_fVertex[1][0]=-(GLdouble)lines[a_iLineArray[iLine]].v2->x/MAP_SCALE;	// x
			a_fVertex[1][1]=(GLdouble)sectors[s].floorheight/MAP_SCALE;				// y
			a_fVertex[1][2]=(GLdouble)lines[a_iLineArray[iLine]].v2->y/MAP_SCALE;	// z
		}
		else
		{
			vStartVertex=lines[a_iLineArray[iLine]].v2;
			vCurrentVertex=lines[a_iLineArray[iLine]].v1;
			a_fVertex[1][0]=-(GLdouble)lines[a_iLineArray[iLine]].v1->x/MAP_SCALE;	// x
			a_fVertex[1][1]=(GLdouble)sectors[s].floorheight/MAP_SCALE;				// y
			a_fVertex[1][2]=(GLdouble)lines[a_iLineArray[iLine]].v1->y/MAP_SCALE;	// z
			a_fVertex[0][0]=-(GLdouble)lines[a_iLineArray[iLine]].v2->x/MAP_SCALE;	// x
			a_fVertex[0][1]=(GLdouble)sectors[s].floorheight/MAP_SCALE;				// y
			a_fVertex[0][2]=(GLdouble)lines[a_iLineArray[iLine]].v2->y/MAP_SCALE;	// z
		}
		
		gluTessVertex(tobj, a_fVertex[0], fn_p_fVertex(a_fVertex[0]/*,fLightLevel*/));
		gluTessVertex(tobj, a_fVertex[1], fn_p_fVertex(a_fVertex[1]/*,fLightLevel*/));

		a_iLinePresent[iLine]--;
		if (!a_iLinePresent[iLine])
			iRemainingLines--;
		vLastVertex=NULL;
		while (vCurrentVertex!=vStartVertex)
		{	
			// DOOM_GL: anti-bug (CF E1M3: linedefs 933 & 927 !!!)
			if (iLine==iNumLines)
			{ int dist,distMin=0x7fffffff,v,iLineMin;

				if (!iRemainingLines)	// Anti-bug 2: Cf MAP02 sector 39
				{	vCurrentVertex=vStartVertex;
					continue;
				}

				for (iLine=0;iLine<iNumLines;iLine++)				
				{	
					if (!a_iLinePresent[iLine])
						continue;
					if ((dist=VtxDist(lines[a_iLineArray[iLine]].v1,vCurrentVertex))<distMin)
					{
						distMin=dist;
						iLineMin=iLine;
						v=1;
					}
					if ((dist=VtxDist(lines[a_iLineArray[iLine]].v2,vCurrentVertex))<distMin)
					{
						distMin=dist;
						iLineMin=iLine;
						v=2;
					}
				}
				iLine=iLineMin;
				if (v==1)
				{	vCurrentVertex=lines[a_iLineArray[iLine]].v2;

					if (vCurrentVertex!=vStartVertex)
					{
						a_fVertex[0][0]=-(GLdouble)lines[a_iLineArray[iLine]].v2->x/MAP_SCALE;	// x
						a_fVertex[0][1]=(GLdouble)sectors[s].floorheight/MAP_SCALE;						// y
						a_fVertex[0][2]=(GLdouble)lines[a_iLineArray[iLine]].v2->y/MAP_SCALE;	// z
						gluTessVertex(tobj, a_fVertex[0], fn_p_fVertex(a_fVertex[0]/*,fLightLevel*/));
					}

					//a_iLineArray[iLine]=-1;
					a_iLinePresent[iLine]--;
					if (!a_iLinePresent[iLine])
						iRemainingLines--;
				}
				else
				{
					vCurrentVertex=lines[a_iLineArray[iLine]].v1;
							
					if (vCurrentVertex!=vStartVertex)
					{
						a_fVertex[0][0]=-(GLdouble)lines[a_iLineArray[iLine]].v1->x/MAP_SCALE;	// x
						a_fVertex[0][1]=(GLdouble)sectors[s].floorheight/MAP_SCALE;						// y
						a_fVertex[0][2]=(GLdouble)lines[a_iLineArray[iLine]].v1->y/MAP_SCALE;	// z
						gluTessVertex(tobj, a_fVertex[0], fn_p_fVertex(a_fVertex[0]/*,fLightLevel*/));
					}

					a_iLinePresent[iLine]--;
					if (!a_iLinePresent[iLine])
						iRemainingLines--;
				}
				continue;
			}
			// End DOOM_GL anti-bug...
			if (vCurrentVertex==vLastVertex)	// Invalid sector (not closed: Cf E1M9)
			{	bAbortSector=TRUE;
				break;
			}
			vLastVertex=vCurrentVertex;

			iLineCandidate=-1;	// MR1306
			for (iLine=0;iLine<iNumLines;iLine++)				
			{	
				if (!a_iLinePresent[iLine])
					continue;
				if (lines[a_iLineArray[iLine]].v1==vCurrentVertex)
				{
					iLineCandidate=iLine;
					if (lines[a_iLineArray[iLine]].frontsector->iSectorID==s)
						break;
/*					vCurrentVertex=lines[a_iLineArray[iLine]].v2;

					if (vCurrentVertex!=vStartVertex)
					{
						a_fVertex[0][0]=-(GLdouble)lines[a_iLineArray[iLine]].v2->x/MAP_SCALE;	// x
						a_fVertex[0][1]=(GLdouble)sectors[s].floorheight/MAP_SCALE;						// y
						a_fVertex[0][2]=(GLdouble)lines[a_iLineArray[iLine]].v2->y/MAP_SCALE;	// z
						gluTessVertex(tobj, a_fVertex[0], fn_p_fVertex(a_fVertex[0]));
					}

					//a_iLineArray[iLine]=-1;
					a_iLinePresent[iLine]--;
					if (!a_iLinePresent[iLine])
						iRemainingLines--;
					break;*/
				}
			}
// MR1306
//			if (iLine==iNumLines)
			if (iLineCandidate!=-1)
			{	vCurrentVertex=lines[a_iLineArray[iLineCandidate]].v2;

				if (vCurrentVertex!=vStartVertex)
				{
					a_fVertex[0][0]=-(GLdouble)lines[a_iLineArray[iLineCandidate]].v2->x/MAP_SCALE;	// x
					a_fVertex[0][1]=(GLdouble)sectors[s].floorheight/MAP_SCALE;						// y
					a_fVertex[0][2]=(GLdouble)lines[a_iLineArray[iLineCandidate]].v2->y/MAP_SCALE;	// z
					gluTessVertex(tobj, a_fVertex[0], fn_p_fVertex(a_fVertex[0]));
				}

				//a_iLineArray[iLine]=-1;
				a_iLinePresent[iLineCandidate]--;
				if (!a_iLinePresent[iLineCandidate])
					iRemainingLines--;
			}
			else
// End MR1306
			for (iLine=0;iLine<iNumLines;iLine++)				
			{	
				if (!a_iLinePresent[iLine])
					continue;

				if (lines[a_iLineArray[iLine]].v2==vCurrentVertex)
				{
					vCurrentVertex=lines[a_iLineArray[iLine]].v1;
					
					if (vCurrentVertex!=vStartVertex)
					{
						a_fVertex[0][0]=-(GLdouble)lines[a_iLineArray[iLine]].v1->x/MAP_SCALE;	// x
						a_fVertex[0][1]=(GLdouble)sectors[s].floorheight/MAP_SCALE;						// y
						a_fVertex[0][2]=(GLdouble)lines[a_iLineArray[iLine]].v1->y/MAP_SCALE;	// z
						gluTessVertex(tobj, a_fVertex[0], fn_p_fVertex(a_fVertex[0]/*,fLightLevel*/));
					}

					a_iLinePresent[iLine]--;
					if (!a_iLinePresent[iLine])
						iRemainingLines--;
					break;
				}
			}
		}
		gluTessEndContour(tobj);
		if (bAbortSector)
			break;
	}
	gluTessEndPolygon(tobj);
	//glEndList();

	gluDeleteTess(tobj);
}

// MR0507
void fn_vComputeBounds(int s)
{ int i,j;
  float fUp,fDown,fLeft,fRight;

	for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
	{	fUp=-100000.0f;
		fRight=-100000.0f;
		fDown=100000.0f;
		fLeft=100000.0f;
		for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
		{
			if (a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2]>fUp)
				fUp=a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2];
			if (a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2]<fDown)
				fDown=a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2];
			if (a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3]>fRight)
				fRight=a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3];
			if (a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3]<fLeft)
				fLeft=a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3];
		}
		a_stFCPolygonArray[s].p_stVertexArray[i].fUp=fUp;
		a_stFCPolygonArray[s].p_stVertexArray[i].fDown=fDown;
		a_stFCPolygonArray[s].p_stVertexArray[i].fLeft=fLeft;
		a_stFCPolygonArray[s].p_stVertexArray[i].fRight=fRight;
	}

	a_bFirstPass[s]=(GLbyte *)glMalloc(2*a_stFCPolygonArray[s].iNbArrays);
}

#ifdef NDEBUG
#pragma optimize( "", on )
#endif

extern void (*fn_vRenderSector)(int s);
void fn_vRenderSector1(int s);
void fn_vRenderSector0(int s);
EXTERN_CVAR(g_bDynLight)

void fn_vCreateFloorCeilingPolygons()
{ 
  int s;

  	if (g_bDynLight.value==3)
		fn_vRenderSector=fn_vRenderSector1;
	else
		fn_vRenderSector=fn_vRenderSector0;

  	xMapMin=0x7fffffff;
	xMapMax=-0x7fffffff;
	yMapMin=0x7fffffff;
	yMapMax=-0x7fffffff;
	iAltitudeMin=0x7fffffff;
	iAltitudeMax=-0x7fffffff;

	hVertexTmpHeap=HeapCreate(HEAP_GENERATE_EXCEPTIONS,2000000,0);
	
	a_iLineArray=(int *)glMalloc(sizeof(int)*numlines);
	a_iLinePresent=(int *)glMalloc(sizeof(int)*numlines);
	
	a_stFCPolygonArray=(GLFloorCeilingPolygonArray *)glMalloc(sizeof(GLFloorCeilingPolygonArray)*numsectors);
	a_bFirstPass=(GLbyte **)glMalloc(sizeof(GLbyte *)*numsectors);
	
	a_iGlDrawFloorCeil=(int *)glMalloc(sizeof(int)*numlines);;

	for (s=0;s<numsectors;s++)
	{
		if (sectors[s].ceilingheight>iAltitudeMax)
			iAltitudeMax=sectors[s].ceilingheight;
		if (sectors[s].floorheight<iAltitudeMin)
			iAltitudeMin=sectors[s].floorheight;

		iCurrentSector=s;
				
		fn_vCreatePolygonsForSector(s);
		// MR0507
		fn_vComputeBounds(s);
	}

	HeapDestroy(hVertexTmpHeap);
}

#ifndef M_PI
#  define M_PI (3.1415926f)
#endif
#define TXTR_COORD(x,y)    /*if (qobj->TextureFlag)*/ glTexCoord2f(x,y);

void fn_vGetMapExtremities()
{ int i,x,y;

	for (i=0;i<numlines;i++)
	{	x=-lines[i].v1->x;
		y=lines[i].v1->y;
		if (x<xMapMin)
			xMapMin=x;
		if (x>xMapMax)
			xMapMax=x;
		if (y<yMapMin)
			yMapMin=y;
		if (y>yMapMax)
			yMapMax=y;
		x=-lines[i].v2->x;
		y=lines[i].v2->y;
		if (x<xMapMin)
			xMapMin=x;
		if (x>xMapMax)
			xMapMax=x;
		if (y<yMapMin)
			yMapMin=y;
		if (y>yMapMax)
			yMapMax=y;
	}	
}

//#ifndef GL_HEXEN
#if 0		// For 3Dfx Minigl...
void MygluSphere( GLUquadricObj *qobj,
                         GLdouble radius, GLint slices, GLint stacks )
{
   GLfloat rho, drho, theta, dtheta;
   GLfloat x, y, z;
   GLfloat s, t, ds, dt;
   GLint i, j, imin, imax;
   GLboolean normals;
   GLfloat nsign;

   normals = GL_TRUE;
   nsign = -1.0f;

   drho = M_PI / (GLfloat) stacks;
   dtheta = 2.0f * M_PI / (GLfloat) slices;

   /* texturing: s goes from 0.0/0.25/0.5/0.75/1.0 at +y/+x/-y/-x/+y axis */
   /* t goes from -1.0/+1.0 at z = -radius/+radius (linear along longitudes) */
   /* cannot use triangle fan on texturing (s coord. at top/bottom tip varies) */

   //if (qobj->DrawStyle==GLU_FILL)
   {

      //ds = 1.0 / slices;
      //dt = 1.0 / stacks;
      ds = 5.0f / slices;
#ifndef DOOM_GL
      dt = 1.0f / stacks;
#else
	  //dt = 1.2f / stacks;	// DOOM_GL
	  dt = 1.0f / stacks;	// DOOM_GL
#endif
      t = 1.0f;  /* because loop now runs from 0 */
      //if (qobj->TextureFlag)
	  {
        imin = 0;
        imax = stacks;
      }
      /*else
	  {
        imin = 1;
        imax = stacks-1;
      }*/

      /* draw intermediate stacks as quad strips */
      for (i=imin;i<imax;i++)
	  {
		 rho = i * drho;
		 glBegin( GL_QUAD_STRIP );
			 s = 0.0f;
		 for (j=0;j<=slices;j++)
		 {
			theta = (j==slices) ? 0.0f : j * dtheta;
			x = -(float)(sin(theta) * sin(rho));
			y = (float)(cos(theta) * sin(rho));
			z = nsign * (float)cos(rho);
			if (normals)  glNormal3f( x*nsign, y*nsign, z*nsign );
			TXTR_COORD(s,t);
			glVertex3f( x*(float)radius, y*(float)radius, z*(float)radius );
			x = -(float)(sin(theta) * sin(rho+drho));
			y = (float)(cos(theta) * sin(rho+drho));
			z = (float)(nsign * cos(rho+drho));
			if (normals)  glNormal3f( x*nsign, y*nsign, z*nsign );
			TXTR_COORD(s,t-dt);
				s += ds;
			glVertex3f( x*(float)radius, y*(float)radius, z*(float)radius );
		 }
		 glEnd();
		 t -= dt;
	 }

   }
}

extern char szSkyName[4][8];
extern byte *p_bPalette;	// a virer

void fn_vCreateSky(int episode)
{ GLUquadricObj *qObj;
  float fU1,fU2,fV1,fV2,fU1Off,fV2Off;
  int iSubTex,iGLTex;
  float xMapCenter,yMapCenter,zMapCenter;
  float fX,fY,fAlt;

	fn_vGetMapExtremities();

	//xMapCenter=(float)(-xMapMin)/MAP_SCALE+(float)(-xMapMax+xMapMin)/(2*MAP_SCALE);
	xMapCenter=(GLdouble)xMapMin/MAP_SCALE+(GLdouble)(xMapMax-xMapMin)/(2*MAP_SCALE);
	yMapCenter=(GLdouble)iAltitudeMin/MAP_SCALE+(GLdouble)(iAltitudeMax-iAltitudeMin)/(2*MAP_SCALE);
#ifdef DOOM_GL
	zMapCenter=(GLdouble)yMapMin/MAP_SCALE+(GLdouble)(yMapMax-yMapMin)/(2*MAP_SCALE);		// DOOM_GL
#else
	zMapCenter=(GLdouble)yMapMin/MAP_SCALE+5.0f*(GLdouble)(yMapMax-yMapMin)/(6*MAP_SCALE);
#endif

	fAlt=(float)((iAltitudeMax-iAltitudeMin)>>FRACBITS);
	fX=(float)((xMapMax-xMapMin)>>FRACBITS);
	fY=(float)((yMapMax-yMapMin)>>FRACBITS);
	fSkyRadius=(float)sqrt(fX*fX+fY*fY+fAlt*fAlt);
	fSkyRadius*=1.5f/MAP_COEFF;
	fSkyRadius=fSkyRadius>320.0f?fSkyRadius:320.0f;

	iSkyList = glGenLists(1);
#ifdef GL_HEXEN
	if (episode==1)
		iSkyList1 = iSkyList;
	else
		iSkyList2 = iSkyList;
#endif
	glNewList(iSkyList, GL_COMPILE);

	//fn_vLoadSkyTexture(episode);
	//glColor3f(1.0f, 1.0f, 1.0f);
/*	qObj=gluNewQuadric();
	gluQuadricDrawStyle(qObj, GLU_FILL);
	gluQuadricOrientation(qObj,GLU_INSIDE);
	gluQuadricTexture(qObj,GL_TRUE);*/
	
#ifndef GL_HEXEN
	iGLTex=fn_iGetGLTexturef(-2,0,0,&fU1,&fU2,&fV1,&fV2,&fU1Off,&fV2Off,&iSubTex);
	glBindTexture(GL_TEXTURE_2D, texobjs[iGLTex]);
#else
	if (episode==1)
		glBindTexture(GL_TEXTURE_2D, GL_Sky1Texture);
	else
		glBindTexture(GL_TEXTURE_2D, GL_Sky2Texture);
#endif
	//glColor3f(1.0f, 1.0f, 1.0f);	// MR1405

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
	glRotatef(-90.0f,   1.0f, 0.0f, 0.0f);		// -90 for MygluSphere & 90 for gluSphere
	glTranslatef(xMapCenter,yMapCenter,zMapCenter);
	
	MygluSphere(qObj,fSkyRadius,10,10);
	glPopMatrix();

	glEndList();
}
#else	// GL_HEXEN
GLSky *GLSky1;

GLSky *MygluSphere( GLdouble radius, GLint slices, GLint stacks )
{
   GLSky *p_stSky;
   GLfloat rho, drho, theta, dtheta;
   GLfloat x, y, z;
   GLfloat s, t, ds, dt;
   GLint i, j, imin, imax;
   GLboolean normals;
   GLfloat nsign;
   GLint iPoint;


   p_stSky=(GLSky *)glMalloc(sizeof(GLSky));
   normals = GL_TRUE;
   nsign = -1.0f;

   drho = M_PI / (GLfloat) stacks;
   dtheta = 2.0f * M_PI / (GLfloat) slices;

   /* texturing: s goes from 0.0/0.25/0.5/0.75/1.0 at +y/+x/-y/-x/+y axis */
   /* t goes from -1.0/+1.0 at z = -radius/+radius (linear along longitudes) */
   /* cannot use triangle fan on texturing (s coord. at top/bottom tip varies) */

   {

      ds = 5.0f / slices;
      dt = 1.0f / stacks;
      t = 1.0f;  /* because loop now runs from 0 */
	  {
        imin = 0;
        imax = stacks;
      }

      p_stSky->iNbPoints=(imax-imin)*(slices+1)*2;
	  p_stSky->p_fVertex=(GLfloat *)glMalloc(3*p_stSky->iNbPoints*sizeof(GLfloat));
	  p_stSky->p_fNormals=(GLfloat *)glMalloc(3*p_stSky->iNbPoints*sizeof(GLfloat));
	  p_stSky->p_fV=(GLfloat *)glMalloc(p_stSky->iNbPoints*sizeof(GLfloat));
	  p_stSky->slices=slices;
	  p_stSky->stacks=stacks;
	  iPoint=0;
	  /* draw intermediate stacks as quad strips */
      for (i=imin;i<imax;i++)
	  {
		 rho = i * drho;
		 //glBegin( GL_QUAD_STRIP );
			 s = 0.0f;
		 for (j=0;j<=slices;j++)
		 {
			theta = (j==slices) ? 0.0f : j * dtheta;
			x = -(float)(sin(theta) * sin(rho));
			y = (float)(cos(theta) * sin(rho));
			z = nsign * (float)cos(rho);
			//if (normals)  glNormal3f( x*nsign, y*nsign, z*nsign );
			if (normals)
			{	p_stSky->p_fNormals[3*iPoint]=x*nsign;
				p_stSky->p_fNormals[3*iPoint+1]=y*nsign;
				p_stSky->p_fNormals[3*iPoint+2]=z*nsign;
			}
			//TXTR_COORD(s,t);
			//glVertex3f( x*(float)radius, y*(float)radius, z*(float)radius );
			p_stSky->p_fV[iPoint]=t;
			p_stSky->p_fVertex[3*iPoint]=x*(GLfloat)radius;
			p_stSky->p_fVertex[3*iPoint+1]=y*(GLfloat)radius;
			p_stSky->p_fVertex[3*iPoint+2]=z*(GLfloat)radius;
			iPoint++;

			x = -(float)(sin(theta) * sin(rho+drho));
			y = (float)(cos(theta) * sin(rho+drho));
			z = (float)(nsign * cos(rho+drho));
//			if (normals)  glNormal3f( x*nsign, y*nsign, z*nsign );
			if (normals)
			{	p_stSky->p_fNormals[3*iPoint]=x*nsign;
				p_stSky->p_fNormals[3*iPoint+1]=y*nsign;
				p_stSky->p_fNormals[3*iPoint+2]=z*nsign;
			}
//			TXTR_COORD(s,t-dt);
				s += ds;
//			glVertex3f( x*(float)radius, y*(float)radius, z*(float)radius );
			p_stSky->p_fV[iPoint]=t-dt;
			p_stSky->p_fVertex[3*iPoint]=x*(GLfloat)radius;
			p_stSky->p_fVertex[3*iPoint+1]=y*(GLfloat)radius;
			p_stSky->p_fVertex[3*iPoint+2]=z*(GLfloat)radius;
			iPoint++;
		 }
		 //glEnd();
		 t -= dt;
	 }

   }
   return p_stSky;
}

void fn_vCreateSky()
{ 
  float xMapCenter,yMapCenter,zMapCenter;
  float fX,fY,fAlt;

	fn_vGetMapExtremities();

	xMapCenter=(GLfloat)xMapMin/MAP_SCALE+(GLfloat)(xMapMax-xMapMin)/(2.0f*MAP_SCALE);
	//zMapCenter=(GLdouble)iAltitudeMin/MAP_SCALE+(GLdouble)(iAltitudeMax-iAltitudeMin)/(2*MAP_SCALE);
	zMapCenter=(GLfloat)iAltitudeMin/MAP_SCALE-10.0f*(GLfloat)(iAltitudeMax-iAltitudeMin)/MAP_SCALE;
#ifdef DOOM_GL
	yMapCenter=(GLfloat)yMapMin/MAP_SCALE+(GLfloat)(yMapMax-yMapMin)/(2.0f*MAP_SCALE);		// DOOM_GL
#elif GL_HEXEN	
	//zMapCenter=(GLdouble)yMapMin/MAP_SCALE+8.0f*((GLdouble)(yMapMax-yMapMin)/MAP_SCALE);
	yMapCenter=(GLdouble)yMapMin/MAP_SCALE+7.5f*((GLdouble)(yMapMax-yMapMin)/MAP_SCALE);
#else
	yMapCenter=(GLdouble)yMapMin/MAP_SCALE+5.0f*(GLdouble)(yMapMax-yMapMin)/(6*MAP_SCALE);
#endif

	fAlt=(float)((iAltitudeMax-iAltitudeMin)>>FRACBITS);
	fX=(float)((xMapMax-xMapMin)>>FRACBITS);
	fY=(float)((yMapMax-yMapMin)>>FRACBITS);
	fSkyRadius=(float)sqrt(fX*fX+fY*fY+fAlt*fAlt);
	fSkyRadius*=1.5f/MAP_COEFF;
	fSkyRadius=fSkyRadius>320.0f?fSkyRadius:320.0f;
	
	GLSky1=MygluSphere(fSkyRadius,10,10);

	GLSky1->xMapCenter=xMapCenter;
	GLSky1->yMapCenter=yMapCenter;
	GLSky1->zMapCenter=zMapCenter;
#ifdef GL_HEXEN
	GLCurrentSky=1;
#endif
}

void fn_vDrawSky(int index)
{ GLint iPoint,i,j;
  GLfloat ds,s;
  int offset,iTex;

#ifdef GL_HEXEN
	if (index==1)
	{	glBindTexture(GL_TEXTURE_2D, GL_Sky1Texture);
		offset = Sky1ColumnOffset>>16;
		iTex=GL_Sky1Texture-1;
	}
	else
	{	glBindTexture(GL_TEXTURE_2D, GL_Sky2Texture);
		offset = Sky2ColumnOffset>>16;
		iTex=GL_Sky2Texture-1;
	}
#else
	int iSubTex;
	float fU1,fU2,fV1,fV2,fU1Off,fV2Off;

	iTex=fn_iGetGLTexturef(-2,0,0,&fU1,&fU2,&fV1,&fV2,&fU1Off,&fV2Off,&iSubTex);
	glBindTexture(GL_TEXTURE_2D, texobjs[iTex]);
	offset=0;
#endif
//	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
//	glLoadIdentity();
	glRotatef(-90.0f,   1.0f, 0.0f, 0.0f);		// -90 for MygluSphere & 90 for gluSphere
	glTranslatef(GLSky1->xMapCenter,GLSky1->yMapCenter,GLSky1->zMapCenter);

    iPoint=0;
	ds = 5.0f / GLSky1->slices;

	/* draw intermediate stacks as quad strips */
    for (i=0;i<GLSky1->stacks;i++)
	{
		 glBegin( GL_QUAD_STRIP );
		 //s = 0.0f;
		 s=(float)offset/(float)p_stGLTextures[iTex].iWidth;
		 for (j=0;j<=GLSky1->slices;j++)
		 {
			glNormal3f( GLSky1->p_fNormals[3*iPoint], GLSky1->p_fNormals[3*iPoint+1], GLSky1->p_fNormals[3*iPoint+2] );
			TXTR_COORD(s,GLSky1->p_fV[iPoint]);
			glVertex3f( GLSky1->p_fVertex[3*iPoint], GLSky1->p_fVertex[3*iPoint+1], GLSky1->p_fVertex[3*iPoint+2] );
			iPoint++;

			glNormal3f( GLSky1->p_fNormals[3*iPoint], GLSky1->p_fNormals[3*iPoint+1], GLSky1->p_fNormals[3*iPoint+2] );
			TXTR_COORD(s,GLSky1->p_fV[iPoint]);
			glVertex3f( GLSky1->p_fVertex[3*iPoint], GLSky1->p_fVertex[3*iPoint+1], GLSky1->p_fVertex[3*iPoint+2] );
			iPoint++;
			s += ds;
		 }
		 glEnd();
	 }
	
	glPopMatrix();
}
#endif	// GL_HEXEN

void fn_vRenderSector1(int s)
{ int i,j,iGlTex;
  float fLightLevel;
  int xOffset,yOffset;
  float fU,fV;
  float fRed,fGreen,fBlue;

	if (sectors[s].floorcolormap->fade)
	{ GLfloat fogColor[4];

		g_bDynLight.Set(2);
		fn_vRenderSector0(s);
		g_bDynLight.Set(3);
		return;
		//glEnable(GL_FOG);
		fogColor[0]=(float)RPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[1]=(float)GPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[2]=(float)BPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[3]=1.0f;
		glFogfv (GL_FOG_COLOR, fogColor);
	}
	if (sectors[s].floorlightsec)
	{	fLightLevel=((float)(sectors[s].floorlightsec->lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=fLightLevel*(float)RPART(sectors[s].floorcolormap->color)/255.0f;
		fGreen=fLightLevel*(float)GPART(sectors[s].floorcolormap->color)/255.0f;
		fBlue=fLightLevel*(float)BPART(sectors[s].floorcolormap->color)/255.0f;
	}
	else
	{	//fLightLevel=((float)(sectors[s].lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=sectors[s].fRed;
		fGreen=sectors[s].fGreen;
		fBlue=sectors[s].fBlue;
	}

#ifdef GL_HEXEN
	special=sectors[s].special;
	scrollOffset = leveltime>>1&63;
	switch(special)
	{ // Handle scrolling flats
		case 201: case 202: case 203: // Scroll_North_xxx
			xOffset=0;
			yOffset=((63-scrollOffset)<<(special-201)&63);
			break;
		case 204: case 205: case 206: // Scroll_East_xxx
			xOffset=(scrollOffset<<(special-204)&63);
			yOffset=0;
			break;
		case 207: case 208: case 209: // Scroll_South_xxx
			xOffset=0;
			yOffset=(scrollOffset<<(special-207)&63);
			break;
		case 210: case 211: case 212: // Scroll_West_xxx
			xOffset=((63-scrollOffset)<<(special-210)&63);
			yOffset=0;
			break;
		case 213: case 214: case 215: // Scroll_NorthWest_xxx
			xOffset=((63-scrollOffset)<<(special-213)&63);
			yOffset=((63-scrollOffset)<<(special-213)&63);
			break;
		case 216: case 217: case 218: // Scroll_NorthEast_xxx
			xOffset=(scrollOffset<<(special-216)&63);
			yOffset=((63-scrollOffset)<<(special-216)&63);
			break;
		case 219: case 220: case 221: // Scroll_SouthEast_xxx
			xOffset=(scrollOffset<<(special-219)&63);
			yOffset=(scrollOffset<<(special-219)&63);
			break;
		case 222: case 223: case 224: // Scroll_SouthWest_xxx
			xOffset=((63-scrollOffset)<<(special-222)&63);
			yOffset=(scrollOffset<<(special-222)&63);
			break;
		default:
			xOffset=0;
			yOffset=0;
	}
	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;
#elif ZDOOM_GL
	xOffset=sectors[s].floor_xoffs/(FRACUNIT / 2);
	yOffset=sectors[s].floor_yoffs/(FRACUNIT / 2);

	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;
#endif

	//if (sectors[s].floorpic==R_FlatNumForName(F_SKY))
	if (a_iGLTexTranslation[a_stFCPolygonArray[s].iFloorTexture]==fn_iIsFlatTextureRegistered(skyflatnum))
	{	
		goto dceiling;
	}

	GL_DrawLightForFloor(s);

	glDepthFunc(GL_LEQUAL);
	glBlendFunc(GL_ONE,GL_ONE);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	
	//GL_StaticLight3f(fLightLevel,fLightLevel,fLightLevel);
	GL_StaticLight3f(fRed,fGreen,fBlue);
	for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
	{	
		if (a_bFirstPass[s][2*i])
			continue;
		glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
		for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
		{	
			glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
		}
		glEnd();
	}

	glEnable(GL_TEXTURE_2D);
	//glEnable(GL_BLEND);	
	glBlendFunc(GL_DST_COLOR,GL_ZERO);
	glColor3f(1.0f,1.0f,1.0f);

	if (sectors[s].floorcolormap->fade)
		glEnable(GL_FOG);
	iGlTex=a_iGLTexTranslation[a_stFCPolygonArray[s].iFloorTexture];

	glBindTexture(GL_TEXTURE_2D, texobjs[iGlTex]);

	for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
	{	
		if (a_bFirstPass[s][2*i])
		{	glDisable(GL_BLEND);
			GL_StaticLight3f(fRed, fGreen, fBlue);
		}
		else
		{
			glEnable(GL_BLEND);	
			glColor3f(1.0f,1.0f,1.0f);
		}			
		glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
		for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
		{	
			glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2]+fU,
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1]+fV );
			glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
		}
		glEnd();
	}		

dceiling:
	glCullFace(GL_BACK);
 	//if (sectors[s].ceilingpic==R_FlatNumForName(F_SKY))
	if (a_iGLTexTranslation[a_stFCPolygonArray[s].iCeilingTexture]==fn_iIsFlatTextureRegistered(skyflatnum))
	{	
		goto end;
	}

	if (sectors[s].floorcolormap->fade)
		glDisable(GL_FOG);
	//xOffset=sectors[s].floor_xoffs;
	xOffset=-sectors[s].ceiling_xoffs/(FRACUNIT / 2);
	yOffset=sectors[s].ceiling_yoffs/(FRACUNIT / 2);

	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;

	if (sectors[s].ceilinglightsec)
	{	fLightLevel=((float)(sectors[s].ceilinglightsec->lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=fLightLevel*(float)RPART(sectors[s].ceilingcolormap->color)/255.0f;
		fGreen=fLightLevel*(float)GPART(sectors[s].ceilingcolormap->color)/255.0f;
		fBlue=fLightLevel*(float)BPART(sectors[s].ceilingcolormap->color)/255.0f;
	}
	else
	{	//fLightLevel=((float)(sectors[s].lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=sectors[s].fRed;
		fGreen=sectors[s].fGreen;
		fBlue=sectors[s].fBlue;
	}

	GL_DrawLightForCeiling(s);

	glDepthFunc(GL_LEQUAL);
	glBlendFunc(GL_ONE,GL_ONE);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	//GL_StaticLight3f(fLightLevel,fLightLevel,fLightLevel);
	GL_StaticLight3f(fRed,fGreen,fBlue);
	for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
	{	
		if (a_bFirstPass[s][2*i+1])
			continue;
		glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
		for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
		{	
			glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
		}
		glEnd();
	}		

	glEnable(GL_TEXTURE_2D);
	//glEnable(GL_BLEND);	
	glBlendFunc(GL_DST_COLOR,GL_ZERO);
	glColor3f(1.0f,1.0f,1.0f);

	if (sectors[s].floorcolormap->fade)
		glEnable(GL_FOG);
	iGlTex=a_iGLTexTranslation[a_stFCPolygonArray[s].iCeilingTexture];
	glBindTexture(GL_TEXTURE_2D, texobjs[iGlTex]);
	
	for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
	{	
		if (a_bFirstPass[s][2*i+1])
		{	glDisable(GL_BLEND);
			GL_StaticLight3f(fRed, fGreen, fBlue);
		}
		else
		{
			glEnable(GL_BLEND);	
			glColor3f(1.0f,1.0f,1.0f);
		}			
		glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
		for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
		{	
			glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2],
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1] );
			glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
						a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
		}
		glEnd();
	}		

end:
	if (sectors[s].floorcolormap->fade)
		glDisable(GL_FOG);

	glDisable(GL_BLEND);
	glDepthFunc(GL_LESS);
}

void fn_vRenderSector0(int s)
{ int i,j,iGlTex;
  float fLightLevel;
#if defined(GL_HEXEN) || defined (ZDOOM_GL)
  int xOffset,yOffset;
  float fU,fV;
  float fRed,fGreen,fBlue;
#endif

	if (sectors[s].floorcolormap->fade)
	{ GLfloat fogColor[4];

		glEnable(GL_FOG);
		fogColor[0]=(float)RPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[1]=(float)GPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[2]=(float)BPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[3]=1.0f;
		glFogfv (GL_FOG_COLOR, fogColor);
	}
	if (sectors[s].floorlightsec)
	{	fLightLevel=((float)(sectors[s].floorlightsec->lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=fLightLevel*(float)RPART(sectors[s].floorcolormap->color)/255.0f;
		fGreen=fLightLevel*(float)GPART(sectors[s].floorcolormap->color)/255.0f;
		fBlue=fLightLevel*(float)BPART(sectors[s].floorcolormap->color)/255.0f;
	}
	else
	{	//fLightLevel=((float)(sectors[s].lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=sectors[s].fRed;
		fGreen=sectors[s].fGreen;
		fBlue=sectors[s].fBlue;
	}

	//if (sectors[s].floorpic==R_FlatNumForName(F_SKY))
	if (a_iGLTexTranslation[a_stFCPolygonArray[s].iFloorTexture]==fn_iIsFlatTextureRegistered(skyflatnum))
	{	
		goto dceiling;
	}
	//iGlTex=a_iGLTexTranslation[fn_iGetGLFlatTexturef(sectors[s].floorpic)];
	iGlTex=a_iGLTexTranslation[a_stFCPolygonArray[s].iFloorTexture];

	glBindTexture(GL_TEXTURE_2D, texobjs[iGlTex]);

#if defined(GL_HEXEN)
	special=sectors[s].special;
	scrollOffset = leveltime>>1&63;
	switch(special)
	{ // Handle scrolling flats
		case 201: case 202: case 203: // Scroll_North_xxx
			/*ds_source = tempSource+((scrollOffset
				<<(pl->special-201)&63)<<6);*/
			xOffset=0;
			yOffset=((63-scrollOffset)<<(special-201)&63);
			break;
		case 204: case 205: case 206: // Scroll_East_xxx
			/*ds_source = tempSource+((63-scrollOffset)
				<<(pl->special-204)&63);*/
			xOffset=(scrollOffset<<(special-204)&63);
			yOffset=0;
			break;
		case 207: case 208: case 209: // Scroll_South_xxx
			/*ds_source = tempSource+(((63-scrollOffset)
				<<(pl->special-207)&63)<<6);*/
			xOffset=0;
			yOffset=(scrollOffset<<(special-207)&63);
			break;
		case 210: case 211: case 212: // Scroll_West_xxx
			/*ds_source = tempSource+(scrollOffset
				<<(pl->special-210)&63);*/
			xOffset=((63-scrollOffset)<<(special-210)&63);
			yOffset=0;
			break;
		case 213: case 214: case 215: // Scroll_NorthWest_xxx
			/*ds_source = tempSource+(scrollOffset
				<<(pl->special-213)&63)+((scrollOffset
				<<(pl->special-213)&63)<<6);*/
			xOffset=((63-scrollOffset)<<(special-213)&63);
			yOffset=((63-scrollOffset)<<(special-213)&63);
			break;
		case 216: case 217: case 218: // Scroll_NorthEast_xxx
			/*ds_source = tempSource+((63-scrollOffset)
				<<(pl->special-216)&63)+((scrollOffset
				<<(pl->special-216)&63)<<6);*/
			xOffset=(scrollOffset<<(special-216)&63);
			yOffset=((63-scrollOffset)<<(special-216)&63);
			break;
		case 219: case 220: case 221: // Scroll_SouthEast_xxx
			/*ds_source = tempSource+((63-scrollOffset)
				<<(pl->special-219)&63)+(((63-scrollOffset)
				<<(pl->special-219)&63)<<6);*/
			xOffset=(scrollOffset<<(special-219)&63);
			yOffset=(scrollOffset<<(special-219)&63);
			break;
		case 222: case 223: case 224: // Scroll_SouthWest_xxx
			/*ds_source = tempSource+(scrollOffset
				<<(pl->special-222)&63)+(((63-scrollOffset)
				<<(pl->special-222)&63)<<6);*/
			xOffset=((63-scrollOffset)<<(special-222)&63);
			yOffset=(scrollOffset<<(special-222)&63);
			break;
		default:
			xOffset=0;
			yOffset=0;
	}
	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;
#elif ZDOOM_GL
	//xOffset=sectors[s].floor_xoffs;
	xOffset=sectors[s].floor_xoffs/(FRACUNIT / 2);
	yOffset=sectors[s].floor_yoffs/(FRACUNIT / 2);

	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;
#endif

	// MR090699
	glCullFace(GL_FRONT);
	
	if (g_bDynLight.value==1)
	{	
		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				GL_DynamicLight4f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2],
							fRed,fGreen,fBlue,1.0f );
				glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2]+fU,
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1]+fV );
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
	}
	else
	{	GL_StaticLight3f(fRed, fGreen, fBlue);
		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			//glVertexPointer (3, GL_FLOAT, 0, a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices, a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex);
			//glTexCoordPointer (2, GL_FLOAT, 0, a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices, a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV);
			//glDrawArrays(a_stFCPolygonArray[s].p_stVertexArray[i].mode,0,a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices);
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				//glArrayElement(j);
				glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2]+fU,
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1]+fV );
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
	}
dceiling:
	// MR090699
	glCullFace(GL_BACK);

 	//if (sectors[s].ceilingpic==R_FlatNumForName(F_SKY))
	if (a_iGLTexTranslation[a_stFCPolygonArray[s].iCeilingTexture]==fn_iIsFlatTextureRegistered(skyflatnum))
	{	
		//return;
		goto dynlight;
	}

	//xOffset=sectors[s].floor_xoffs;
	xOffset=sectors[s].ceiling_xoffs/(FRACUNIT / 2);
	yOffset=sectors[s].ceiling_yoffs/(FRACUNIT / 2);

	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;

	if (sectors[s].ceilinglightsec)
	{	fLightLevel=((float)(sectors[s].ceilinglightsec->lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=fLightLevel*(float)RPART(sectors[s].ceilingcolormap->color)/255.0f;
		fGreen=fLightLevel*(float)GPART(sectors[s].ceilingcolormap->color)/255.0f;
		fBlue=fLightLevel*(float)BPART(sectors[s].ceilingcolormap->color)/255.0f;
	}
	else
	{	//fLightLevel=((float)(sectors[s].lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=sectors[s].fRed;
		fGreen=sectors[s].fGreen;
		fBlue=sectors[s].fBlue;
	}

	//iGlTex=a_iGLTexTranslation[fn_iGetGLFlatTexturef(sectors[s].ceilingpic)];
	iGlTex=a_iGLTexTranslation[a_stFCPolygonArray[s].iCeilingTexture];
	glBindTexture(GL_TEXTURE_2D, texobjs[iGlTex]);
	
	if (g_bDynLight.value==1)
	{	
		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				GL_DynamicLight4f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2],
							fRed,fGreen,fBlue,1.0f );
				glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2]+fU,
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1]+fV );
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
	}
	else
	{	
		GL_StaticLight3f(fRed, fGreen, fBlue);
		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2]+fU,
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1]+fV );
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
	}
dynlight:
	if (sectors[s].floorcolormap->fade)
		glDisable(GL_FOG);
	if (g_bDynLight.value==2)
		GL_DrawLightForFloorCeiling(s,0);
   //glDisableClientState (GL_VERTEX_ARRAY);
   //glDisableClientState (GL_TEXTURE_COORD_ARRAY);
}

void GL_RenderFloor(int s,float fAlpha)
{ int i,j,iGlTex;
  float fLightLevel;
  int xOffset,yOffset;
  float fU,fV;
  float fRed,fGreen,fBlue;

	if (sectors[s].floorcolormap->fade)
	{ GLfloat fogColor[4];

		glEnable(GL_FOG);
		fogColor[0]=(float)RPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[1]=(float)GPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[2]=(float)BPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[3]=1.0f;
		glFogfv (GL_FOG_COLOR, fogColor);
	}
	if (sectors[s].floorlightsec)
	{	fLightLevel=((float)(sectors[s].floorlightsec->lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=fLightLevel*(float)RPART(sectors[s].floorcolormap->color)/255.0f;
		fGreen=fLightLevel*(float)GPART(sectors[s].floorcolormap->color)/255.0f;
		fBlue=fLightLevel*(float)BPART(sectors[s].floorcolormap->color)/255.0f;
	}
	else
	{	//fLightLevel=((float)(sectors[s].lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=sectors[s].fRed;
		fGreen=sectors[s].fGreen;
		fBlue=sectors[s].fBlue;
	}

	if (sectors[s].floorpic==R_FlatNumForName(F_SKY))
	{	
		return;
	}
	iGlTex=a_iGLTexTranslation[a_stFCPolygonArray[s].iFloorTexture];
	glBindTexture(GL_TEXTURE_2D, texobjs[iGlTex]);

#ifdef GL_HEXEN
	special=sectors[s].special;
	scrollOffset = leveltime>>1&63;
	switch(special)
	{ // Handle scrolling flats
		case 201: case 202: case 203: // Scroll_North_xxx
			/*ds_source = tempSource+((scrollOffset
				<<(pl->special-201)&63)<<6);*/
			xOffset=0;
			yOffset=((63-scrollOffset)<<(special-201)&63);
			break;
		case 204: case 205: case 206: // Scroll_East_xxx
			/*ds_source = tempSource+((63-scrollOffset)
				<<(pl->special-204)&63);*/
			xOffset=(scrollOffset<<(special-204)&63);
			yOffset=0;
			break;
		case 207: case 208: case 209: // Scroll_South_xxx
			/*ds_source = tempSource+(((63-scrollOffset)
				<<(pl->special-207)&63)<<6);*/
			xOffset=0;
			yOffset=(scrollOffset<<(special-207)&63);
			break;
		case 210: case 211: case 212: // Scroll_West_xxx
			/*ds_source = tempSource+(scrollOffset
				<<(pl->special-210)&63);*/
			xOffset=((63-scrollOffset)<<(special-210)&63);
			yOffset=0;
			break;
		case 213: case 214: case 215: // Scroll_NorthWest_xxx
			/*ds_source = tempSource+(scrollOffset
				<<(pl->special-213)&63)+((scrollOffset
				<<(pl->special-213)&63)<<6);*/
			xOffset=((63-scrollOffset)<<(special-213)&63);
			yOffset=((63-scrollOffset)<<(special-213)&63);
			break;
		case 216: case 217: case 218: // Scroll_NorthEast_xxx
			/*ds_source = tempSource+((63-scrollOffset)
				<<(pl->special-216)&63)+((scrollOffset
				<<(pl->special-216)&63)<<6);*/
			xOffset=(scrollOffset<<(special-216)&63);
			yOffset=((63-scrollOffset)<<(special-216)&63);
			break;
		case 219: case 220: case 221: // Scroll_SouthEast_xxx
			/*ds_source = tempSource+((63-scrollOffset)
				<<(pl->special-219)&63)+(((63-scrollOffset)
				<<(pl->special-219)&63)<<6);*/
			xOffset=(scrollOffset<<(special-219)&63);
			yOffset=(scrollOffset<<(special-219)&63);
			break;
		case 222: case 223: case 224: // Scroll_SouthWest_xxx
			xOffset=((63-scrollOffset)<<(special-222)&63);
			yOffset=(scrollOffset<<(special-222)&63);
			break;
		default:
			xOffset=0;
			yOffset=0;
	}
	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;
#elif ZDOOM_GL
	//xOffset=sectors[s].floor_xoffs;
	xOffset=sectors[s].floor_xoffs/(FRACUNIT / 2);
	yOffset=sectors[s].floor_yoffs/(FRACUNIT / 2);

	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;
#endif

	glCullFace(GL_FRONT);
	
	if (g_bDynLight.value==1)
	{	
		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				GL_DynamicLight4f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2],
							fRed,fGreen,fBlue,fAlpha );
				glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2]+fU,
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1]+fV );
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
	}
	else
	{	//GL_StaticLight4f(fLightLevel, fLightLevel, fLightLevel,fAlpha);
		GL_StaticLight4f(fRed, fGreen, fBlue,fAlpha);
		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			//glVertexPointer (3, GL_FLOAT, 0, a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices, a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex);
			//glTexCoordPointer (2, GL_FLOAT, 0, a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices, a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV);
			//glDrawArrays(a_stFCPolygonArray[s].p_stVertexArray[i].mode,0,a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices);
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				//glArrayElement(j);
				glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2]+fU,
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1]+fV );
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+1],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
	}
	if (sectors[s].floorcolormap->fade)
		glDisable(GL_FOG);
	if (g_bDynLight.value>=2)
		GL_DrawLightForFloorCeiling(s,1);

	glCullFace(GL_BACK);
}

void GL_RenderCeiling(int s)
{ int i,j,iGlTex;
  float fLightLevel;
  int xOffset,yOffset;
  float fU,fV;
  float fRed,fGreen,fBlue;

	/*if (s==91)
		printf("prout");*/
	if (sectors[s].floorcolormap->fade)
	{ GLfloat fogColor[4];

		glEnable(GL_FOG);
		fogColor[0]=(float)RPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[1]=(float)GPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[2]=(float)BPART(sectors[s].floorcolormap->fade)/256.0f;
		fogColor[3]=1.0f;
		glFogfv (GL_FOG_COLOR, fogColor);
	}
	if (sectors[s].ceilinglightsec)
	{	fLightLevel=((float)(sectors[s].ceilinglightsec->lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=fLightLevel*(float)RPART(sectors[s].floorcolormap->color)/255.0f;
		fGreen=fLightLevel*(float)GPART(sectors[s].floorcolormap->color)/255.0f;
		fBlue=fLightLevel*(float)BPART(sectors[s].floorcolormap->color)/255.0f;
	}
	else
	{	//fLightLevel=((float)(sectors[s].lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
		fRed=sectors[s].fRed;
		fGreen=sectors[s].fGreen;
		fBlue=sectors[s].fBlue;
	}

#ifdef GL_HEXEN
	special=sectors[s].special;
	scrollOffset = leveltime>>1&63;
	switch(special)
	{ // Handle scrolling flats
		case 201: case 202: case 203: // Scroll_North_xxx
			xOffset=0;
			yOffset=((63-scrollOffset)<<(special-201)&63);
			break;
		case 204: case 205: case 206: // Scroll_East_xxx
			xOffset=(scrollOffset<<(special-204)&63);
			yOffset=0;
			break;
		case 207: case 208: case 209: // Scroll_South_xxx
			xOffset=0;
			yOffset=(scrollOffset<<(special-207)&63);
			break;
		case 210: case 211: case 212: // Scroll_West_xxx
			xOffset=((63-scrollOffset)<<(special-210)&63);
			yOffset=0;
			break;
		case 213: case 214: case 215: // Scroll_NorthWest_xxx
			xOffset=((63-scrollOffset)<<(special-213)&63);
			yOffset=((63-scrollOffset)<<(special-213)&63);
			break;
		case 216: case 217: case 218: // Scroll_NorthEast_xxx
			xOffset=(scrollOffset<<(special-216)&63);
			yOffset=((63-scrollOffset)<<(special-216)&63);
			break;
		case 219: case 220: case 221: // Scroll_SouthEast_xxx
			xOffset=(scrollOffset<<(special-219)&63);
			yOffset=(scrollOffset<<(special-219)&63);
			break;
		case 222: case 223: case 224: // Scroll_SouthWest_xxx
			xOffset=((63-scrollOffset)<<(special-222)&63);
			yOffset=(scrollOffset<<(special-222)&63);
			break;
		default:
			xOffset=0;
			yOffset=0;
	}
	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;
#elif ZDOOM_GL
	//xOffset=sectors[s].floor_xoffs;
	xOffset=sectors[s].ceiling_xoffs/(FRACUNIT / 2);
	yOffset=sectors[s].ceiling_yoffs/(FRACUNIT / 2);

	fU=(float)xOffset/64.0f;
	fV=(float)yOffset/64.0f;
#endif

	glCullFace(GL_BACK);

 	if (sectors[s].ceilingpic==R_FlatNumForName(F_SKY))
	{	
		return;
	}
	iGlTex=a_iGLTexTranslation[a_stFCPolygonArray[s].iCeilingTexture];
	glBindTexture(GL_TEXTURE_2D, texobjs[iGlTex]);
	
	if (g_bDynLight.value==1)
	{	
		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				GL_DynamicLight4f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2],
							fRed,fGreen,fBlue,1.0f );
				glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2]+fU,
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1]+fV );
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
	}
	else
	{	
		GL_StaticLight3f(fRed, fGreen, fBlue);
		for (i=0;i<a_stFCPolygonArray[s].iNbArrays;i++)
		{	
			glBegin(a_stFCPolygonArray[s].p_stVertexArray[i].mode);
			for (j=0;j<a_stFCPolygonArray[s].p_stVertexArray[i].iNbVertices;j++)
			{	
				glTexCoord2f(a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2]+fU,
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fUV[j*2+1]+fV );
				glVertex3f( a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fCeiling[j],
							a_stFCPolygonArray[s].p_stVertexArray[i].p_fVertex[j*3+2] );
			}
			glEnd();
		}		
	}
	if (sectors[s].floorcolormap->fade)
		glDisable(GL_FOG);
	if (g_bDynLight.value>=2)
		GL_DrawLightForFloorCeiling(s,2);
}

#ifdef GL_HEXEN
GLint GL_vRegisterFlatTextureOnTheFly(int iTexNum);
#endif

void GL_vSetFloorTexture(int iSectorID,int texture)
{
	if ((a_stFCPolygonArray[iSectorID].iFloorTexture=fn_iIsFlatTextureRegistered(texture))==-1)
	{	a_stFCPolygonArray[iSectorID].iFloorTexture=GL_vRegisterFlatTextureOnTheFly(texture);
		fn_vCheckIfFlatIsAnimated(texture);
	}
}
void GL_vSetCeilingTexture(int iSectorID,int texture)
{
	//a_stFCPolygonArray[iSectorID].iCeilingTexture=fn_iGetGLFlatTexturef(texture);
	if ((a_stFCPolygonArray[iSectorID].iCeilingTexture=fn_iIsFlatTextureRegistered(texture))==-1)
	{	a_stFCPolygonArray[iSectorID].iCeilingTexture=GL_vRegisterFlatTextureOnTheFly(texture);
		fn_vCheckIfFlatIsAnimated(texture);
	}
}

void fn_vUpdateFloorCeilingTexturesFromSavedGame()
{ int s;

	for (s=0;s<numsectors;s++)
	{
		GL_vSetFloorTexture(s,sectors[s].floorpic);
		GL_vSetCeilingTexture(s,sectors[s].ceilingpic);
	}
}

// ------------------------------------------------------------------
// SKY JHEXEN METHOD (thanks to Jaakko Kernen)
// ------------------------------------------------------------------
int			skyhemispheres;


// The texture offset to be applied to the texture coordinates in SkyVertex().
static float		maxSideAngle = (float) PI/3;
static float		texoff;
static int			rows, columns;	
static float		scale = 10.0f;
static boolean		yflip;

#define SKYHEMI_UPPER		0x1
#define SKYHEMI_LOWER		0x2
#define SKYHEMI_JUST_CAP	0x4	// Just draw the top or bottom cap.

int texw,texh;
// Calculate the vertex and texture coordinates.
static void SkyVertex(int r, int c)
{
	float vx=-(float)viewx/MAP_SCALE;
	float vz=(float)viewy/MAP_SCALE;
	float vy=(float)viewz/MAP_SCALE;
	// The direction must be clockwise.
	float topAngle = c/(float)columns * (float)(2*PI);
	float sideAngle = maxSideAngle * (rows-r)/(float)rows;
	float height = (float)sin(sideAngle);
	float realRadius = scale*(float)cos(sideAngle);
	float x = vx + realRadius*(float)cos(topAngle), 
			z = vz + realRadius*(float)sin(topAngle),
			y = vy + ((!yflip)? scale*height : -scale*height);	

	// And the texture coordinates.
	if(!yflip)	// Flipped Y is for the lower hemisphere.
		glTexCoord2f(4.0f*c/(float)columns + texoff/texw, r/(float)rows*200.0f/256.0f);
	else
		glTexCoord2f(4.0f*c/(float)columns + texoff/texw, (rows-r)/(float)rows*200.0f/256.0f);
	if(r==0) glColor3f(0,0,0); else glColor3f(1,1,1);
	// And finally the vertex.
	glVertex3f(x, y-1.0f, z);	
}

static void CapSideVertex(int r, int c)
{
	float vx=-(float)viewx/MAP_SCALE;
	float vz=(float)viewy/MAP_SCALE;
	float vy=(float)viewz/MAP_SCALE;
	// The direction must be clockwise.
	float topAngle = c/(float)columns * 2.0f*(float)PI;
	float sideAngle = maxSideAngle * (rows-r)/(float)rows;
	float height = (float)sin(sideAngle);
	float realRadius = scale*(float)cos(sideAngle);

	glVertex3f(vx + realRadius*(float)cos(topAngle),
		vy + ((!yflip)? scale*height : -scale*height), 
		vz + realRadius*(float)sin(topAngle));	
}

int skyDetail=5;
// Hemi is Upper or Lower. Zero is not acceptable.
// The current texture is used. SKYHEMI_NO_TOPCAP can be used.
void OGL_RenderSkyHemisphere(int hemi)
{
	int		r, c;

	if(hemi & SKYHEMI_LOWER) yflip = true; else yflip = false;

	// The top row (row 0) is the one that's faded out.
	// There must be at least 4 columns. The preferable number
	// is 4n, where n is 1, 2, 3... There should be at least
	// two rows because the first one is always faded.
	rows = 3;
	columns = 4*skyDetail;	// 4n
	if(hemi & SKYHEMI_JUST_CAP)
	{
		glBindTexture(GL_TEXTURE_2D, 0);
		// Use the appropriate color.
		glColor3f(0,0,0);
		glBegin(GL_TRIANGLE_FAN);
		for(c=0; c<columns; c++) CapSideVertex(0, c);
		glEnd();

		return;
	}

	// The total number of triangles per hemisphere can be calculated
	// as follows: rows * columns * 2 + 2 (for the top cap).
	for(r=0; r<rows; r++)
	{
		glBegin(GL_QUADS);
		for(c=0; c<columns; c++)
		{
			SkyVertex(r, c);
			SkyVertex(r+1, c);
			SkyVertex(r+1, c+1);
			SkyVertex(r, c+1);
		}
		glEnd();
	}
}

static void OGL_DrawSkyhemi(int whichHemi)
{
	GLuint skyname;
	float fU1,fU2,fV1,fV2,fU1Off,fV2Off;
	int iSubTex;

	skyname=fn_iGetGLTexturef(-2,0,0,&fU1,&fU2,&fV1,&fV2,&fU1Off,&fV2Off,&iSubTex);

	// First the top cap.
	OGL_RenderSkyHemisphere(whichHemi | SKYHEMI_JUST_CAP);
	glBindTexture(GL_TEXTURE_2D, texobjs[skyname]);
	texw=p_stGLTextures[skyname].iWidth;
	texh=p_stGLTextures[skyname].iHeight;
	texoff=0;
	// Render the front sky (sky1).
	OGL_RenderSkyHemisphere(whichHemi);
}

void R_RenderSkyHemispheres(int hemis)
{
	// IS there a sky to be rendered?
	if(!hemis) return;

	glPushMatrix();		// MR2012

	// We don't want anything written in the depth buffer, not yet.
	glDepthMask(GL_FALSE);
	glPushAttrib(GL_ENABLE_BIT);
	// Disable culling, all triangles face the viewer.
	//glDisable(GL_CULL_FACE);
	glDisable(GL_FOG);
	// Draw the possibly visible hemispheres.
	if(hemis & SKYHEMI_UPPER) OGL_DrawSkyhemi(SKYHEMI_UPPER);
	if(hemis & SKYHEMI_LOWER) OGL_DrawSkyhemi(SKYHEMI_LOWER);
	// Enable the disabled things.
	glPopAttrib();
	glDepthMask(GL_TRUE);

	glPopMatrix();
}

#endif	// ZDOOM_GL