#ifdef ZDOOM_GL
//#define __DOOMTYPE__

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <gl/gl.h>
#include <GL/glu.h>
#include "gl_struct.h"
#include "gl_priv.h"

#ifndef GL_HEXEN
#include "doomdef.h"
#else
#include "h2def.h"
#endif
#include "r_local.h"

#ifdef DOOM_GL
float MAP_COEFF=100.0f;
//int MAP_COEFF=10;
#else
int MAP_COEFF=200;
//int MAP_COEFF=100;
#endif

extern void R_DrawPlayerSprites (void);
extern GLfloat aspect;
extern int xMapMin,xMapMax,yMapMin,yMapMax,iAltitudeMin,iAltitudeMax;
extern int *iWall;
extern int iSkyList;
extern float fSkyRadius;
extern HDC   ghDC;
extern GLFloorCeiling *a_stFloorCeiling;
extern int startCeilingList,startFloorList;
extern int startWallList;
//extern FloorCeilVertexesArray *a_stFloorVertexesArray;
extern GLFloorCeilingPolygonArray *a_stFCPolygonArray;
extern int iNbSpriteRendered;

extern int yWeapon;

extern drawseg_t	*drawsegs;
#include "v_video.h"
extern	DCanvas *screen;
#define SCREENWIDTH screen->width
#define SCREENHEIGHT screen->height
extern fixed_t CameraX, CameraY, CameraZ;
EXTERN_CVAR (g_bMD2)
EXTERN_CVAR (g_bDynLight)
CVAR (g_cClipQuality, "1", CVAR_ARCHIVE)
CVAR (g_bSkyMethod, "1", CVAR_ARCHIVE)
CVAR (g_iMaxMirrors, "1", CVAR_ARCHIVE)
int STACK_ARGS ConPrintf (const char *format, ...);
#define printf ConPrintf

int *a_iGlDrawFloorCeil;
int iNbSect;
int *a_iGlDrawLine;
int iNbLine;
//H_boolean g_bSmoothSprite=0;
//GLMirror_prop *g_p_stMirrorProp;

void fn_vRenderSector1(int s);
void fn_vRenderSector0(int s);
void (*fn_vRenderSector)(int s);
void fn_vDisplayWall1(int line);
void fn_vDisplayWall0(int line);
void (*fn_vDisplayWall)(int line);

#ifdef RASTER
#include "gl_raster.h"
GLboolean g_bGlobalRaster=FALSE,g_bDisplayRaster=FALSE,g_bLightRaster=FALSE;
glRaster stGlobalRaster(0,1.0f,0.2f,0.5f),stDisplayRaster(25,0.0f,0.0f,1.0f),stWallRaster(50,0.0f,1.0f,0.0f),stFCRaster(75,1.0f,0.0f,0.0f),stSpritesRaster(100,1.0f,1.0f,0.0f);
glRaster stBSPRaster(125,1.0f,0.5f,0.5f);
/*float fps=0.0f;
long lNbFrames=0;
LARGE_INTEGER PerformanceCountStart,PerformanceCountEnd,PerformanceCount;
LARGE_INTEGER PerformanceFrequency;
LARGE_INTEGER LightPerf;	// MR1907*/
GLvoid fn_vDisplayRaster()
{ 
	stGlobalRaster.fn_vStopCounter();
	stDisplayRaster.fn_vStopCounter();
	
	stGlobalRaster.fn_vDisplayRaster();
	stDisplayRaster.fn_vDisplayRaster();
	stWallRaster.fn_vDisplayRaster();
	stFCRaster.fn_vDisplayRaster();
	stSpritesRaster.fn_vDisplayRaster();
	stBSPRaster.fn_vDisplayRaster();
/*	int i;
	static float log2=0.69314718056f;

	#define LENGTH(w,a) (GLfloat) ((w)*(1.0-exp(-(a)*log2)))

	GLfloat t,T,a,w,h,l;
	GLfloat x0=0.0f;
	GLfloat y0=0.0f;

	QueryPerformanceFrequency(&PerformanceFrequency);
	QueryPerformanceCounter(&PerformanceCountEnd);
	if (g_bLightRaster)		// MR1907
		t=((float) LightPerf.LowPart)/((float) PerformanceFrequency.LowPart);
	else
		t=((float) (PerformanceCountEnd.LowPart-PerformanceCountStart.LowPart))/((float) PerformanceFrequency.LowPart);	
	if (t)
	{	fps+=1/t;
		lNbFrames++;
	}
	T=1.0f/60.0f;
	a=t/T;
	w=(GLfloat)SCREENWIDTH;
	h=10.0f;
	l=LENGTH(w,a); //w*(1.0-exp(-a*log(2.0)));

	// projection
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho( (GLdouble) 0, (GLdouble) SCREENWIDTH, (GLdouble) 0, (GLdouble) SCREENHEIGHT, (GLdouble) -1.0, (GLdouble) 1.0 );
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
	glTranslatef(x0, y0, 1.0f);

	glColor4f (1.0f, 0.2f, 0.5f, 0.6f);
	glBegin(GL_QUADS);
	glNormal3f(0.0f,0.0f,1.0f);
	glVertex2f( 0.0f, h);
	glVertex2f( l, h);
	glVertex2f( l, 0.0f);
	glVertex2f( 0.0f, 0.0f);
	glEnd();

	glColor4f (1.0f, 1.0f, 1.0f, 0.7f);
	for (i=0;i<8;i++)
	{
		l=LENGTH(w,(GLfloat) i);
		
		glBegin(GL_QUADS);
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex2f( l-1.0f,0.0f);
		glVertex2f( l+1.0f,0.0f);
		glVertex2f( l+1.0f,h+5);
		glVertex2f( l-1.0f,h+5);
		glEnd();
	}

	glPopMatrix();*/
}
#endif

GLvoid GLSet2DMode()
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho( (GLdouble) 0, (GLdouble) SCREENWIDTH, (GLdouble) 0, (GLdouble) SCREENHEIGHT, (GLdouble) -1.0, (GLdouble) 1.0 );
	// MR0210
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glDisable(GL_DEPTH_TEST);

	glEnable(GL_ALPHA_TEST);
	//MR1807
	//glAlphaFunc(GL_EQUAL,1.0f);
	glAlphaFunc(GL_NOTEQUAL,0.0f);
	// MR2106
	glEnable(GL_TEXTURE_2D);
}

void GL_CheckCoronasPresent(float x,float y,float z,float roll,float pitch,float yaw,player_t *player);

#ifdef GL_HEXEN
extern H_boolean DoubleSky;
extern int iSkyList1,iSkyList2;
extern char GLCurrentSky;
extern fixed_t		viewx, viewy, viewz;
#endif

//#define MAX_MIRRORS 2
GLint g_iNbMirrors;
GLint g_a_iSectMirror[5/*MAX_MIRRORS*/];
GLboolean g_bMirror;
GLboolean g_bDrawMirror;

extern  void R_DrawCrosshair (void);
extern int		BlendR, BlendG, BlendB, BlendA;
void fn_vDisplayWallTransp(int line);
void R_RenderSkyHemispheres(int hemis);
extern  int		gamemap;
void GL_vDrawSkyMD2(int episode);
void GL_RenderCeiling(int s);
GLvoid GL_drawScene(player_t *player)
{ drawseg_t *ds;
  int i;

	//glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	glDisable(GL_BLEND);
	glEnable(GL_CULL_FACE);
	// SKY
	GL_StaticLight3f(1.0f,1.0f,1.0f);
#ifdef DOOM
	//glCallList(iSkyList);
	if (g_bSkyMethod.value==2)
	{	if (gamemode!=commercial)
			g_bSkyMethod.Set(1);
		else
		{	if (gamemap < 12)
				GL_vDrawSkyMD2(0);
			else if (gamemap < 21)
				GL_vDrawSkyMD2(1);
			else
				GL_vDrawSkyMD2(2);
		}
	}
	else
	if (g_bSkyMethod.value==0)
		fn_vDrawSky(1);
	else if (g_bSkyMethod.value==1)
	{ fixed_t OldViewz=viewz;

		if (g_bDrawMirror)
			//viewz=0;
			fn_vDrawSky(1);
		else
		R_RenderSkyHemispheres(1);

		if (g_bDrawMirror)
			viewz=OldViewz;
	}
#else
	if (g_bSkyMethod.value==2)
	{	g_bSkyMethod.Set(1);
	}
	else
	if (g_bSkyMethod.value==0)
		fn_vDrawSky(1);
	else if (g_bSkyMethod.value==1)
	{ fixed_t OldViewz=viewz;

		if (g_bDrawMirror)
			//viewz=0;
			fn_vDrawSky(1);
		else
		R_RenderSkyHemispheres(1);

		if (g_bDrawMirror)
			viewz=OldViewz;
	}
	/*if (DoubleSky)
	{	//glCallList(iSkyList2);
		fn_vDrawSky(2);
		glDepthFunc(GL_LEQUAL);
		glEnable(GL_ALPHA_TEST);
		glAlphaFunc(GL_EQUAL,1);	// MR0109
		//glCallList(iSkyList1);
		fn_vDrawSky(1);
		glDisable(GL_ALPHA_TEST);
	}
	else
	{	//glCallList(iSkyList1);	// a voir (affichage sky2 seul)
		if (player->mo->subsector->sector->special==200)
			fn_vDrawSky(2);
		else
			fn_vDrawSky(GLCurrentSky);
	}*/
#endif
	
	// WALLS
	glDepthFunc(GL_LESS);

#ifdef RASTER
	if (g_bGlobalRaster)
		stWallRaster.fn_vStartCounter();
#endif

	//glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

	for (ds=ds_p-1 ; ds >= drawsegs ; ds--)
	{
#ifndef WALL_ARRAY
		glCallList(iWall[ds->curline->linedef->iLineID]);
#else
		fn_vGlAddLine(ds->curline->linedef->iLineID);
#endif
	}

	i=0;
	while (a_iGlDrawLine[i]>=0)
	{
#ifndef WALL_ARRAY
		glCallList(iWall[a_iGlDrawLine[i++]]);
#else
		fn_vDisplayWall(a_iGlDrawLine[i++]);
#endif
	}
#ifdef RASTER
	if (g_bGlobalRaster)
		stWallRaster.fn_vStopCounter();
#endif
	//glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	
	// FLOORS & CEILINGS
#ifdef RASTER
	if (g_bGlobalRaster)
		stFCRaster.fn_vStartCounter();
#endif
	
	i=0;
	while (a_iGlDrawFloorCeil[i]>=0)
	{
		if (sectors[a_iGlDrawFloorCeil[i]].bIsReflected)	// Mirrors
			GL_RenderCeiling(a_iGlDrawFloorCeil[i++]);
		else
			fn_vRenderSector(a_iGlDrawFloorCeil[i++]);
	}

#ifdef RASTER
	if (g_bGlobalRaster)
		stFCRaster.fn_vStopCounter();
#endif

	// Sprites
#ifdef RASTER
	if (g_bGlobalRaster)
		stSpritesRaster.fn_vStartCounter();
#endif

	//if (g_bSmoothSprite)
	//	glEnable(GL_POLYGON_SMOOTH);	// MR2806
	fn_vDrawSprites(player);
	//if (g_bSmoothSprite)
	//	glDisable(GL_POLYGON_SMOOTH);

	for (ds=ds_p-1 ; ds >= drawsegs ; ds--)
	{
		if (ds->maskedtexturecol)
			fn_vDisplayWallTransp(ds->curline->linedef->iLineID);
	}
	//R_DrawMasked();
	
	glDisable(GL_CULL_FACE);

	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	GL_DrawCoronas(player);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

#ifdef RASTER
	if (g_bGlobalRaster)
		stSpritesRaster.fn_vStopCounter();
#endif
}

extern void GL_RenderFloor(int s,float fAlpha);
void GL_ComputeViewDir(GLfloat xC,GLfloat yC,GLfloat zC,GLfloat yaw,GLfloat pitch);

//#if 0 // MR0109
// Original version
GLvoid GL_drawMirrorsZBuffer(player_t *player,float pitch,float yaw,float x,float y,float z)
{ GLfloat MirrorMatrix[16]= { 1.0f,0.0f,0.0f,0.0f,0.0f,-1.0f,0.0f,0.0f,0.0f,0.0f,1.0f,0.0f,0.0f,0.0f,0.0f,1.0f };
  GLdouble planeEqu[4]= { 0.0, 1.0, 0.0, 0.0 };
  GLfloat matrixMaxZ[16]= { 1.0f,0.0f,0.0f,0.0f,0.0f,1.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.0f,1.0f };
  int i,sector;

	g_bDrawMirror=true;
	for (i=0;i<g_iNbMirrors;i++)
	{
		// Recover mirror coordinates
		sector=g_a_iSectMirror[i];
		MirrorMatrix[13]=2*a_stFCPolygonArray[sector].p_stVertexArray[0].p_fVertex[1];	// floorheight	(why *2 ???)
		planeEqu[3]=-MirrorMatrix[13];

		// Create the mirror mask using Z-buffer
		// useless ? it crashes on 3dfx... (freeze and reboot).
		/*glClearDepth(0.0);
		glClear(GL_DEPTH_BUFFER_BIT);
		glClearDepth(1.0);

		glMatrixMode(GL_PROJECTION);
		glLoadMatrixf(matrixMaxZ);
		gluPerspective(65.0, aspect, 0.01, 2*fSkyRadius);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glRotatef(pitch, 1.0f, 0.0f, 0.0f);
		glRotatef(yaw,   0.0f, 1.0f, 0.0f);
		glTranslatef(x, y, z);

		glDepthFunc(GL_GREATER);
		glColorMask(0,0,0,0);

		GL_RenderFloor(sector,0.0f);

		glDepthFunc(GL_LESS);
		glColorMask(1,1,1,1);*/

		// Draw the reflected scene
		g_bMirror=true;
		glFrontFace(GL_CW);

		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		//gluPerspective(65.0, aspect, 0.01, 2*fSkyRadius);
		gluPerspective((GLfloat)(player->fov-30), 1.6f, 0.01, 2*fSkyRadius);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glRotatef(pitch, 1.0f, 0.0f, 0.0f);
		glRotatef(yaw,   0.0f, 1.0f, 0.0f);
		glTranslatef(x, y, z);

		glMultMatrixf(MirrorMatrix);
		glClipPlane(GL_CLIP_PLANE0, planeEqu);
		//glEnable(GL_CLIP_PLANE0);	// too slow on 3dfx ???

		GL_drawScene(player);

		glDisable(GL_CLIP_PLANE0);
		glFrontFace(GL_CCW);
		g_bMirror=false;

		// Draw the mirror (to fill the Z-buffer)
		glClear(GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glRotatef(pitch, 1.0f, 0.0f, 0.0f);
		glRotatef(yaw,   0.0f, 1.0f, 0.0f);
		glTranslatef(x, y, z);

		//glColorMask(0,0,0,0);
		glEnable(GL_BLEND);
		//glBlendFunc(GL_ONE,GL_ONE);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		GL_RenderFloor(sector,sectors[sector].fReflection);
		glDisable(GL_BLEND);
		//glColorMask(1,1,1,1);
	}
	g_bDrawMirror=false;
}
//#else	// 0
GLvoid GL_drawMirrors0(player_t *player,float pitch,float yaw,float x,float y,float z)
{ GLfloat MirrorMatrix[16]= { 1.0f,0.0f,0.0f,0.0f,0.0f,-1.0f,0.0f,0.0f,0.0f,0.0f,1.0f,0.0f,0.0f,0.0f,0.0f,1.0f };
  GLdouble planeEqu[4]= { 0.0, 1.0, 0.0, 0.0 };
  int i,sector;

	g_bDrawMirror=true;
	
	glEnable( GL_STENCIL_TEST );
    glClearStencil( 0 );  
    glClear( GL_STENCIL_BUFFER_BIT );
	
	for (i=0;i<g_iNbMirrors;i++)
	{
		// Recover mirror coordinates
		sector=g_a_iSectMirror[i];
		MirrorMatrix[13]=2*a_stFCPolygonArray[sector].p_stVertexArray[0].p_fVertex[1];	// floorheight	(why *2 ???)
		planeEqu[3]=-MirrorMatrix[13];

		// Create the mirror mask using stencil buffer
		glEnable( GL_STENCIL_TEST );
		glStencilFunc( GL_NEVER, i+1, i+1 );
		glStencilOp( GL_REPLACE, GL_REPLACE, GL_REPLACE );

		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluPerspective((GLfloat)(player->fov-30), 1.6f, 0.01, 2*fSkyRadius);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glRotatef(pitch, 1.0f, 0.0f, 0.0f);
		glRotatef(yaw,   0.0f, 1.0f, 0.0f);
		glTranslatef(x, y, z);

		GL_RenderFloor(sector,0.0f);

		glStencilFunc( GL_EQUAL, i+1, i+1 );
		glStencilOp( GL_KEEP, GL_KEEP, GL_KEEP );

		// Draw the reflected scene
		g_bMirror=true;
		glFrontFace(GL_CW);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glRotatef(pitch, 1.0f, 0.0f, 0.0f);
		glRotatef(yaw,   0.0f, 1.0f, 0.0f);
		glTranslatef(x, y, z);

		glMultMatrixf(MirrorMatrix);
		glClipPlane(GL_CLIP_PLANE0, planeEqu);
		glEnable(GL_CLIP_PLANE0);

		GL_drawScene(player);

		glDisable(GL_CLIP_PLANE0);
		glFrontFace(GL_CCW);
		g_bMirror=false;

		// Draw the mirror (to fill the Z-buffer)
		glDisable( GL_STENCIL_TEST );

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glRotatef(pitch, 1.0f, 0.0f, 0.0f);
		glRotatef(yaw,   0.0f, 1.0f, 0.0f);
		glTranslatef(x, y, z);

		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		GL_RenderFloor(sector,sectors[sector].fReflection);
		glDisable(GL_BLEND);
	}
	g_bDrawMirror=false;
}

GLvoid GL_drawMirrorsStencil(player_t *player,float pitch,float yaw,float x,float y,float z)
{ GLfloat MirrorMatrix[16]= { 1.0f,0.0f,0.0f,0.0f,0.0f,-1.0f,0.0f,0.0f,0.0f,0.0f,1.0f,0.0f,0.0f,0.0f,0.0f,1.0f };
  GLdouble planeEqu[4]= { 0.0, 1.0, 0.0, 0.0 };
  int i,sector;

	g_bDrawMirror=true;
	
	for (i=0;i<g_iNbMirrors;i++)
	{
		// Recover mirror coordinates
		sector=g_a_iSectMirror[i];
		MirrorMatrix[13]=2*a_stFCPolygonArray[sector].p_stVertexArray[0].p_fVertex[1];	// floorheight	(why *2 ???)
		planeEqu[3]=-a_stFCPolygonArray[sector].p_stVertexArray[0].p_fVertex[1]+0.000005f;

		// Create the mirror mask using stencil buffer

		// 1 - Tag the mirror surface
		glEnable( GL_STENCIL_TEST );
		glStencilOp( GL_KEEP, GL_KEEP, GL_REPLACE );
		glStencilFunc( GL_ALWAYS, 1, ~0 );
		glColorMask(0,0,0,0);

		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluPerspective((GLfloat)(player->fov-30), 1.6f, 0.01, 2*fSkyRadius);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glRotatef(pitch, 1.0f, 0.0f, 0.0f);
		glRotatef(yaw,   0.0f, 1.0f, 0.0f);
		glTranslatef(x, y, z);

		GL_RenderFloor(sector,0.0f);

		// 2 - reset the depth buffer for the mirror's pixels
		glDepthRange(1,1);
		glDepthFunc(GL_ALWAYS);
		glStencilFunc( GL_EQUAL, 1, ~0 );
		glStencilOp( GL_KEEP, GL_KEEP, GL_KEEP );

		GL_RenderFloor(sector,0.0f);

		// 3- Draw the reflected scene
		glDepthFunc(GL_LESS);
		glColorMask(1,1,1,1);
		glDepthRange(0,1);

		g_bMirror=true;
		glFrontFace(GL_CW);

		glPushMatrix();
		glMultMatrixf(MirrorMatrix);
		glClipPlane(GL_CLIP_PLANE0, planeEqu);
		glEnable(GL_CLIP_PLANE0);		// pose problme... (faces qui disparaissent)

		GL_drawScene(player);
		// Afficher les autres mirroirs ici....

		glDisable(GL_CLIP_PLANE0);
		glFrontFace(GL_CCW);
		g_bMirror=false;

		glPopMatrix();

		// 5 - Reset stencil values, update zbuffer & draw mirror texture
		glStencilOp(GL_KEEP,GL_KEEP,GL_ZERO);
		glDepthFunc(GL_ALWAYS);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		GL_RenderFloor(sector,sectors[sector].fReflection);
		glDisable(GL_BLEND);
		glDepthFunc(GL_LESS);
	}
	g_bDrawMirror=false;

	glDisable( GL_STENCIL_TEST );
}
//#endif	// 0

//#if 0
GLvoid GLdrawScene0(player_t *player)
{
    static float roll  = 0.0f;
	static float yaw   = 0.0f;
    static float pitch = 0.0f;
	static float trZ = -5.0f;
	static float trY /*= -0.32f*/;
	static float xCamera,yCamera;
	//float fSkyRadius;
	/*drawseg_t *ds;
	GLfloat lightPos[4];
	GLfloat lightColor[4]={ 1.0f,0.5f,0.0f,1.0f};
	GLfloat lightColorD[4]={ 1.0f,1.0f,0.0f,1.0f};*/

	GLfloat width=(float)SCREENWIDTH,height=(float)SCREENHEIGHT;
	//GLfloat aspect = (GLfloat)width/(GLfloat)height;

#ifdef RASTER
	//if (g_bDisplayRaster)
	if (g_bGlobalRaster)
		stDisplayRaster.fn_vStartCounter();
#endif

	// Player coordinates
	/*if (!(player->cheats & CF_CHASECAM))
	{
	xCamera=(float)viewx/MAP_SCALE;
	yCamera=-(float)viewy/MAP_SCALE;
	trY=(float)player->viewz/MAP_SCALE;
	
	yaw=270.0f-(float)(player->mo->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;
	pitch=(float)(player->mo->pitch>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;
	}
	else*/
	{
		xCamera=(float)viewx/MAP_SCALE;
		yCamera=-(float)viewy/MAP_SCALE;
		trY=(float)viewz/MAP_SCALE;
		
		//yaw=270.0f-(float)(viewangle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;
		yaw=270.0f-(float)(camera->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;
		pitch=(float)(camera->pitch>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;

		// MR2812
		//GL_ComputeViewDir(-xCamera, trY, -yCamera,yaw,pitch);
		GL_ComputeViewDir(-xCamera, trY, -yCamera,-90.0f+(float)(camera->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES,pitch);
	}

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_ALPHA_TEST);

	// Test with select or feedback buffers...
	//GL_CheckCoronasPresent(xCamera, -trY, yCamera,roll,pitch,yaw,player);
	// MR3006: DynLight
//	GL_MoveLight(0,-xCamera,trY,-yCamera);

	// test light
	/*glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	//glPushMatrix();
	//lightPos[0]=xCamera;
	//lightPos[1]=-trY;
	//lightPos[2]=yCamera;
	//lightPos[3]=1.0f;
	lightPos[0]=0.0f;
	lightPos[1]=0.0f;
	lightPos[2]=0.0f;
	lightPos[3]=1.0f;
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightColor);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, lightColor);
	glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 0.1f);	//0.5f
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	//glPopMatrix();
	//glMatrixMode(GL_PROJECTION);*/
	// End test light

	GL_UpdateLights();
	glEnable(GL_TEXTURE_2D);

	/*if (g_bSkyMethod.value==1)
	{
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();

		gluPerspective(65.0, aspect, 0.01, 2*fSkyRadius);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

		glRotatef(roll,  0.0f, 0.0f, 1.0f);
		glRotatef(pitch, 1.0f, 0.0f, 0.0f);
		glRotatef(yaw,   0.0f, 1.0f, 0.0f);
		glTranslatef(xCamera, -trY, yCamera);

		R_RenderSkyHemispheres(1);
	}*/

	// Mirrors....
	if (g_iMaxMirrors.value<=1)
		GL_drawMirrorsZBuffer(player,pitch,yaw,xCamera,-trY,yCamera);
	else
		GL_drawMirrorsStencil(player,pitch,yaw,xCamera,-trY,yCamera);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	//gluPerspective(65.0, aspect, 0.01, 2*fSkyRadius);
	//gluPerspective(70.0, aspect, 0.01, 2*fSkyRadius);
	//gluPerspective(player->fov*0.777f, aspect, 0.01, 2*fSkyRadius);
	gluPerspective((GLfloat)(player->fov-30), 1.6f, 0.01, 2*fSkyRadius);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glRotatef(roll,  0.0f, 0.0f, 1.0f);
	glRotatef(pitch, 1.0f, 0.0f, 0.0f);
	glRotatef(yaw,   0.0f, 1.0f, 0.0f);
	glTranslatef(xCamera, -trY, yCamera);

	GL_drawScene(player);
#if 0
	glEnable(GL_TEXTURE_2D);

	// WALLS
	glEnable(GL_CULL_FACE);
	//glCullFace(GL_FRONT);
	//glFrontFace(GL_CW);

	// MR0906
	glDepthFunc(GL_ALWAYS);
	// SKY
	GL_StaticLight3f(1.0f,1.0f,1.0f);
#ifndef GL_HEXEN
	//glCallList(iSkyList);
	if (g_bSkyMethod.value==2)
	{	if (gamemode!=commercial)
			g_bSkyMethod.Set(1);
		else
		{	if (gamemap < 12)
				GL_vDrawSkyMD2(0);
			else if (gamemap < 21)
				GL_vDrawSkyMD2(1);
			else
				GL_vDrawSkyMD2(2);
		}
	}
	if (g_bSkyMethod.value==0)
		fn_vDrawSky(1);
	else if (g_bSkyMethod.value==1)
	{ fixed_t OldViewz=viewz;

		if (g_bDrawMirror)
			viewz=0;
		R_RenderSkyHemispheres(/*3*/1);
		if (g_bDrawMirror)
			viewz=OldViewz;
	}
#else
	if (DoubleSky)
	{	//glCallList(iSkyList2);
		fn_vDrawSky(2);
		glDepthFunc(GL_LEQUAL);
		glEnable(GL_ALPHA_TEST);
		glAlphaFunc(GL_EQUAL,1);	// MR0109
		//glCallList(iSkyList1);
		fn_vDrawSky(1);
		glDisable(GL_ALPHA_TEST);
	}
	else
	{	//glCallList(iSkyList1);	// a voir (affichage sky2 seul)
		if (player->mo->subsector->sector->special==200)
			fn_vDrawSky(2);
		else
			fn_vDrawSky(GLCurrentSky);
	}
#endif
	glDepthFunc(GL_LESS);
	// End MR0906

//	GL_UpdateLights();

	for (ds=ds_p-1 ; ds >= drawsegs ; ds--)
	{
#ifndef WALL_ARRAY
		glCallList(iWall[ds->curline->linedef->iLineID]);
#else
		fn_vGlAddLine(ds->curline->linedef->iLineID);
#endif
	}
	i=0;
	while (a_iGlDrawLine[i]!=-1)
	{
#ifndef WALL_ARRAY
		glCallList(iWall[a_iGlDrawLine[i++]]);
#else
		fn_vDisplayWall(a_iGlDrawLine[i++]);
#endif
	}
	
	// FLOORS & CEILINGS
	i=0;
	while (a_iGlDrawFloorCeil[i]!=-1)
	{
		//glCallList(a_stFloorCeiling[a_iGlDrawFloorCeil[i]].iFloorCallList);
		fn_vRenderSector(a_iGlDrawFloorCeil[i++]);
		//glCallList(a_stFloorCeiling[a_iGlDrawFloorCeil[i++]].iCeilingCallList);
	}

	// Sprites
	//if (g_bSmoothSprite)
	//	glEnable(GL_POLYGON_SMOOTH);	// MR2806
	fn_vDrawSprites(player);
	//if (g_bSmoothSprite /*|| g_bKeepJunctions.value*/)
	//	glDisable(GL_POLYGON_SMOOTH);

	for (ds=ds_p-1 ; ds >= drawsegs ; ds--)
	{
		if (ds->maskedtexturecol)
			fn_vDisplayWallTransp(ds->curline->linedef->iLineID);
	}
	//R_DrawMasked();
	
	glDisable(GL_CULL_FACE);

	GL_DrawCoronas(player);

	//GLSet2DMode();
#endif	// 0

#ifndef WEAP_DRAWPIX
	if (viewangleoffset <= 1024<<ANGLETOFINESHIFT || viewangleoffset >=
			-1024<<ANGLETOFINESHIFT)
  	{	// don't draw on side views
		glEnable(GL_DEPTH_TEST);
		R_DrawPlayerSprites ();
		GLSet2DMode();
		R_DrawCrosshair ();
		if (BlendA)
		{
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
			glColor4f((float)BlendR/255.0f,(float)BlendG/255.0f,(float)BlendB/255.0f,(float)BlendA/256.0f);
			glDisable(GL_TEXTURE_2D);
			glBegin(GL_QUADS);
				glVertex2f(0.0f,0.0f);
				glVertex2f((float)screen->width,0.0f);
				glVertex2f((float)screen->width,(float)screen->height);
				glVertex2f(0.0f,(float)screen->height);
			glEnd();
			glEnable(GL_TEXTURE_2D);
			glDisable(GL_BLEND);
		}
		glDisable(GL_DEPTH_TEST);
	}
#endif
	glColor3f(1.0f,1.0f,1.0f);

#ifdef WEAP_DRAWPIX
	glDisable(GL_TEXTURE_2D);
	GLdrawWeapons();
#endif
}
//#else	// 0
GLvoid GLdrawScene1(player_t *player)
{
    static float roll  = 0.0f;
	static float yaw   = 0.0f;
    static float pitch = 0.0f;
	static float trZ = -5.0f;
	static float trY;
	static float xCamera,yCamera;

	GLfloat width=(float)SCREENWIDTH,height=(float)SCREENHEIGHT;

#ifdef RASTER
	if (g_bGlobalRaster)
		stDisplayRaster.fn_vStartCounter();
#endif

	// Player coordinates
	xCamera=(float)viewx/MAP_SCALE;
	yCamera=-(float)viewy/MAP_SCALE;
	trY=(float)viewz/MAP_SCALE;
	
	yaw=270.0f-(float)(camera->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;
	pitch=(float)(camera->pitch>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;

	GL_ComputeViewDir(xCamera, -trY, yCamera,yaw,pitch);

	GL_UpdateLights();

	glClearStencil(0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	glEnable(GL_DEPTH_BUFFER_BIT);
	glDisable(GL_STENCIL_TEST);

	glEnable(GL_DEPTH_TEST);
	glDisable(GL_ALPHA_TEST);	
	glEnable(GL_TEXTURE_2D);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	gluPerspective((GLfloat)(player->fov-30), 1.6f, 0.01, 2*fSkyRadius);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glRotatef(roll,  0.0f, 0.0f, 1.0f);
	glRotatef(pitch, 1.0f, 0.0f, 0.0f);
	glRotatef(yaw,   0.0f, 1.0f, 0.0f);
	glTranslatef(xCamera, -trY, yCamera);

	GL_drawScene(player);

	// Mirrors....
	GL_drawMirrorsStencil(player,pitch,yaw,xCamera,-trY,yCamera);

	// Draw weapon, crosshair, etc.
	if (viewangleoffset <= 1024<<ANGLETOFINESHIFT || viewangleoffset >=
			-1024<<ANGLETOFINESHIFT)
  	{	// don't draw on side views
		glEnable(GL_DEPTH_TEST);
		R_DrawPlayerSprites ();
		GLSet2DMode();
		R_DrawCrosshair ();
		if (BlendA)
		{
			if (BlendA>128)	// A voir...
				BlendA=128;
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
			glColor4f((float)BlendR/256.0f,(float)BlendG/256.0f,(float)BlendB/256.0f,(float)BlendA/256.0f);
			glDisable(GL_TEXTURE_2D);
			glBegin(GL_QUADS);
				glVertex2f(0.0f,0.0f);
				glVertex2f((float)screen->width,0.0f);
				glVertex2f((float)screen->width,(float)screen->height);
				glVertex2f(0.0f,(float)screen->height);
			glEnd();
			glEnable(GL_TEXTURE_2D);
			glDisable(GL_BLEND);
		}
		glDisable(GL_DEPTH_TEST);
	}
	glColor3f(1.0f,1.0f,1.0f);
}
//#endif	// 0

GLvoid GLdrawScene(player_t *player)
{
//	if (g_iMaxMirrors.value<=1)
		GLdrawScene0(player);
/*	else
		GLdrawScene1(player);*/
}

void GL_Finish()
{
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_ALPHA_TEST);

	glDisable(GL_TEXTURE_2D);
#ifdef RASTER
	if ((g_bDisplayRaster)||(g_bGlobalRaster)||(g_bLightRaster))	// MR1907
	{	//glFinish();
		fn_vDisplayRaster();
	}
#endif

    glFinish();
	
	SwapBuffers(ghDC);
}

extern bool (*GL_vDrawMD2)(mobj_t *pSpr,float fRed,float fGreen,float fBlue,fixed_t fDist);
extern bool GL_vDrawMD2g(mobj_t *pSpr,float fRed,float fGreen,float fBlue,fixed_t fDist);
extern bool GL_vDrawMD2i(mobj_t *pSpr,float fRed,float fGreen,float fBlue,fixed_t fDist);
extern void GL_fn_vInitLightsBeforeDrawScene();
void fn_vInitglDrawScene()
{ int i;

	iNbSect=0;
	for (i=0;i<numsectors;i++)
		a_iGlDrawFloorCeil[i]=-1;

	iNbLine=0;
	for (i=0;i<numlines;i++)
		a_iGlDrawLine[i]=-1;
	
	iNbSpriteRendered=0;

	yWeapon=0x7fffffff;

//	LightPerf.LowPart=0;

	if (g_bMD2.value==2)
		GL_vDrawMD2=GL_vDrawMD2i;
	else
		GL_vDrawMD2=GL_vDrawMD2g;
	if (g_bDynLight.value==3)
	{	fn_vRenderSector=fn_vRenderSector1;
		fn_vDisplayWall=fn_vDisplayWall1;		
	}
	else
	{	fn_vRenderSector=fn_vRenderSector0;
		fn_vDisplayWall=fn_vDisplayWall0;
	}
	// Mirrors
	g_iNbMirrors=0;
}

void fn_vAddSector(int ucSectorID)
{ int i,j;
  sector_t *sector=sectors+ucSectorID;
  float fLightLevel;

	i=0;
	while (a_iGlDrawFloorCeil[i]!=-1)
	{	if (a_iGlDrawFloorCeil[i]==ucSectorID)
			return;
		if (a_iGlDrawFloorCeil[i]>ucSectorID)
		{	for (j=iNbSect+1;j>i;j--)
			{	a_iGlDrawFloorCeil[j]=a_iGlDrawFloorCeil[j-1];
			}
			a_iGlDrawFloorCeil[j]=a_iGlDrawFloorCeil[j-1];
			a_iGlDrawFloorCeil[i]=ucSectorID;
			iNbSect++;
			break;
		}
		i++;
	}
	if (a_iGlDrawFloorCeil[i]==-1)
	{	a_iGlDrawFloorCeil[i]=ucSectorID;
		iNbSect=i;
	}
	// Mirrors
//#ifdef TEST_MIRROR
	if ((sector->fReflection!=-1.0f)&&(g_iNbMirrors<g_iMaxMirrors.value/*MAX_MIRRORS*/))
	{	
		g_a_iSectMirror[g_iNbMirrors]=ucSectorID;
		sector->bIsReflected=true;
		g_iNbMirrors++;
	}
	else
		sector->bIsReflected=false;
//#endif		
	// MR1203
	// Pre-compute colors
	fLightLevel=((float)(sector->lightlevel+(extralight<<LIGHTSEGSHIFT)))/LIGHTLEVELMAX;
	sector->fRed=fLightLevel*(float)RPART(sector->floorcolormap->color)/255.0f;
	sector->fGreen=fLightLevel*(float)GPART(sector->floorcolormap->color)/255.0f;
	sector->fBlue=fLightLevel*(float)BPART(sector->floorcolormap->color)/255.0f;
}

void fn_vGlAddLine(int iLineID)
{ int i,j;

	i=0;
	while (a_iGlDrawLine[i]!=-1)
	{	if (a_iGlDrawLine[i]==iLineID)
			return;
		if (a_iGlDrawLine[i]>iLineID)
		{	for (j=iNbLine+1;j>i;j--)
			{	a_iGlDrawLine[j]=a_iGlDrawLine[j-1];
			}
			a_iGlDrawLine[j]=a_iGlDrawLine[j-1];
			a_iGlDrawLine[i]=iLineID;
			iNbLine++;
			break;
		}
		i++;
	}
	if (a_iGlDrawLine[i]==-1)
	{	a_iGlDrawLine[i]=iLineID;
		iNbLine=i;
	}
}

void R_glAddFloorCeiling()
{
	return;	// DOOM_GL (cf R_subsector dans r_bsp.c)
	fn_vAddSector(curline->frontsector->iSectorID);
	if (curline->backsector)
		fn_vAddSector(curline->backsector->iSectorID);
}

void fn_vUpdateCeilFloorHeights(int sector,fixed_t floorheight,fixed_t ceilingheight)
{ int i,j;

	for (i=0;i<a_stFCPolygonArray[sector].iNbArrays;i++)
		for (j=0;j<a_stFCPolygonArray[sector].p_stVertexArray[i].iNbVertices;j++)
		{	a_stFCPolygonArray[sector].p_stVertexArray[i].p_fVertex[j*3+1]=(float)floorheight/MAP_SCALE;
			a_stFCPolygonArray[sector].p_stVertexArray[i].p_fCeiling[j]=(float)ceilingheight/MAP_SCALE;
		}
}

#ifdef WALL_ARRAY
extern GLWallPolygonArray *a_stWallPoly;
void fn_vUpdateWallsHeights(int iLineID,fixed_t Prevfloorheight,fixed_t Prevceilingheight,fixed_t floorheight,fixed_t ceilingheight)
{ float fFloor,fCeiling,fPrevFloor,fPrevCeiling;
  int i;

	fFloor=(float)floorheight/MAP_SCALE;
	fCeiling=(float)ceilingheight/MAP_SCALE;
	fPrevFloor=(float)Prevfloorheight/MAP_SCALE;
	fPrevCeiling=(float)Prevceilingheight/MAP_SCALE;

	for (i=0;i<a_stWallPoly[iLineID].iNbQuads;i++)
	{	/*if (a_stWallPoly[iLineID].p_stWallQuad[i].a_fVertex[1]==fPrevFloor)
		{	a_stWallPoly[iLineID].p_stWallQuad[i].a_fVertex[1]=fFloor;
			a_stWallPoly[iLineID].p_stWallQuad[i].a_fUV[1]*=fFloor/fPrevFloor;
			//continue;
		}
		if (a_stWallPoly[iLineID].p_stWallQuad[i].a_fVertex[4]==fPrevCeiling)
		{	a_stWallPoly[iLineID].p_stWallQuad[i].a_fVertex[4]=fCeiling;
			a_stWallPoly[iLineID].p_stWallQuad[i].a_fUV[3]*=fCeiling/fPrevCeiling;
			//continue;
		}*/

		/*if (lines[iLineID]->frontsector==sector)
		{	fCeilingHeight=lines[iLineID]
		
		fV1=a_stWallPoly[iLineID].p_stWallQuad[i].a_fVertex[1];
		fV2=a_stWallPoly[iLineID].p_stWallQuad[i].a_fVertex[3];
		y1=
		if ((a_stWallPoly[iLineID].cWallType==2)&&(lines[iLineID].flags & ML_DONTPEGBOTTOM))
		{
			fV1=fV1Off;
			fV1Off=fV1+(float)(fabs(fCeilingHeight-y1)*(MAP_SCALE>>FRACBITS))/p_stGLTextures[iGLTex].a_stSubTex[iSubTex].iHeight;
			fV2=fV1+(float)(fabs(fCeilingHeight-fFloorHeight)*(MAP_SCALE>>FRACBITS))/p_stGLTextures[iGLTex].a_stSubTex[iSubTex].iHeight;
		}
		else
		if (((a_stWallPoly[iLineID].cWallType==0)&&(lines[iLineID].flags & ML_DONTPEGBOTTOM)&&(!(lines[iLineID].flags & ML_DONTPEGTOP)))||
			((a_stWallPoly[iLineID].cWallType==1)&&(!(lines[iLineID].flags & ML_DONTPEGTOP))))
		{	fV2=fV1Off;
			fV1Off=fV2-((float)(fabs(y2-y1)*(MAP_SCALE>>FRACBITS)))/p_stGLTextures[iGLTex].a_stSubTex[iSubTex].iHeight;
		}
		else
			fV2=fV1Off+((float)(fabs(y2-y1)*(MAP_SCALE>>FRACBITS)))/p_stGLTextures[iGLTex].a_stSubTex[iSubTex].iHeight;*/
	}
}
#endif
int g_iMovingSector;

void fn_vGLUpdateSector(sector_t *sector)
{ int i;

	g_iMovingSector=sector->iSectorID;
	fn_vUpdateCeilFloorHeights(sector->iSectorID,sector->floorheight,sector->ceilingheight);

#ifndef WALL_ARRAY
	for (i=0;i<sector->linecount;i++)
	{	iLine=sector->lines[i]->iLineID;
		glDeleteLists(startWallList+iLine,1);
		fn_vCreateWallsPolygons(iLine);
	}
#else
	for (i=0;i<sector->linecount;i++)
	{	
		fn_vUpdateWallsPolygons(sector->lines[i]->iLineID);
	}
#endif
}

void fn_vGLUpdateSectorFake(sector_t *sector,int floorIni,int ceilingIni)
{ int i;
  sector_t *fSector,*bSector;

	/*glDeleteLists(startFloorList+sector->iSectorID,1);
	glDeleteLists(startCeilingList+sector->iSectorID,1);
	fn_vCreateFloorPolygonsForSector(sector->iSectorID);*/
	//fn_vCreateCeilingPolygonsForSector(sector->iSectorID);

	g_iMovingSector=sector->iSectorID;
	fn_vUpdateCeilFloorHeights(sector->iSectorID,floorIni>sector->floorheight?floorIni:sector->floorheight,
		ceilingIni<sector->ceilingheight?ceilingIni:sector->ceilingheight);

#ifndef WALL_ARRAY
	for (i=0;i<sector->linecount;i++)
	{	iLine=sector->lines[i]->iLineID;
		glDeleteLists(startWallList+iLine,1);
		fn_vCreateWallsPolygons(iLine);
	}
#else
	for (i=0;i<sector->linecount;i++)
	{	
		fSector=sector->lines[i]->frontsector;
		bSector=sector->lines[i]->backsector;
		/*if (sector->lines[i]->frontsector->iSectorID==g_iMovingSector)
			sector->lines[i]->frontsector=sector;
		else*/
		if (sector->lines[i]->backsector && sector->lines[i]->backsector->iSectorID==g_iMovingSector)
		{	sector->lines[i]->backsector=sector;
			fn_vUpdateWallsPolygons(sector->lines[i]->iLineID);
		}
		sector->lines[i]->frontsector=fSector;
		sector->lines[i]->backsector=bSector;
	}
#endif
}

extern GLTexture *p_stGLTextures;
extern int			iNbTexturesInMap,iNbGLTextures;

void GL_ScreenShot(const char *filename)
{
	byte *screenGL = (byte *)malloc (SCREENWIDTH*SCREENHEIGHT*4);
	if (!screenGL)
	{
		Printf (PRINT_HIGH, "No memory for screenshot\n");
	}
	else
	{
		glReadPixels(0,0,SCREENWIDTH,SCREENHEIGHT,GL_RGBA,GL_UNSIGNED_BYTE,screenGL);
		fn_vSaveRAW(filename,screenGL,SCREENWIDTH,SCREENHEIGHT);
		free (screenGL);
	}

//	fn_vSaveRAW("sky.raw",p_stGLTextures[iNbGLTextures-1].p_bRGBBuffer,p_stGLTextures[iNbGLTextures-1].iWidth,p_stGLTextures[iNbGLTextures-1].iHeight);
}

void GL_AddExtraLines(player_t *player)
{ sector_t *sector;
  int i;
	
	//return;	// MR2705
	sector=player->mo->subsector->sector;
	for (i=0;i<sector->linecount;i++)
		fn_vGlAddLine(sector->lines[i]->iLineID);
}

#if 0
void Oldfn_vUpdateCeilFloorHeights(int sector,fixed_t floorheight,fixed_t ceilingheight)
{ int i;

	for (i=0;i<a_stFloorVertexesArray[sector].iNbPoints;i++)
	{	*(a_stFloorVertexesArray[sector].p_fCeiling[i])=(float)ceilingheight/MAP_SCALE;
		*(a_stFloorVertexesArray[sector].p_fFloor[i])=(float)floorheight/MAP_SCALE;
	}
}
#endif	// 0

// MIRRORS init
char C_sz_Levelsini0[255]="levels.ini";
char C_sz_Levelsini[255];
static int iMirror,g_iNbMirrorProps;

typedef struct
{	char szMirror[64];
	int iSector;
	float fReflection;
} tdstLkTable;

static tdstLkTable *LkTable;

int fn_iGetMirrorId(char *szState)
{ int i;

	for (i=0;i<g_iNbMirrorProps;i++)
		if (!strcmp(LkTable[i].szMirror,szState))
			return i;
	return -1;
}

void fn_vReadMirrorsSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer,*p_cBuffer2=NULL;

	strcpy(LkTable[iMirror].szMirror,buffer);
	//LkTable[iMirror].iMirror=iMirror;

	GetPrivateProfileString("MIRRORS",buffer,"-",szBuffer,1024,C_sz_Levelsini);
	if (szBuffer)
	{	p_cBuffer=szBuffer;
		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		//g_p_stMirrorProp[iMirror].iSector=(float)atoi(p_cBuffer);
		LkTable[iMirror].iSector=(int)atoi(p_cBuffer);
		if (!p_cBuffer2)
		{	iMirror++;
			return;
		}
		p_cBuffer=p_cBuffer2+1;
		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		//g_p_stMirrorProp[iMirror].fReflection=(float)atof(p_cBuffer);
		LkTable[iMirror].fReflection=(float)atof(p_cBuffer);
	}
	iMirror++;
}

void GL_vReadLevelsSection(char *szLevelName)
{ char szBuffer[1024],*p_cBuffer,*p_cBuffer2=NULL;

	GetPrivateProfileString(szLevelName,"mirrors","-",szBuffer,1024,C_sz_Levelsini);
	if (szBuffer[0]!='-')
	{	p_cBuffer=szBuffer;
		p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;

		while (1)
		{	iMirror=fn_iGetMirrorId(p_cBuffer);
			if (iMirror==-1)
				printf("Warning: %s mirror undefined\n",szBuffer);
			//sectors[g_p_stMirrorProp[iMirror].iSector].fReflection=g_p_stMirrorProp[iMirror].fReflection;
			sectors[LkTable[iMirror].iSector].fReflection=LkTable[iMirror].fReflection;
			if (!p_cBuffer2)
				break;
			p_cBuffer=p_cBuffer2+1;
			p_cBuffer2=strpbrk(p_cBuffer," ");
			if (p_cBuffer2)
				p_cBuffer2[0]=0;
		}
	}
	/*else
		//sectors[g_p_stMirrorProp[iMirror].iSector].fReflection=-1.0f;
		sectors[LkTable[iMirror].iSector].fReflection=-1.0f;*/
}

void GL_vLoadLevelsIni()
{ char szBuffer[20480],*p_cBuffer;

	GetCurrentDirectory(255,C_sz_Levelsini);
	strcat(C_sz_Levelsini,"\\");
	strcat(C_sz_Levelsini,C_sz_Levelsini0);

	iMirror=0;
	
	GetPrivateProfileString("MIRRORS","Nb","0",szBuffer,1024,C_sz_Levelsini);
	g_iNbMirrorProps=atoi(szBuffer);
	//g_p_stMirrorProp=(GLMirror_prop *)malloc(g_iNbMirrorProps*sizeof(GLMirror_prop));
	LkTable=(tdstLkTable *)malloc(g_iNbMirrorProps*sizeof(tdstLkTable));	

	GetPrivateProfileString("MIRRORS",NULL,"-",szBuffer,1024,C_sz_Levelsini);
	p_cBuffer=szBuffer;
	p_cBuffer+=strlen(p_cBuffer)+1;
	while (*p_cBuffer!=0)
	{
		fn_vReadMirrorsSection(p_cBuffer);
		p_cBuffer+=strlen(p_cBuffer)+1;
	}
}

void GL_vLoadLevelSpecialEffects(char *szLevelName)
{
}
#endif // ZDOOM_GL