#ifdef ZDOOM_GL

//#define __DOOMTYPE__

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <gl/gl.h>
#include <GL/glu.h>
#include "gl_struct.h"
// MD2
#include "md2.h"

#ifndef GL_HEXEN
#include "doomdef.h"
#else
#include "h2def.h"
#endif


#include "d_main.h"
#include "v_video.h"
#include "i_input.h"
extern	DCanvas *screen;
#define SCREENWIDTH screen->width
#define SCREENHEIGHT screen->height
CVAR (g_bMD2, "1", CVAR_ARCHIVE)
CVAR (g_fGLFog, "7.0", CVAR_ARCHIVE)
HWND  win;
extern HWND			Window;
#define printf ConPrintf

extern int *a_iLineArray,*a_iLinePresent;
/*#ifdef RASTER
extern float fps;
extern long lNbFrames;
extern GLboolean g_bGlobalRaster;
#endif*/

extern byte *p_bPalette;

CHAR szAppName[]="ZDoomGL";
HDC   ghDC;
HGLRC ghRC=0;

GLfloat aspect;
int g_GLbits=16;

unsigned char doublebuffer=1;

//extern DEVMODE dvmdOrig;
EXTERN_CVAR (fullscreen);
void GL_vInitMD2Tables();
void GL_vLoadLightIni();
void GL_vLoadLevelsIni();

extern GLboolean g_bPaletteTexture,g_bSpriteOpti,g_bSpriteBilinear;
extern GLboolean g_bGlobalRaster,g_bDisplayRaster;
extern float fScaleSprite;
extern int iMaxSizeBeforeReduction;
extern float fSpriteFilterDistanceCoeff;

extern int windowActive;
extern H_boolean		grabMouse;
extern H_boolean g_bMlook;

// ----------------------------------------------------------------
// Memory (WIN32 code)
// ----------------------------------------------------------------

HANDLE g_hHeap=NULL,g_hHeapFix=NULL;
char g_cMemMode=FIX;

void fn_vSetMemoryMode(char type)
{
	g_cMemMode=type;
}

char fn_cGetMemoryMode()
{
	return g_cMemMode;
}

void fn_vInitMemory(DWORD dwSize)
{
	if (g_cMemMode==FIX)
		g_hHeapFix=HeapCreate(HEAP_GENERATE_EXCEPTIONS,dwSize,0);
	else
		g_hHeap=HeapCreate(HEAP_GENERATE_EXCEPTIONS,dwSize,0);
}

void fn_vDesinitMemory()
{ HANDLE hHeap=(g_cMemMode==FIX?g_hHeapFix:g_hHeap);

	if (!hHeap)
		return;
	HeapDestroy(hHeap);
	if (g_cMemMode==FIX)
		g_hHeapFix=NULL;
	else
		g_hHeap=NULL;
}

LPVOID GLMalloc(DWORD dwNbBytes)	// Heap
{ LPVOID memory;
  HANDLE hHeap=(g_cMemMode==FIX?g_hHeapFix:g_hHeap);

	//memory=HeapAlloc(g_hHeap,HEAP_GENERATE_EXCEPTIONS,dwNbBytes);
	memory=HeapAlloc(hHeap,0,dwNbBytes);

	return memory;
}

LPVOID GLRealloc(LPVOID lpMem,DWORD dwBytes)
{ LPVOID memory;
  HANDLE hHeap=(g_cMemMode==FIX?g_hHeapFix:g_hHeap);

	if (!lpMem)
	{	//printf("Attempt to realloc NULL pointer");
		//return FALSE;
		memory=HeapAlloc(hHeap,0,dwBytes);
		return memory;
	}
	else
	{
		/*if (!HeapValidate(MMHeap,0,NULL))
			TRACE("Connard\n");*/
		//memory=HeapReAlloc(MMHeap,HEAP_GENERATE_EXCEPTIONS,lpMem,dwBytes);
		memory=HeapReAlloc(hHeap,0,lpMem,dwBytes);

		return memory;
	}
}

BOOL GLFree(LPVOID lpMem)
{ HANDLE hHeap=(g_cMemMode==FIX?g_hHeapFix:g_hHeap);
	////return HeapglFree(MMHeap,HEAP_NO_SERIALIZE,lpMem);
	return HeapFree(hHeap,0,lpMem);
}

// ----------------------------------------------------------------
// WIN32 code
// ----------------------------------------------------------------
DEVMODE dvmdOrig, dvmdRequested, dvmdCurrent;
void fn_vChangeScreenResolution(long Width,long Height,int bits)
{
  HDC hdc;

   // Initialize all the DEVMODE structures
   ZeroMemory(&dvmdOrig, sizeof(dvmdOrig));
   dvmdOrig.dmSize = sizeof(DEVMODE);
   dvmdOrig.dmDriverExtra = 0;
   dvmdOrig.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT | 
      DM_BITSPERPEL | DM_DISPLAYFREQUENCY;
	dvmdRequested = dvmdCurrent = dvmdOrig;

   // Get the current screen settings and save them as
   // the "original" settings.
   hdc = GetDC(NULL);  // Screen DC used to get current display settings
	dvmdOrig.dmPelsWidth        = GetDeviceCaps(hdc, HORZRES);
	dvmdOrig.dmPelsHeight       = GetDeviceCaps(hdc, VERTRES);
	dvmdOrig.dmBitsPerPel       = GetDeviceCaps(hdc, BITSPIXEL);
   dvmdOrig.dmDisplayFrequency = GetDeviceCaps(hdc, VREFRESH);
	ReleaseDC(NULL, hdc);

/*   Width=SCREENWIDTH;
   Height=SCREENHEIGHT;*/

   dvmdRequested.dmPelsWidth=Width;
   dvmdRequested.dmPelsHeight=Height;
   dvmdRequested.dmBitsPerPel=bits;	// MR0109
   dvmdRequested.dmDisplayFrequency=60;

   // Attempt to change the screen settings
   if (ChangeDisplaySettings(&dvmdRequested, 0)!= DISP_CHANGE_SUCCESSFUL)
   {
		fprintf(stderr,"Change screen resolution failed\n");
   }
   else
	ShowCursor(FALSE);

   //Sleep(5000);
}

void fn_vRestoreScreenResolution()
{
	HDC hdc;

	// Get the current screen settings
	hdc = GetDC(NULL);  // Screen DC used to get current resolution info
	dvmdCurrent.dmPelsWidth        = GetDeviceCaps(hdc, HORZRES);
	dvmdCurrent.dmPelsHeight       = GetDeviceCaps(hdc, VERTRES);
	dvmdCurrent.dmBitsPerPel       = GetDeviceCaps(hdc, BITSPIXEL);
	dvmdCurrent.dmDisplayFrequency = GetDeviceCaps(hdc, VREFRESH);
	ReleaseDC(NULL, hdc);

   // Windows 95 does not support getting/changing the display frequency
   // So, if we get a display frequency of 0, assume that we requested
   // a display frequency of 0.
   if (dvmdCurrent.dmDisplayFrequency == 0)
      dvmdRequested.dmDisplayFrequency = 0;

   // If the current settings match the requested settings,
   // restore the original settings
   if (memcmp(&dvmdCurrent, &dvmdRequested, sizeof(dvmdCurrent)) == 0) {
		ChangeDisplaySettings(&dvmdOrig, CDS_UPDATEREGISTRY);
	}
}

void GL_SetMode(int width,int height,int bits)
{
/*	SetWindowPos (Window, NULL, 0, 0,
	width + GetSystemMetrics (SM_CXSIZEFRAME) * 2,
	height + GetSystemMetrics (SM_CYSIZEFRAME) * 2 +
			 GetSystemMetrics (SM_CYCAPTION)
	, SWP_DRAWFRAME|
	  SWP_NOACTIVATE|
	  SWP_NOCOPYBITS|
	  SWP_NOMOVE|
	  SWP_NOZORDER);

	glViewport(0, 0, width, height);

	fn_vChangeScreenResolution(width,height);	*/
	DestroyWindow(Window);

	//Sleep(5000);

	I_GL_InitGraphics(width, height,bits);
	GL_vReinitTextures();
	I_InitInput (Window);
}

extern int VPrintf (int printlevel, const char *format, va_list parms);
int STACK_ARGS ConPrintf (const char *format, ...)
{
	va_list argptr;
	int count;

	va_start (argptr, format);
	count=VPrintf(PRINT_HIGH,format,argptr);
	va_end (argptr);

	return count;
}

BOOL bSetupPixelFormat(HDC hdc)
{ 
    PIXELFORMATDESCRIPTOR pfd = {
        sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
        1,                              // version number
        PFD_DRAW_TO_WINDOW |             // support window
        PFD_SUPPORT_OPENGL |          // support OpenGL
        PFD_DOUBLEBUFFER ,           // double buffered
        PFD_TYPE_RGBA,                  // RGBA type
        32,                             // 16-bit color depth	// MR0109
        0, 0, 0, 0, 0, 0,               // color bits ignored
        0,                              // no alpha buffer
        0,                              // shift bit ignored
        0,                              // no accumulation buffer
        0, 0, 0, 0,                     // accum bits ignored
        32,                             // 16-bit z-buffer      
        8,                              // no stencil buffer	// MR0109
        0,                              // no auxiliary buffer
        PFD_MAIN_PLANE,                 // main layer
        0,                              // reserved
        0, 0, 0                         // layer masks ignored
    };
   
    PIXELFORMATDESCRIPTOR *ppfd=&pfd;
    int pixelformat;
	
    ppfd->cColorBits=(BYTE)g_GLbits;
	if (doublebuffer)
      ppfd->dwFlags |= PFD_DOUBLEBUFFER;
		
    if ((pixelformat = ChoosePixelFormat(hdc, ppfd)) == 0) 
	  {
        MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK);
        return FALSE;
    }
	
    if (pfd.dwFlags & PFD_NEED_PALETTE) 
	{
        MessageBox(NULL, "Needs palette", "Error", MB_OK);
        return FALSE;
    }
	
    if (SetPixelFormat(hdc, pixelformat, ppfd) == FALSE) 
	{
        MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK);
        return FALSE;
    }
	
    return TRUE;
}

void OnCreateWindow(HWND hWnd)
{ RECT rect;

	//fullscreen=1;
/*	if (fullscreen)
		fn_vChangeScreenResolution();*/

    ghDC = GetDC(hWnd);
    if (!bSetupPixelFormat(ghDC))
        PostQuitMessage (0);
    ghRC = wglCreateContext(ghDC);
    wglMakeCurrent(ghDC, ghRC);
    GetClientRect(hWnd, &rect);
	//DisplayGLInfo();
	/*fn_vCreateWalls();
	fn_vCreateFloorPolygons();
	fn_vCreateCeilingPolygons();
	fn_vCreateSky();*/
}

void OnCloseWindow(HWND hWnd)
{
	//ChangeDisplaySettings(0, 0);
	fn_vRestoreScreenResolution();
    wglMakeCurrent(NULL, NULL);
	if (ghRC)
        wglDeleteContext(ghRC);
    if (ghDC)
        ReleaseDC(hWnd, ghDC);
    ghRC = 0;
    ghDC = 0;
	
    DestroyWindow (hWnd);
}

void STACK_ARGS M_SaveDefaults (void);
void fn_vGLDeleteAllTextures();
void OnDestroyWindow(HWND hWnd,BOOL bExitGame)
{
    wglMakeCurrent(NULL, NULL);
    if (ghRC)
        wglDeleteContext(ghRC);
    if (ghDC)
        ReleaseDC(hWnd, ghDC);
	
	if (!bExitGame)
		return;

	glFree(a_iLineArray);
	glFree(a_iLinePresent);

	fn_vGLDeleteAllTextures();

	fn_vSetMemoryMode(LEVEL);
	fn_vDesinitMemory();
	fn_vSetMemoryMode(FIX);
	fn_vDesinitMemory();

#ifdef RASTER
/*	if (g_bGlobalRaster)	// MR1907
		printf("Average frames per second: %f\n",fps/lNbFrames);*/
#endif
	//ChangeDisplaySettings(NULL, 0);		// fullscreen off
	fn_vRestoreScreenResolution();

    PostQuitMessage (0);

	exit(0);
}

extern int TranslateKey(unsigned k);

LRESULT CALLBACK WndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

void I_GL_InitGraphics(int width, int height,int bits)
{ static GLboolean bClassRegistered=false;

    //MSG msg;
    WNDCLASSEX wndclass;
    HINSTANCE hInstance=(HINSTANCE) GetModuleHandle(NULL);

	g_GLbits=bits;
		
//	InitGL();
//	return;

	// Register the frame class 
    wndclass.cbSize        = sizeof (wndclass);
    wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wndclass.lpfnWndProc   = (WNDPROC)WndProc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;
    wndclass.hInstance     = hInstance;
    wndclass.hIcon         = LoadIcon (hInstance, szAppName);
    wndclass.hCursor       = LoadCursor (NULL,IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);;
    wndclass.lpszMenuName  = szAppName;
    wndclass.lpszClassName = "ZDoomGLWindowClass";
	wndclass.hIconSm       = 0;
	
    if (!bClassRegistered && RegisterClassEx(&wndclass))
		bClassRegistered=true;
	if (bClassRegistered)
	{
		//fn_vInitMemory(10000000);
	
//#ifndef ZDOOM_GL

		// MR: A REMETTRE !!!
		if (fullscreen.value)
			fn_vChangeScreenResolution(width,height,bits);
		else
			//ChangeDisplaySettings(NULL, 0);		// fullscreen off
			fn_vRestoreScreenResolution();
		win = CreateWindowEx(0,"ZDoomGLWindowClass", szAppName, 
			/*WS_CAPTION | */WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
			0, 0, width, height,
			NULL, NULL, hInstance, NULL);
/*#else
		win = CreateWindowEx(0,"ZDoomGLWindowClass", szAppName, 
			WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
			0, 0, 640, 480,
			NULL, NULL, hInstance, NULL);
#endif*/
		
		// Make sure window was created 
		if (win)
		{ RECT rect;
			// Show and update main window 
			ShowWindow(win, SW_SHOW);
			UpdateWindow(win);
			OnCreateWindow(win);	// MR009

			GetClientRect(win, &rect);

			ClipCursor(&rect);	// MR
		}
		Window=win;
	}

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0);
    glDepthFunc(GL_LEQUAL);
    glShadeModel(GL_SMOOTH);
	
	// enable 
    glEnable(GL_DEPTH_TEST);
	
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	//fn_vInitGLTextures();
	
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	//glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);
	glHint(GL_POLYGON_SMOOTH_HINT, GL_FASTEST);
	//glHint(GL_FOG_HINT, GL_NICEST);
}

extern void fn_vInitSpriteList();
void GL_vInitBeforeLoadLevel()
{
	GL_fn_vInitLights();	// MR0811
	fn_vSetMemoryMode(LEVEL);
	GL_PurgeTextures();
	fn_vDesinitMemory();
	fn_vInitMemory(10000000);
	fn_vInitSpriteList();
}
// ----------------------------------------------------------------
// OpenGL code
// ----------------------------------------------------------------
GLboolean g_b3Dfx=FALSE;
void DisplayGLInfo()
{
	const unsigned char *vendor=glGetString(GL_VENDOR);
	const unsigned char *version=glGetString(GL_VERSION);
	unsigned char str[1]={0};
	const unsigned char *renderer=glGetString(GL_RENDERER);
	const unsigned char *extension=str;
	//int StencilDepth;

	/* can't be called wglCreateContext with 3dfxfl.dll ????? */
	/*if ( (ghRC!=0) && (strstr((const char *) vendor,"3Dfx")!=NULL) )
	{
		renderer=glGetString(GL_RENDERER);
		extension=glGetString(GL_EXTENSIONS);
	}*/
//	DisplayText("OpenGL v%s (%s) %s %s\n",version,vendor,renderer,extension);
	extension=glGetString(GL_EXTENSIONS);
	printf("OpenGL v%s (%s) %s\n",version,vendor,renderer);
	printf("OpenGL Extensions: %s\n",extension);
	if (!strstr((char *)extension,"GL_EXT_paletted_texture"))
	{	g_bPaletteTexture=FALSE;
		printf("OpenGL driver doesn't support paletted textures\n");
	}
	//if (strstr(version,"3Dfx")||strstr(vendor,"3Dfx")||strstr(renderer,"3Dfx"))
	//	g_b3Dfx=TRUE;
	//glGetIntegerv(GL_STENCIL_BITS,&StencilDepth);
}

GLvoid resize( GLsizei width, GLsizei height )
{
    glViewport(0, 0, width, height);
}    

GLvoid initializeGL(GLsizei width, GLsizei height)
{ // MD2

	aspect = (GLfloat)width/(GLfloat)height;

	DisplayGLInfo();
	
	p_bPalette=(unsigned char *)W_CacheLumpName("PLAYPAL", PU_STATIC);		// DOOM_GL
/*	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0);
    glDepthFunc(GL_LEQUAL);
    glShadeModel(GL_SMOOTH);
	
	// enable 
    glEnable(GL_DEPTH_TEST);
	
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	//fn_vInitGLTextures();
	
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	//glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);
	glHint(GL_POLYGON_SMOOTH_HINT, GL_FASTEST);*/

	// MD2 (test)
		GL_vInitMD2Tables();
	// End MD2
	GL_fn_vInitLights();
	GL_vLoadLightIni();

	GL_vLoadLevelsIni();

#ifdef WEAP_DRAWPIX
	fn_vAllocWeaponMemory();
#endif
	// MR3006: DynLight (test)
	//GL_AddLightSource(0,0,0,0,0,1,0,0,10.0f);
	
	// Fog...
//	glEnable(GL_FOG);
	glFogi(GL_FOG_MODE,GL_LINEAR);
	//glFogi(GL_FOG_MODE,GL_EXP);
    { GLfloat fogColor[4] = {0.5, 0.5, 0.5, 1.0};

      glFogfv (GL_FOG_COLOR, fogColor);
    //  glFogf (GL_FOG_DENSITY, 0.3);
      glFogf (GL_FOG_START, 0.5);
      //glFogf (GL_FOG_END, 7.0);
	  glFogf (GL_FOG_END, 100.0f*g_fGLFog.value/(float)MAP_COEFF);
   }
}

extern H_boolean g_bLightEffects;
extern char C_sz_MD2ini0[255];
extern char C_sz_Lightini0[255];
extern char C_sz_Levelsini0[255];
#define M_CheckParm Args.CheckParm
#define myargv Args.GetArg
extern bool g_bNoMD2;

void GL_InitCommandLine()
{ int p;

	if (M_CheckParm("-paltex"))
	{	g_bPaletteTexture=TRUE;
		printf("OpenGL: Paletted textures enabled\n");
	}
	//if (M_CheckParm("-sprfilter"))
	{	g_bSpriteBilinear=TRUE;
		printf("OpenGL: Sprite filtering enabled\n");
	}
	//if (M_CheckParm("-sprcompr"))
	{	g_bSpriteOpti=TRUE;
		printf("OpenGL: Sprite compression enabled\n");
	}
	if ((p=M_CheckParm("-sprscale")))
		fScaleSprite=(float)atof(Args.GetArg(p+1));
	if ((p=M_CheckParm("-sprmaxsurf")))
	{	
		iMaxSizeBeforeReduction=atoi(Args.GetArg(p+1));
		printf("OpenGL: Sprite maximum surface: %d\n",iMaxSizeBeforeReduction);
		printf("OpenGL: Sprite factor scale: %f\n",fScaleSprite);
	}
	if ((p=M_CheckParm("-raster")))
	{	g_bGlobalRaster=TRUE;
	}
	if ((p=M_CheckParm("-dspraster")))
	{	g_bDisplayRaster=TRUE;
	}
	if ((p=M_CheckParm("-3dfx")))
	{	g_b3Dfx=TRUE;
		printf("OpenGL: Max texture size is 256x256\n");
	}

	if (!M_CheckParm("-noeffects"))	// DarkFang
		g_bLightEffects=TRUE;
	else
		g_bLightEffects=FALSE;
	if ((p=M_CheckParm("-md2")))
		strcpy(C_sz_MD2ini0,Args.GetArg(p+1));
	if ((p=M_CheckParm("-lights")))
		strcpy(C_sz_Lightini0,Args.GetArg(p+1));
	if ((p=M_CheckParm("-lvlspec")))
		strcpy(C_sz_Levelsini0,Args.GetArg(p+1));
	if (M_CheckParm("-nomd2"))
	{	g_bNoMD2=TRUE;
		printf("OpenGL: MD2 support removed\n");
	}
	if ((p=M_CheckParm("-scale")))
	{	MAP_COEFF=(float)atof(Args.GetArg(p+1));
		printf("OpenGL: Set map scale to %s\n",Args.GetArg(p+1));
	}
}

#endif // ZDOOM_GL